Package: interp
Type: Package
Title: Interpolation Methods
Version: 1.1-3
Date: 2022-07-12
Authors@R: c(person("Albrecht", "Gebhardt", role = c("aut", "cre", "cph"),
                     email = "albrecht.gebhardt@aau.at"),
            person("Roger", "Bivand", role = c("aut"),
                     email = "Roger.Bivand@nhh.no"),
            person("David", "Sinclair", role = c("aut","cph"),
                     email = "david@s-hull.org",
                     comment = "author of the shull library"))
Maintainer: Albrecht Gebhardt <albrecht.gebhardt@aau.at>
Description: Bivariate data interpolation on regular and irregular
  grids, either linear or using splines are the main part of this
  package.  It is intended to provide FOSS replacement functions for
  the ACM licensed akima::interp and tripack::tri.mesh functions.
  Linear interpolation is implemented in 
  interp::interp(..., method="linear"), this corresponds to the call 
  akima::interp(..., linear=TRUE) which is the default setting and 
  covers most of akima::interp use cases in depending packages.  
  A re-implementation of Akimas irregular grid spline
  interpolation (akima::interp(..., linear=FALSE)) is now also
  available via interp::interp(..., method="akima").
  Estimators for partial derivatives are now also available in 
  interp::locpoly(), these are a prerequisite for the spline interpolation.  
  The basic part is a GPLed triangulation algorithm (sweep hull 
  algorithm by David Sinclair) providing the starting point for the
  irregular grid interpolator. As side effect this algorithm is also
  used to provide replacements for almost all functions of the tripack
  package which also suffers from the same ACM license restrictions.  
  All functions are designed to be backward compatible with their 
  akima / tripack counterparts.
License: GPL (>= 2)
Imports: Rcpp (>= 0.12.9), deldir
Suggests: sp, Deriv, Ryacas, ggplot2, gridExtra, lattice, stringi,
        stringr
Enhances: RcppEigen
LinkingTo: Rcpp, RcppEigen
Depends: R (>= 3.5.0)
NeedsCompilation: yes
Packaged: 2022-07-13 18:57:53 UTC; alge
Author: Albrecht Gebhardt [aut, cre, cph],
  Roger Bivand [aut],
  David Sinclair [aut, cph] (author of the shull library)
Repository: CRAN
Date/Publication: 2022-07-13 20:00:02 UTC

This package contains a FOSS (re)implementation of the interp* functions from
package akima, as well as FOSS version of most functions of package tripack.

These functions are backward compatible in their arguments.

outer.convhull<-function(cx,cy,px,py,FUN,duplicate="remove",...)
  {
    nx<-length(cx)
    ny<-length(cy)
    np<-length(px)
    if(length(py)!=np)
      stop("length of cx and cy differ")
    if (is.character(FUN))
      FUN <- get(FUN, mode = "function", inherits = TRUE)
    p.tr<-tri.mesh(px,py,duplicate)

    ans<-matrix(FUN(matrix(cx, nx, ny),
                    matrix(cy, nx, ny, byrow = TRUE),
                    ...), nx, ny)
    ans[!in.convex.hull(p.tr,matrix(cx, nx, ny),
                        matrix(cy, nx, ny, byrow = TRUE))]<-NA
    ans
  }

### R code from vignette source 'partDeriv.Rnw'

###################################################
### code chunk number 1: init
###################################################
set.seed(42)
options(width=80)
options(continue=" ")
options(SweaveHooks=list(fig=function()
    par(mar=c(5.1, 4.1, 1.1, 2.1))))
library(interp)
library(Deriv)
library(Ryacas)
library(gridExtra)
library(grid)
library(ggplot2)
library(lattice)


###################################################
### code chunk number 2: partDeriv.Rnw:391-392
###################################################
ng <- 11


###################################################
### code chunk number 3: partDeriv.Rnw:397-398
###################################################
knl <- "gaussian"


###################################################
### code chunk number 4: partDeriv.Rnw:405-407
###################################################
bwg <- 0.33  
bwl <- 0.11  


###################################################
### code chunk number 5: partDeriv.Rnw:420-421
###################################################
dg=3


###################################################
### code chunk number 6: partDeriv.Rnw:424-425
###################################################
f <- function(x,y) (x-0.5)*(x-0.2)*(y-0.6)*y*(x-1)


###################################################
### code chunk number 7: helperR2Yacas
###################################################
# helper functions for translation between R and Yacas
fn_y  <- function(f){
    b <- toString(as.expression(body(f)))
    b <- stringr::str_replace_all(b,"cos","Cos")
    b <- stringr::str_replace_all(b,"sin","Sin")
    b <- stringr::str_replace_all(b,"exp","Exp")
    b <- stringr::str_replace_all(b,"log","Log")
    b <- stringr::str_replace_all(b,"sqrt","Sqrt")
    b
}


###################################################
### code chunk number 8: helperYacas2R
###################################################
ys_fn  <- function(f){
    f <- stringr::str_replace_all(f,"Cos","cos")
    f <- stringr::str_replace_all(f,"Sin","sin")
    f <- stringr::str_replace_all(f,"Exp","exp")
    f <- stringr::str_replace_all(f,"Log","log")
    f <- stringr::str_replace_all(f,"Sqrt","sqrt")
    f
}


###################################################
### code chunk number 9: helperDerivs
###################################################
derivs <- function(f,dg){
    ret<-list(f=f,
              f_str=ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),""),")"))))

    if(dg>0){

        ret$fx <- function(x,y){
            myfx <- Deriv(f,"x");
            tmp <- myfx(x,y);
            if(length(tmp)==1)
                return(rep(tmp,length(x)))
            else
                return(tmp)
        }
        ret$fx_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)"),")")))


        ret$fy <- function(x,y){
            myfy <- Deriv(f,"y");
            tmp <- myfy(x,y);
            if(length(tmp)==1)
                return(rep(tmp,length(x)))
            else
                return(tmp)
        }
        ret$fy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(y)"),")")))


        if(dg>1){
            ret$fxy <- function(x,y){
                myfxy <- Deriv(Deriv(f,"y"),"x");
                tmp <- myfxy(x,y);
                if(length(tmp)==1)
                    return(rep(tmp,length(x)))
                else
                    return(tmp)
            }
            ret$fxy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(y)"),")")))

            ret$fxx <- function(x,y){
                myfxx <- Deriv(Deriv(f,"x"),"x");
                tmp <- myfxx(x,y);
                if(length(tmp)==1)
                    return(rep(tmp,length(x)))
                else
                    return(tmp)
            }
            ret$fxx_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(x)"),")")))

            ret$fyy <- function(x,y){
                myfyy <- Deriv(Deriv(f,"y"),"y");
                tmp <- myfyy(x,y);
                if(length(tmp)==1)
                    return(rep(tmp,length(x)))
                else
                    return(tmp)
            }
            ret$fyy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(y)D(y)"),")")))

            if(dg>2){
                ret$fxxy <- function(x,y){
                    myfxxy <- Deriv(Deriv(Deriv(f,"y"),"x"),"x");
                    tmp <- myfxxy(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fxxy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(x)D(y)"),")")))

                ret$fxyy <- function(x,y){
                    myfxyy <- Deriv(Deriv(Deriv(f,"y"),"y"),"x");
                    tmp <- myfxyy(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fxyy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(y)D(y)"),")")))

                ret$fxxx <- function(x,y){
                    myfxxx <- Deriv(Deriv(Deriv(f,"x"),"x"),"x");
                    tmp <- myfxxx(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fxxx_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(x)D(x)"),")")))

                ret$fyyy <- function(x,y){
                    myfyyy <- Deriv(Deriv(Deriv(f,"y"),"y"),"y");
                    tmp <- myfyyy(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fyyy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(y)D(y)D(y)"),")")))
            }
        }
    }
    ret
}


###################################################
### code chunk number 10: partDeriv.Rnw:559-560
###################################################
df <- derivs(f,dg)


###################################################
### code chunk number 11: partDeriv.Rnw:563-566
###################################################
xg <- seq(0,1,length=ng)
yg <- seq(0,1,length=ng)
xyg <- expand.grid(xg,yg)


###################################################
### code chunk number 12: partDeriv.Rnw:568-569
###################################################
af=4


###################################################
### code chunk number 13: partDeriv.Rnw:573-577
###################################################
af <- 4
xfg <- seq(0,1,length=af*ng)
yfg <- seq(0,1,length=af*ng)
xyfg <- expand.grid(xfg,yfg)


###################################################
### code chunk number 14: partDeriv.Rnw:580-584
###################################################
nx <- length(xg)
ny <- length(yg)
xx <- t(matrix(rep(xg,ny),nx,ny))
yy <- matrix(rep(yg,nx),ny,nx)


###################################################
### code chunk number 15: helperGrid
###################################################
# for plots of exact values
fgrid <- function(f,xg,yg,dg){
  ret <- list(f=outer(xg,yg,f))
  df <- derivs(f,dg)
  if(dg>0){
    ret$fx  <- outer(xg,yg,df$fx)
    ret$fy  <- outer(xg,yg,df$fy)
    if(dg>1){
      ret$fxy <- outer(xg,yg,df$fxy)
      ret$fxx <- outer(xg,yg,df$fxx)
      ret$fyy <- outer(xg,yg,df$fyy)
      if(dg>2){
        ret$fxxy <- outer(xg,yg,df$fxxy)
        ret$fxyy <- outer(xg,yg,df$fxyy)
        ret$fxxx <- outer(xg,yg,df$fxxx)
        ret$fyyy <- outer(xg,yg,df$fyyy)
      }
    }
  }
  ret
}


###################################################
### code chunk number 16: partDeriv.Rnw:612-616
###################################################
## data for local regression
fg   <- outer(xg,yg,f)
## data for exact plots on fine grid
ffg <- fgrid(f,xfg,yfg,dg)


###################################################
### code chunk number 17: partDeriv.Rnw:620-624
###################################################
## global bandwidth:
pdg <- interp::locpoly(xg,yg,fg, input="grid", pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel=knl,nx=af*ng,ny=af*ng)
## local bandwidth:
pdl <- interp::locpoly(xg,yg,fg, input="grid", pd="all", h=bwl, solver="QR", degree=dg,kernel=knl,nx=af*ng,ny=af*ng)


###################################################
### code chunk number 18: helperSplit
###################################################
split_str <- function(txt,l){
  start <- seq(1, nchar(txt), l)
  stop <- seq(l, nchar(txt)+l, l)[1:length(start)]
  substring(txt, start, stop)
}


###################################################
### code chunk number 19: helperImage
###################################################
grid2df <- function(x,y,z)
    subset(data.frame(x = rep(x, nrow(z)),
                      y = rep(y, each = ncol(z)),
                      z = as.numeric(z)),
           !is.na(z))

gg1image2contours <- function(x,y,z1,z2,z3,xyg,ttl=""){
    breaks <- pretty(seq(min(z1,na.rm=T),max(z1,na.rm=T),length=11))
    griddf1 <- grid2df(x,y,z1)
    griddf2 <- grid2df(x,y,z2)
    griddf3 <- grid2df(x,y,z3)
    griddf  <- data.frame(x=griddf1$x,y=griddf1$y,z1=griddf1$z,z2=griddf2$z,z3=griddf3$z)
    ggplot(griddf, aes(x=x, y=y, z = z1)) +
        ggtitle(ttl) +
        theme(plot.title = element_text(size = 6, face = "bold"),
              axis.line=element_blank(),axis.text.x=element_blank(),
              axis.text.y=element_blank(),axis.ticks=element_blank(),
              axis.title.x=element_blank(),
              axis.title.y=element_blank(),legend.position="none",
              panel.background=element_blank(),panel.border=element_blank(),panel.grid.major=element_blank(),
              panel.grid.minor=element_blank(),plot.background=element_blank()) +
        geom_contour_filled(breaks=breaks) +
        scale_fill_brewer(palette = "YlOrRd") +
        geom_contour(aes(z=z2),breaks=breaks,color="green",lty="dashed",lwd=0.5) +
        geom_contour(aes(z=z3),breaks=breaks,color="blue",lty="dotted",lwd=0.5) +
        theme(legend.position="none") +
        geom_point(data=xyg, aes(x=Var1,y=Var2), inherit.aes = FALSE,size=1,pch="+")
}


###################################################
### code chunk number 20: helperPrint
###################################################
print_deriv <- function(txt,l,at=42){
    ret<-""
    for(t in txt){
        if(stringi::stri_length(t)<at)
            btxt <- t
        else
            btxt <- split_str(t,at)
        ftxt <- rep(paste(rep(" ",stringi::stri_length(l)),sep="",collapse=""),length(btxt))
        ftxt[1] <- l
        ret <- paste(ret,paste(ftxt,btxt,sep="",collapse = "\n"),sep="",collapse = "\n")
    }
    ret
}
print_f <- function(f,df,dg,offset=0.8){
  lns <- c(print_deriv(df$f_str,"f(x,y) ="))
  if(dg>=1)
    lns <- c(lns,
    print_deriv(df$fx_str,"f_x(x,y) ="),
    print_deriv(df$fy_str,"f_y(x,y) ="))
  if(dg>=2)
    lns <- c(lns,
    print_deriv(df$fxx_str,"f_xx(x,y) ="),
    print_deriv(df$fyy_str,"f_yy(x,y) ="),
    print_deriv(df$fxy_str,"f_xy(x,y) ="))
  if(dg>=3)
    lns <- c(lns,
    print_deriv(df$fxxx_str,"f_xxx(x,y) ="),
    print_deriv(df$fyyy_str,"f_yyy(x,y) ="),
    print_deriv(df$fxxy_str,"f_xxy(x,y) ="),
    print_deriv(df$fxyy_str,"f_xyy(x,y) ="))
  txt <- grid.text(paste(lns,
    collapse="\n"),gp=gpar(fontsize=8),
    x=0,y=offset,draw=FALSE,
    just = c("left","top"))
  txt
}


###################################################
### code chunk number 21: prepare1
###################################################
t1 <- grid.text(paste(c(paste("regular data grid",nx,"x",ny),
  "colors = exaxt values",
  "dashed green = global bw",
  "dotted blue = local bw",
  "crosses: data points"),collapse="\n"),
  gp=gpar(fontsize=8),
  x=0,y=0.8,draw=FALSE,
  just = c("left","top"))

t3 <- grid.text(paste(c(paste("kernel:",knl),
                        paste("global bandwidth",bwg*100,"%"),
                        paste("local bandwidth",bwl*100,"%")),
                      collapse="\n"),
                gp=gpar(fontsize=8),x=0,y=0.8,draw=FALSE,
                just = c("left","top"))



###################################################
### code chunk number 22: partDeriv.Rnw:722-735
###################################################
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xyg,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xyg,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xyg,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xyg,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xyg,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xyg,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xyg,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xyg,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xyg,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xyg,"f_yyy")
## t1 and t3 contain pure texts generated hidden in this Sweave file.
## t2 contains aas much of the symbolic computation output as possible:
t2 <- print_f(f,df,3)


###################################################
### code chunk number 23: plotbicubic
###################################################
lay<-rbind(c( 1, 2, 3, 3),
           c( 4, 5, 3, 3),
           c( 6, 7, 8, 9),
           c(10,11,12,13))
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)


###################################################
### code chunk number 24: partDeriv.Rnw:758-759
###################################################
getOption("SweaveHooks")[["fig"]]()
lay<-rbind(c( 1, 2, 3, 3),
           c( 4, 5, 3, 3),
           c( 6, 7, 8, 9),
           c(10,11,12,13))
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)


###################################################
### code chunk number 25: partDeriv.Rnw:767-771
###################################################
f <- function(x,y) 0.75*exp(-((9*x-2)^2+(9*y-2)^2)/4)+0.75*exp(-((9*x+1)^2)/49-(9*y+1)/10)+0.5*exp(-((9*x-7)^2+(9*y-3)^2)/4)-0.2*exp(-(9*x-4)^2-(9*y-7)^2)
fg  <- outer(xg,yg,f)
ffg <- fgrid(f,xfg,yfg,dg)
df  <- derivs(f,dg)


###################################################
### code chunk number 26: partDeriv.Rnw:774-778
###################################################
## global bw,
pdg <- interp::locpoly(xg,yg,fg, input="grid", pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel=knl,nx=af*ng,ny=af*ng)
## local bw:
pdl <- interp::locpoly(xg,yg,fg, input="grid", pd="all", h=bwl, solver="QR", degree=dg,kernel=knl,nx=af*ng,ny=af*ng)


###################################################
### code chunk number 27: plotfranke1
###################################################
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xyg,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xyg,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xyg,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xyg,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xyg,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xyg,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xyg,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xyg,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xyg,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xyg,"f_yyy")

t2 <- print_f(f,df,1,0.9)

gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix=lay)


###################################################
### code chunk number 28: partDeriv.Rnw:801-802
###################################################
getOption("SweaveHooks")[["fig"]]()
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xyg,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xyg,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xyg,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xyg,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xyg,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xyg,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xyg,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xyg,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xyg,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xyg,"f_yyy")

t2 <- print_f(f,df,1,0.9)

gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix=lay)


###################################################
### code chunk number 29: partDeriv.Rnw:814-815
###################################################
n <- ng*ng


###################################################
### code chunk number 30: partDeriv.Rnw:818-819
###################################################
f <- function(x,y) (x-0.5)*(x-0.2)*(y-0.6)*y*(x-1)


###################################################
### code chunk number 31: partDeriv.Rnw:822-827
###################################################
## random irregular data
x<-runif(n)
y<-runif(n)
xy<-data.frame(Var1=x,Var2=y)
z <- f(x,y)


###################################################
### code chunk number 32: partDeriv.Rnw:830-832
###################################################
ffg <- fgrid(f,xfg,yfg,dg)
df <- derivs(f,dg)


###################################################
### code chunk number 33: partDeriv.Rnw:835-839
###################################################
## global bandwidth
pdg <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel=knl)
## local bandwidth:
pdl <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=bwl, solver="QR", degree=dg,kernel=knl)


###################################################
### code chunk number 34: partDeriv.Rnw:844-865
###################################################
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xy,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xy,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xy,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xy,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xy,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xy,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xy,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xy,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xy,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xy,"f_yyy")

t1 <- grid.text(paste(c(paste("irregular data grid",n,"pts"),
  "colors = exaxt values",
  "dashed green = global bw",
  "dotted blue = local bw",
  "crosses: data points"),collapse="\n"),
  gp=gpar(fontsize=8),
  x=0,y=0.8,draw=FALSE,
  just = c("left","top"))

t2 <- print_f(f,df,3)


###################################################
### code chunk number 35: plotbicubic2
###################################################
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)


###################################################
### code chunk number 36: partDeriv.Rnw:872-873
###################################################
getOption("SweaveHooks")[["fig"]]()
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)


###################################################
### code chunk number 37: partDeriv.Rnw:879-880
###################################################
f <- function(x,y) 0.75*exp(-((9*x-2)^2+(9*y-2)^2)/4)+0.75*exp(-((9*x+1)^2)/49-(9*y+1)/10)+0.5*exp(-((9*x-7)^2+(9*y-3)^2)/4)-0.2*exp(-(9*x-4)^2-(9*y-7)^2)


###################################################
### code chunk number 38: partDeriv.Rnw:882-886
###################################################
z <- f(x,y)
fg  <- outer(xg,yg,f)
ffg <- fgrid(f,xfg,yfg,dg)
df <- derivs(f,dg)


###################################################
### code chunk number 39: partDeriv.Rnw:888-893
###################################################
## global bandwidth:
ttg <- system.time(pdg <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel=knl))

## local bandwidth:
ttl <- system.time(pdl <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=bwl, solver="QR", degree=dg,kernel=knl))


###################################################
### code chunk number 40: partDeriv.Rnw:895-907
###################################################
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xy,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xy,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xy,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xy,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xy,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xy,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xy,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xy,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xy,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xy,"f_yyy")

t2 <- print_f(f,df,1,0.9)


###################################################
### code chunk number 41: plotfranke12
###################################################
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)


###################################################
### code chunk number 42: partDeriv.Rnw:914-915
###################################################
getOption("SweaveHooks")[["fig"]]()
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)


###################################################
### code chunk number 43: partDeriv.Rnw:926-930
###################################################
## global bandwidth:
pdg <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel="uniform")
## local bandwidth:
pdl <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=bwl, solver="QR", degree=dg,kernel="uniform")


###################################################
### code chunk number 44: partDeriv.Rnw:932-951
###################################################
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xy,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xy,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xy,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xy,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xy,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xy,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xy,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xy,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xy,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xy,"f_yyy")

t2 <- print_f(f,df,1,0.9)
t3 <- grid.text(paste(c(paste("kernel:","uniform"),
                        paste("global bandwidth",bwg*100,"%"),
                        paste("local bandwidth",bwl*100,"%")),
                      collapse="\n"),
                gp=gpar(fontsize=8),x=0,y=0.8,draw=FALSE,
                just = c("left","top"))



###################################################
### code chunk number 45: plotfranke12unif
###################################################
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)


###################################################
### code chunk number 46: partDeriv.Rnw:958-959
###################################################
getOption("SweaveHooks")[["fig"]]()
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)


###################################################
### code chunk number 47: partDeriv.Rnw:964-968
###################################################
## global bandwidth:
pdg <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel="epanechnikov")
## local bandwidth:
pdl <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=bwl, solver="QR", degree=dg,kernel="epanechnikov")


###################################################
### code chunk number 48: partDeriv.Rnw:970-988
###################################################
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xy,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xy,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xy,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xy,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xy,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xy,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xy,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xy,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xy,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xy,"f_yyy")

t2 <- print_f(f,df,1,0.9)
t3 <- grid.text(paste(c(paste("kernel:","epanechnikov"),
                        paste("global bandwidth",bwg*100,"%"),
                        paste("local bandwidth",bwl*100,"%")),
                      collapse="\n"),
                gp=gpar(fontsize=8),x=0,y=0.8,draw=FALSE,
                just = c("left","top"))


###################################################
### code chunk number 49: plotfranke12epa
###################################################
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)


###################################################
### code chunk number 50: partDeriv.Rnw:995-996
###################################################
getOption("SweaveHooks")[["fig"]]()
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)


###################################################
### code chunk number 51: partDeriv.Rnw:1011-1013
###################################################
# helper functions for translation between R and Yacas
fn_y  <- function(f){
    b <- toString(as.expression(body(f)))
    b <- stringr::str_replace_all(b,"cos","Cos")
    b <- stringr::str_replace_all(b,"sin","Sin")
    b <- stringr::str_replace_all(b,"exp","Exp")
    b <- stringr::str_replace_all(b,"log","Log")
    b <- stringr::str_replace_all(b,"sqrt","Sqrt")
    b
}
ys_fn  <- function(f){
    f <- stringr::str_replace_all(f,"Cos","cos")
    f <- stringr::str_replace_all(f,"Sin","sin")
    f <- stringr::str_replace_all(f,"Exp","exp")
    f <- stringr::str_replace_all(f,"Log","log")
    f <- stringr::str_replace_all(f,"Sqrt","sqrt")
    f
}


###################################################
### code chunk number 52: partDeriv.Rnw:1020-1021
###################################################
derivs <- function(f,dg){
    ret<-list(f=f,
              f_str=ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),""),")"))))

    if(dg>0){

        ret$fx <- function(x,y){
            myfx <- Deriv(f,"x");
            tmp <- myfx(x,y);
            if(length(tmp)==1)
                return(rep(tmp,length(x)))
            else
                return(tmp)
        }
        ret$fx_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)"),")")))


        ret$fy <- function(x,y){
            myfy <- Deriv(f,"y");
            tmp <- myfy(x,y);
            if(length(tmp)==1)
                return(rep(tmp,length(x)))
            else
                return(tmp)
        }
        ret$fy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(y)"),")")))


        if(dg>1){
            ret$fxy <- function(x,y){
                myfxy <- Deriv(Deriv(f,"y"),"x");
                tmp <- myfxy(x,y);
                if(length(tmp)==1)
                    return(rep(tmp,length(x)))
                else
                    return(tmp)
            }
            ret$fxy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(y)"),")")))

            ret$fxx <- function(x,y){
                myfxx <- Deriv(Deriv(f,"x"),"x");
                tmp <- myfxx(x,y);
                if(length(tmp)==1)
                    return(rep(tmp,length(x)))
                else
                    return(tmp)
            }
            ret$fxx_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(x)"),")")))

            ret$fyy <- function(x,y){
                myfyy <- Deriv(Deriv(f,"y"),"y");
                tmp <- myfyy(x,y);
                if(length(tmp)==1)
                    return(rep(tmp,length(x)))
                else
                    return(tmp)
            }
            ret$fyy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(y)D(y)"),")")))

            if(dg>2){
                ret$fxxy <- function(x,y){
                    myfxxy <- Deriv(Deriv(Deriv(f,"y"),"x"),"x");
                    tmp <- myfxxy(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fxxy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(x)D(y)"),")")))

                ret$fxyy <- function(x,y){
                    myfxyy <- Deriv(Deriv(Deriv(f,"y"),"y"),"x");
                    tmp <- myfxyy(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fxyy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(y)D(y)"),")")))

                ret$fxxx <- function(x,y){
                    myfxxx <- Deriv(Deriv(Deriv(f,"x"),"x"),"x");
                    tmp <- myfxxx(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fxxx_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(x)D(x)"),")")))

                ret$fyyy <- function(x,y){
                    myfyyy <- Deriv(Deriv(Deriv(f,"y"),"y"),"y");
                    tmp <- myfyyy(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fyyy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(y)D(y)D(y)"),")")))
            }
        }
    }
    ret
}


###################################################
### code chunk number 53: partDeriv.Rnw:1027-1028
###################################################
# for plots of exact values
fgrid <- function(f,xg,yg,dg){
  ret <- list(f=outer(xg,yg,f))
  df <- derivs(f,dg)
  if(dg>0){
    ret$fx  <- outer(xg,yg,df$fx)
    ret$fy  <- outer(xg,yg,df$fy)
    if(dg>1){
      ret$fxy <- outer(xg,yg,df$fxy)
      ret$fxx <- outer(xg,yg,df$fxx)
      ret$fyy <- outer(xg,yg,df$fyy)
      if(dg>2){
        ret$fxxy <- outer(xg,yg,df$fxxy)
        ret$fxyy <- outer(xg,yg,df$fxyy)
        ret$fxxx <- outer(xg,yg,df$fxxx)
        ret$fyyy <- outer(xg,yg,df$fyyy)
      }
    }
  }
  ret
}


###################################################
### code chunk number 54: partDeriv.Rnw:1032-1033
###################################################
split_str <- function(txt,l){
  start <- seq(1, nchar(txt), l)
  stop <- seq(l, nchar(txt)+l, l)[1:length(start)]
  substring(txt, start, stop)
}


###################################################
### code chunk number 55: partDeriv.Rnw:1037-1038
###################################################
grid2df <- function(x,y,z)
    subset(data.frame(x = rep(x, nrow(z)),
                      y = rep(y, each = ncol(z)),
                      z = as.numeric(z)),
           !is.na(z))

gg1image2contours <- function(x,y,z1,z2,z3,xyg,ttl=""){
    breaks <- pretty(seq(min(z1,na.rm=T),max(z1,na.rm=T),length=11))
    griddf1 <- grid2df(x,y,z1)
    griddf2 <- grid2df(x,y,z2)
    griddf3 <- grid2df(x,y,z3)
    griddf  <- data.frame(x=griddf1$x,y=griddf1$y,z1=griddf1$z,z2=griddf2$z,z3=griddf3$z)
    ggplot(griddf, aes(x=x, y=y, z = z1)) +
        ggtitle(ttl) +
        theme(plot.title = element_text(size = 6, face = "bold"),
              axis.line=element_blank(),axis.text.x=element_blank(),
              axis.text.y=element_blank(),axis.ticks=element_blank(),
              axis.title.x=element_blank(),
              axis.title.y=element_blank(),legend.position="none",
              panel.background=element_blank(),panel.border=element_blank(),panel.grid.major=element_blank(),
              panel.grid.minor=element_blank(),plot.background=element_blank()) +
        geom_contour_filled(breaks=breaks) +
        scale_fill_brewer(palette = "YlOrRd") +
        geom_contour(aes(z=z2),breaks=breaks,color="green",lty="dashed",lwd=0.5) +
        geom_contour(aes(z=z3),breaks=breaks,color="blue",lty="dotted",lwd=0.5) +
        theme(legend.position="none") +
        geom_point(data=xyg, aes(x=Var1,y=Var2), inherit.aes = FALSE,size=1,pch="+")
}


###################################################
### code chunk number 56: partDeriv.Rnw:1042-1043
###################################################
print_deriv <- function(txt,l,at=42){
    ret<-""
    for(t in txt){
        if(stringi::stri_length(t)<at)
            btxt <- t
        else
            btxt <- split_str(t,at)
        ftxt <- rep(paste(rep(" ",stringi::stri_length(l)),sep="",collapse=""),length(btxt))
        ftxt[1] <- l
        ret <- paste(ret,paste(ftxt,btxt,sep="",collapse = "\n"),sep="",collapse = "\n")
    }
    ret
}
print_f <- function(f,df,dg,offset=0.8){
  lns <- c(print_deriv(df$f_str,"f(x,y) ="))
  if(dg>=1)
    lns <- c(lns,
    print_deriv(df$fx_str,"f_x(x,y) ="),
    print_deriv(df$fy_str,"f_y(x,y) ="))
  if(dg>=2)
    lns <- c(lns,
    print_deriv(df$fxx_str,"f_xx(x,y) ="),
    print_deriv(df$fyy_str,"f_yy(x,y) ="),
    print_deriv(df$fxy_str,"f_xy(x,y) ="))
  if(dg>=3)
    lns <- c(lns,
    print_deriv(df$fxxx_str,"f_xxx(x,y) ="),
    print_deriv(df$fyyy_str,"f_yyy(x,y) ="),
    print_deriv(df$fxxy_str,"f_xxy(x,y) ="),
    print_deriv(df$fxyy_str,"f_xyy(x,y) ="))
  txt <- grid.text(paste(lns,
    collapse="\n"),gp=gpar(fontsize=8),
    x=0,y=offset,draw=FALSE,
    just = c("left","top"))
  txt
}

"plot.voronoi" <- function(x,add=FALSE,
                           xlim=c(min(x$tri$x)-
                                  0.1*diff(range(x$tri$x)),
                                  max(x$tri$x)+
                                  0.1*diff(range(x$tri$x))),
                           ylim=c(min(x$tri$y)-
                                  0.1*diff(range(x$tri$y)),
                                  max(x$tri$y)+
                                  0.1*diff(range(x$tri$y))),
                           all=FALSE,
                           do.points=TRUE,
                           main="Voronoi mosaic",
                           sub=deparse(substitute(x)),
                           isometric=TRUE,
                           ...)
{

    
    if(isometric){
        if(!all(xlim==c(min(x$tri$x)-
                        0.1*diff(range(x$tri$x)),
                        max(x$tri$x)+
                        0.1*diff(range(x$tri$x)))) ||
           !all(ylim==c(min(x$tri$y)-
                        0.1*diff(range(x$tri$y)),
                        max(x$tri$y)+
                        0.1*diff(range(x$tri$y))))){
            warning("isometric option not used as xlim or ylim explicitly given")
        } else {
            if(all){
                xlim=range(x$x)
                ylim=range(x$y)
            } else {
                xlim=range(x$tri$x)
                ylim=range(x$tri$y)
            }
            xrange <- diff(xlim)
            yrange <- diff(ylim)
            maxrange <- max(xrange,yrange)
            midx <- sum(xlim)/2
            midy <- sum(ylim)/2
            xlim <- midx+(xlim-midx)/xrange*maxrange
            ylim <- midy+(ylim-midy)/yrange*maxrange
        }
    } else {
        if(!all(xlim==c(min(x$tri$x)-
                        0.1*diff(range(x$tri$x)),
                        max(x$tri$x)+
                        0.1*diff(range(x$tri$x)))) ||
           !all(ylim==c(min(x$tri$y)-
                        0.1*diff(range(x$tri$y)),
                        max(x$tri$y)+
                        0.1*diff(range(x$tri$y))))){
            warning("all option not used as xlim or ylim explicitly given")
        } else {
            if(all)
            {
                xlim<-c(min(x$x)-0.1*diff(range(x$x)),
                        max(x$x)+0.1*diff(range(x$x)))
                ylim<-c(min(x$y)-0.1*diff(range(x$y)),
                        max(x$y)+0.1*diff(range(x$y)))
            }
        }
    }

    n<-length(x$x)

    if(!add)
    {
        plot.new()
        plot.window(xlim=xlim,ylim=ylim,"")
    }

    if(do.points) points(x$x,x$y,...)

    for (i in 1:n)
    {
        if(x$node[i])
            ## Triangle i has positive area.
            ## Connect circumcircle center of triangle i with neighbours:
        {
            ## Find neighbour triangles
            tns<-sort(c(x$n1[i],x$n2[i],x$n3[i]))
            for(j in 1:3)
            {
                ## Connect (if triangle exists and has positive area).
                if(tns[j]>0)
                {
                    ## simple node
                    if(x$node[tns[j]])
                        lines(c(x$x[i],x$x[tns[j]]),
                              c(x$y[i],x$y[tns[j]]),...)
                }
                else if(tns[j]<0){
                    ## dummy node
                    lines(c(x$x[i],x$dummy.x[-tns[j]]),
                          c(x$y[i],x$dummy.y[-tns[j]]),
                          lty="dashed",...) }
            }
        }
    }
    if(!add)
        title(main = main, sub =sub)
}

aspline <- function(x, y=NULL, xout, n = 50, ties=mean, method="improved", degree=3) {

    if (! method %in% c("original", "improved")) stop(paste("unknown method:", method))

    x <- xy.coords(x, y) # -> (x,y) numeric of same length
    y <- x$y
    x <- x$x
    nx <- length(x)
    if(any(na <- is.na(x) | is.na(y))) {
	ok <- !na
	x <- x[ok]
	y <- y[ok]
	nx <- length(x)
    }
    if (!identical(ties, "ordered")) {
	if (length(ux <- unique(x)) < nx) {
	    if (missing(ties))
		warning("Collapsing to unique x values")
	    y <- as.vector(tapply(y,x,ties))# as.v: drop dim & dimn.
	    x <- sort(ux)
	    nx <- length(x)
	} else {
	    o <- order(x)
	    x <- x[o]
	    y <- y[o]
	}
    }
    if (nx < 1)
	stop("need at least one non-NA value to interpolate (single value yields constant result)!")
    if (missing(xout)) {
	if (n <= 0)
	    stop("aspline requires n >= 1")
	xout <- seq(x[1], x[nx], length = n)
    }
    aSpline(x,y,xout,method,degree)
}

"plot.voronoi.polygons" <- function(x,which,
                                    color=TRUE,
                                    isometric=TRUE,...){
  lx <- length(x)
  if(missing(which))
      which <- 1:lx
  ## exclude border polygons represented as NULL,
  ## intersect ensures working behaviour for eventuelly
  ## given argument "which" (otherwise 1:lx)
  which <-  intersect(which,(1:lx)[!(unlist(lapply(x, is.null)))])
  if(any(is.na(which)))
      stop("border polygons may not be choosen to plot")
  lw <- length(which)
  lmax <- function(x)
    apply(x,2,max)
  lmin <- function(x)
    apply(x,2,min)
  lmean <- function(x)
    apply(x,2,mean)
  xy.max <- apply(sapply(x[which],lmax),1,max)
  xy.min <- apply(sapply(x[which],lmin),1,min)
  xy.mean <- sapply(x[which],lmean)

  xlim=c(xy.min["x"]-
         0.1*(xy.max["x"]-xy.min["x"]),
         xy.max["x"]+
         0.1*(xy.max["x"]-xy.min["x"]))
  ylim=c(xy.min["y"]-
         0.1*(xy.max["y"]-xy.min["y"]),
         xy.max["y"]+
         0.1*(xy.max["y"]-xy.min["y"]))
  if(isometric){
      xrange <- diff(xlim)
      yrange <- diff(ylim)
      maxrange <- max(xrange,yrange)
      midx <- sum(xlim)/2
      midy <- sum(ylim)/2
      xlim <- midx+(xlim-midx)/xrange*maxrange
      ylim <- midy+(ylim-midy)/yrange*maxrange
  }
  plot(x[[which[1]]],type="n",xlim=xlim,
       ylim=ylim,...)
  colors <- heat.colors(lw)
  j <- 0
  for(i in which){
      j <- j+1
      polygon(x[[i]],col=colors[j])
      text(xy.mean[,j]["x"],xy.mean[,j]["y"],i)
  }
  title(paste("plot of",deparse(substitute(x))))
}

neighbours<-function(obj)
{
  if(!inherits(obj,"triSht") && !inherits(obj,"voronoi.mosaic"))
    stop("obj must be of class \"triSht\" or \"voronoi.mosaic\"")
  if(inherits(obj,"triSht")){
      n <- obj$n
      ret<-rep(NULL,obj$n)
  } else if(inherits(obj,"voronoi.mosiac")) {
      n <- obj$tri$n
      ret<-rep(NULL,obj$tri$n)
  }
  
  for (i in 1:n)
  {
      if(inherits(obj,"triSht"))
          ret[i]<-list( sort(c(arcs(obj)[arcs(obj)[,1]==i,2],arcs(obj)[arcs(obj)[,2]==i,1])))
      else if(inherits(obj,"voronoi.mosiac"))
          ret[i]<-list( sort(c(arcs(obj$tri)[arcs(obj$tri)[,1]==i,2],arcs(obj$tri)[arcs(obj$tri)[,2]==i,1])))
  }
  ret
}

circumcircle <- function(x,y=NULL,num.touch=2,plot=FALSE,debug=FALSE)
  {

    circumcircle3 <- function(ch,i,j,...){
      # helper function, given a convex hull ch and two indices i,j of
      # its points find a third point k on ch so that the circumcircle
      # of the triangle i,j,k contains all points of ch and has minimum
      # radius.
      kmin <- NULL
      for(k in (1:npch)[-c(i,j)]){
        # cat(paste("<",i,",",j,",",k,">\n"))
        circ <- circum(ch$x[c(i,j,k)],ch$y[c(i,j,k)])
        if(debug){
          plot(tri.mesh(ch$x[c(i,j,k)],ch$y[c(i,j,k)]),
               add=TRUE,lty="dotted")
          circles(circ$x,circ$y,circ$radius,lty="dotted",col="grey")
        }
        d <- as.matrix(dist(rbind(cbind(circ$x,circ$y),
                                  cbind(ch$x[-c(i,j,k)],
                                        ch$y[-c(i,j,k)]))
                            ))[-1,1]
        if(all(d<=circ$radius)){
          if(is.null(rmin)){
            rmin <- circ$radius
          }            
          if(debug){
            plot(tri.mesh(ch$x[c(i,j,k)],ch$y[c(i,j,k)]),
                 add=TRUE,lty="dotted")
            circles(circ$x,circ$y,circ$radius,lty="dotted")
          }
          if(circ$radius<=rmin){
            rmin <- circ$radius
            kmin <- k
            xmin <- circ$x
            ymin <- circ$y
            rmin <- circ$radius
          }
        }
      }
      if(!is.null(kmin)){
        if(debug)
          plot(tri.mesh(ch$x[c(i,j,k)],
                        ch$y[c(i,j,k)]),
               add=TRUE,col="red")
        xtri <- ch$x[c(i,j,kmin)]
        ytri <- ch$y[c(i,j,kmin)]
      } else {
        xtri <- ytri <- NULL
      }
      list(x=xmin,y=ymin,radius=rmin,xtri=xtri,ytri=ytri)
    }
    
    rmin <- NULL
    xmin <- NULL
    ymin <- NULL

    if(debug) plot <- TRUE

    if(is.null(x))
      stop("argument x missing.")
    if(is.null(y)){
      y<-x$y
      x<-x$x
      if (is.null(x) || is.null(y))
        stop("argument y missing and x contains no $x or $y component.")
    }

    
    n <- length(x)
    tri <- tri.mesh(x,y,duplicate="remove")
    ch <- convex.hull(tri)
    npch <- length(ch$x)

    if(num.touch!=2 & num.touch!=3)
      stop("num.touch can only take values 2 or 3!")

    # get the diameter, it's somewhat tricky to extracrt the index of the
    # maximum out of the return value of dist():
    chdist <- dist(cbind(ch$x,ch$y))
    idmax <- which.max(as.matrix(chdist))[1] # take only the first!
    jmax <- (idmax-1)%/%npch+1
    imax <- (idmax-1)%%npch+1
    if(imax==0) imax <- npch
    
    if(plot){
      # taken partially from eqscplot
      ratio <- 1
      tol <- 0.02
      xlim <- range(x[is.finite(x)])
      ylim <- range(y[is.finite(y)])
      midx <- 0.5 * (xlim[2L] + xlim[1L])
      xlim <- midx + (1 + tol) * 0.5 * c(-1, 1) * (xlim[2L] - xlim[1L])
      midy <- 0.5 * (ylim[2L] + ylim[1L])
      ylim <- midy + (1 + tol) * 0.5 * c(-1, 1) * (ylim[2L] - ylim[1L])
      oldpin <- par("pin")
      xuin <- oxuin <- oldpin[1L]/abs(diff(xlim))
      yuin <- oyuin <- oldpin[2L]/abs(diff(ylim))
      if (yuin > xuin * ratio) 
        yuin <- xuin * ratio
      else xuin <- yuin/ratio
      xlim <- midx + oxuin/xuin * c(-1, 1) * diff(xlim) * 0.5
      ylim <- midy + oyuin/yuin * c(-1, 1) * diff(ylim) * 0.5

      xrange <- diff(range(x))
      plot(x,y,
           xlim=xlim,
           ylim=ylim)
    }
    # (ch$x[imax],ch$y[imax]) and (ch$x[jmax],ch$y[jmax])
    # are the two points where the minumum circle touches if it
    # touches in only two points.

    # check if the circle with center between (ch$x[imax],ch$y[imax]) and
    # (ch$x[jmax],ch$y[jmax]) and diameter = dist((ch$x[imax],ch$y[imax]),
    # (ch$x[jmax],ch$y[jmax])) already contains all points, ...
    xc <- (ch$x[imax]+ch$x[jmax])/2
    yc <- (ch$y[imax]+ch$y[jmax])/2
    radiusc <- sqrt((ch$x[imax]-ch$x[jmax])^2+(ch$y[imax]-ch$y[jmax])^2)/2
    # this radius gives also a lower bound for searching later:
    rlower <- radiusc
    
    if(all(as.matrix(dist(rbind(cbind(xc,yc),
                                cbind(ch$x[-c(imax,jmax)],
                                      ch$y[-c(imax,jmax)]))
                          ))[-1,1]<=radiusc)){
      if(num.touch==2){
        # then if num.touch==2: this is the solution, ...
        if(plot)
          points(ch$x[c(imax,jmax)],ch$y[c(imax,jmax)],col="red",pch="X")
        ret <- list(x=xc,y=yc,radius=radiusc)
        ret3 <- NULL
      } else {
        #      if num.touch==3: find exactly one third point on the hull
        #                       so that the circumcircle of the resulting
        #                       triangle contains all points and is minimal.
        #                       ( circumcircle3() ) ...
        ret3 <- circumcircle3(ch,imax,jmax,plot,debug)
        ret <- list(x=ret3$x,y=ret3$y,radius=ret3$radius)
      }
    } else {
      # else find exactly one third point on the hull so that the circumcircle
      #      of the resulting triangle contains all points and is minimal.
      #      ( circumcircle3() ) ...
      ret3 <- circumcircle3(ch,imax,jmax,plot,debug)
      ret <- list(x=ret3$x,y=ret3$y,radius=ret3$radius)
    }
    # if circumcircle3() doesnt find a third point to imax and jmax
    # (see e.g. circtest2) search all remaining combinations on the convex hull.

    # enclosing rectangle (r1,r2,r3,r4):
    r1 <- c(min(ch$x),min(ch$y))
    r2 <- c(max(ch$x),min(ch$y))
    r3 <- c(max(ch$x),max(ch$y))
    r4 <- c(min(ch$x),max(ch$y))
    # upper bound for the minimum circle radius taken from the
    # enclosing rectangle, used later:
    cupper <- circum(c(r1[1],r2[1],r3[1]),c(r1[2],r2[2],r3[2]))
    rupper <- cupper$radius
    xmin <- cupper$x
    ymin <- cupper$y
    rmin <- rupper
    if(is.null(ret$x)){
      for(i1 in 1:npch){
        for (i2 in (1:npch)[-(1:i1)]){
          for(i3 in (1:npch)[-c(i1,i2)]){
            # skip combinations which contain imax and jmax:
            if(imax %in% c(i1,i2,i3) & jmax %in% c(i1,i2,i3)){
#              cat(paste("skipping: <",i1,",",i2,",",i3,"> contains ",imax,",",jmax,"\n"))
            } else {
#              cat(paste("<",i1,",",i2,",",i3,">\n"))
              circ <- circum(ch$x[c(i1,i2,i3)],ch$y[c(i1,i2,i3)])
              # use bounds to avoid calling dist() with no need:
              if(circ$radius<=rupper & circ$radius>=rlower){
                d <- as.matrix(dist(rbind(cbind(circ$x,circ$y),
                                          cbind(ch$x[-c(i1,i2,i3)],
                                                ch$y[-c(i1,i2,i3)]))
                                    ))[-1,1]
                if(all(d<=circ$radius)){
                  if(circ$radius<=rmin){
                    if(debug){
                      plot(tri.mesh(ch$x[c(i1,i2,i3)],ch$y[c(i1,i2,i3)]),
                           add=TRUE,lty="dotted")
                      circles(circ$x,circ$y,circ$radius,lty="dotted")
                    }
                    rmin <- circ$radius
                    i1min <- i1
                    i2min <- i2
                    i3min <- i3
                    xmin <- circ$x
                    ymin <- circ$y
                    rmin <- circ$radius
                  }
                }
              }
            }
          }
        }
      }
      if(debug)
        plot(tri.mesh(ch$x[c(i1min,i2min,i3min)],
                      ch$y[c(i1min,i2min,i3min)]),
             add=TRUE,col="blue")
      if(plot)
        points(ch$x[c(i1min,i2min,i3min)],
               ch$y[c(i1min,i2min,i3min)],col="red",pch="X")
      ret <- list(x=xmin,y=ymin,radius=rmin)
    } else {
      if(plot & !is.null(ret3))
        points(ret3$xtri,
               ret3$ytri,col="red",pch="X")
    }
    if(plot)
      circles(ret$x,ret$y,ret$radius,col="red")
    ret
  }
    


    

summary.voronoi<-function(object,...)
{
  if(!inherits(object,"voronoi"))
    stop("object must be of class \"voronoi\"")
  ans<-list(nn=length(object$x),
            nd=length(object$dummy.x),
            call=object$call)
  class(ans)<-"summary.voronoi"
  ans
}

tri.find<-function(tri.obj,x,y)
{
  if(!inherits(tri.obj,"triSht"))
      stop("tri.obj must be of class \"triSht\"")

  ans <- triFind(tri.obj$nt, tri.obj$x, tri.obj$y,
                 tri.obj$trlist[,"i1"], tri.obj$trlist[,"i2"], tri.obj$trlist[,"i3"],
                 x,y)

  ans
}

# from Denis White <white.denis@epamail.epa.gov> :

voronoi.polygons <- function (voronoi.obj)
{
  nsites <- length(voronoi.obj$tri$x)
  polys <- list()
  j <- 0
  for (i in 1:nsites) {
    vs <- voronoi.findvertices(i, voronoi.obj)
    if (length(vs) > 0) {
        polys[[i]] <- cbind (x=voronoi.obj$x[vs],
                             y=voronoi.obj$y[vs])
    } else {
        polys[[i]] <- NULL
    }
  }
  class(polys)<-"voronoi.polygons"
  polys
}

voronoi.findrejectsites <- function(voronoi.obj, xmin, xmax, ymin, ymax)
{
  ## Given a voronoi object, find the reject sites, i.e. those sites
  ## with one of their vertices outside the bounded rectangle given by
  ## (xmin,ymin) and (xm ax,ymax).
  ## Return a vector `rejects': site N is a reject iff rejects[i] is T.
  nsites <- length(voronoi.obj$tri$x)
  rejects <- logical(nsites)
  outsiders <- ((voronoi.obj$x > xmax) | (voronoi.obj$x < xmin) |
                (voronoi.obj$y > ymax) | (voronoi.obj$y < ymin))


  ## In the list below, each site could be rejected more than once.
  rejects[c(voronoi.obj$p1[outsiders], voronoi.obj$p2[outsiders], voronoi.obj$p3[outsiders])] <- TRUE;

  rejects
}

print.triSht<-function(x,...)
{
  if(!inherits(x,"triSht"))
    stop("x must be of class \"triSht\"")
  cat("Delauney triangulation, node and triangle indices:\n")
  cat("triangle: nodes (a,b,c), neighbour triangles [i,j,k] \n")
  for (i in 1:x$nt)
    {
      cat(i,": (",x$trlist[i,"i1"],",",x$trlist[i,"i2"],",",x$trlist[i,"i3"],"), [",x$trlist[i,"j1"],",",x$trlist[i,"j2"],",",x$trlist[i,"j3"],"]\n",sep="")
  }
  cat("boundary nodes: ", x$chull, "\n", sep=" ")
}

print.voronoi<-function(x,...)
{
  if(!inherits(x,"voronoi"))
    stop("x must be of class \"voronoi\"")
  cat("voronoi mosaic:\n")
  cat("nodes: (x,y): neighbours (<0: dummy node)\n")
  for (i in 1:length(x$x))
    {
      if(x$node[i]){
        cat(i,": (",x$x[i],",",x$y[i],")",sep="")
        cat(":",x$n1[i],x$n2[i],x$n3[i],"\n",sep=" ")
      }
    }
  cat("dummy nodes: (x,y)\n")
  for (i in 1:length(x$dummy.x))
    {
      cat(i,": (",x$dummy.x[i],",",x$dummy.y[i],")\n",sep="")
    }

}

##' From an akima() result, produce a 3 column matrix "cbind(x, y, z)"
##'
##' @title From interp() Result, Produce 3-column Matrix
##' @param al a \code{\link{list}} as produced from interp().
##' @param data.frame logical indicating if result should be data.frame or matrix.
##' @return a matrix (or data.frame) with three (3) columns, called "x", "y", "z".
##' @author Martin Maechler, Jan.18, 2013
interp2xyz <- function(al, data.frame = FALSE) {
    stopifnot(is.list(al), identical(names(al), c("x","y","z")))
    xy <- expand.grid(x = al[["x"]], y = al[["y"]], KEEP.OUT.ATTRS=FALSE)
    cbind(if(!data.frame) data.matrix(xy) else xy,
          z = as.vector(al[["z"]]))
}

summary.triSht<-function(object, ...)
{
  if(!inherits(object,"triSht"))
    stop("object must be of class \"triSht\"")

  ans<-list(n=object$n,
            na=object$narcs,
            nb=object$nchull,
            nt=object$nt,
            call=object$call)
  class(ans)<-"summary.triSht"
  ans
}

      SUBROUTINE BILIIP(X0,Y0,Z0,N0,X,Y,Z,NX,NY,IER)

C     A. Gebhardt <albrecht.gebhardt@aau.at>, Dec. 2016
C
C     Please note that this file is not associated with Akimas
C     interpolation code (and so not under ACM license, so it can be
C     reused without restriction), it is included here just for 
C     comparison with Akimas ACM 760 algorithm for regular gridded
C     data.
C
C     It implements bilinear (in contrast to bicubic as in ACM 760)
C     interpolation, resulting in a continious but not differentiable
C     (at grid lines) surface.

      IMPLICIT NONE
      INTEGER NX,NY,N0,IER
      DOUBLE PRECISION X0(*),Y0(*),Z0(*),X(*),Y(*),Z(NX,*)

      DOUBLE PRECISION XT,YT,X1,Y1
      INTEGER K,I,J

      IER=0
      DO 10 K=1,N0
         DO 20 I=1,NX-1
            DO 30 J=1,NY-1
               IF ((X(I).LE.X0(K)).AND.(X0(K).LE.X(I+1))) THEN
                  IF ((Y(J).LE.Y0(K)).AND.(Y0(K).LE.Y(J+1))) THEN
                     X1=X(I+1)-X(I)
                     Y1=Y(J+1)-Y(J)
                     IF ((X1.EQ.0.0D0).OR.(Y1.EQ.0.0D0)) THEN
                       IER=1
                       RETURN
                     ENDIF
                     XT=(X0(K)-X(I))/X1
                     YT=(Y0(K)-Y(J))/Y1
                     Z0(K)=(1.0D0-YT)*(1.0D0-XT)*Z(I,J)+
     +                    (1.0D0-YT)*XT*Z(I+1,J)+
     +                    YT*(1.0D0-XT)*Z(I,J+1)+
     +                    YT*XT*Z(I+1,J+1)
                  END IF
               END IF
 30         CONTINUE
 20      CONTINUE
 10   CONTINUE

      RETURN
      END

## cyclic rotate a vector moving its minimum element first
## assumption: elements are unique
minrot =function(x){
    n=length(x)
    mpos = which.min(x)
    c(1:n,1:n)[mpos:(mpos+n-1)]
}

## operates on trlist structure from tri.mesh
## rotates first 3 columns so that minimum element is in first row
## row 4 to 6 and 7 to 9 are rotatetd accoringly (but later ignored)
## then create all three cyclic permutations of the first three elements
## repeatedly and add those two rows
minsort = function(t){
    ret<-NULL
    for(i in 1:dim(t)[1]){
        mr =minrot(t[i,1:3])
        ret=rbind(ret,t[i,c(mr,mr+3,mr+6)])
        nr = c(mr[2:3],mr[1])
        ret=rbind(ret,t[i,c(nr,nr+3,nr+6)])
        nr = c(nr[2:3],nr[1])
        ret=rbind(ret,t[i,c(nr,nr+3,nr+6)])
    }
    ret
}


triSht2tri = function(t.triSht){
    ms = minsort(t.triSht$trlist)
    ## this will contain a list of adjacency vectors for each
    ## triangulation node:
    msl=NULL
    ## number of data points
    nd=t.triSht$n

    for(i in 1:nd){
        ## get columns 2 and 3 matching "i" in column 1
        tmp=ms[ms[,1]==i,2:3]
        ## this can be a matrix or a vector, handle it appropriately
        if(is.vector(tmp))
            msl[[i]]=c(tmp)
        else{
            ## collect the adjacencies in lst
            lst=NULL
            ## sometimes start end end nodes are unique and only once found,
            ## sometimes twice, if twice remove one row to get
            ## also unique start and end nodes
            ctmp=table(tmp)
            if(any(ctmp==1)){
                ## nothing
            } else {
                ## each time we remove one row from tmp
                ## we have to ensure it stays a matrix
                ## even in the case of only one row, this
                ## is the reason for all the odim... stuff here and below
                odim=dim(tmp)
                tmp=tmp[-1,]
                dim(tmp)=c(odim[1]-1,odim[2])
            }
            ## start/stop nodes
            st=as.integer(names(ctmp)[ctmp==1])
            ## start node
            p1=which(tmp[,1]==st[1] | tmp[,1]==st[2])
            ## stop node
            p2=which(tmp[,2]==st[1] | tmp[,2]==st[2])
            ## take the first pair if adjencent neighbour nodes
            lst=tmp[1,]
            ## remove them from tmp
            odim=dim(tmp)
            tmp=tmp[-1,]
            dim(tmp)=c(odim[1]-1,odim[2])
            llst=length(lst)
            repeat{
                ## until tmp is empty
                if(length(c(tmp))/2==0){
                    break
                }
                ## find a pair of nodes matching left to lst
                lft=which(tmp[,2]==lst[1])
                if(length(lft)==1){
                    ## append it left to lst
                    lst=c(tmp[lft,1],lst)
                    ## remove it from tmp
                    odim=dim(tmp)
                    tmp=tmp[-lft,]
                    dim(tmp)=c(odim[1]-1,odim[2])
                    llst=length(lst)
                }
                ## find a pair of nodes matching right to lst
                rgt=which(tmp[,1]==lst[llst])
                if(length(rgt)==1){
                    ## append it right to lst
                    lst=c(lst,tmp[rgt,2])
                    ## remove it from tmp
                    odim=dim(tmp)
                    tmp=tmp[-rgt,]
                    dim(tmp)=c(odim[1]-1,odim[2])
                    llst=length(lst)
                }
            }
            ## TODO: use start and stop nodes to check
            ## if results are correct.

            ## store the adjacency list for node i
            msl[[i]]=lst
            ## do some cleaning
            attr(msl[[i]],"names") <- NULL
        }
        ## check for counter clock wise ordering of adjacency list,
        ## otherwise correct it.
        if(!interp::left(t.triSht$x[i],t.triSht$y[i],t.triSht$x[msl[[i]][1]],t.triSht$y[msl[[i]][1]],t.triSht$x[msl[[i]][2]],t.triSht$y[msl[[i]][2]]))
            msl[[i]]=msl[[i]][length(msl[[i]]):1]
    }
    ## prepare TRIPACK data structures
    tlist=NULL; tlptr=NULL;tlend=NULL
    for(l in msl){
        last=length(tlist)
        ## concat lists
        tlist=append(tlist,l)
        ## save end points of lists
        tlend=append(tlend,length(tlist))
        ## find pointers from list end points to previous
        ## elements of the list, a little bit tricky
        tlptr=append(c(tlptr,last+length(l)),last+(1:(length(l)-1)))
    }
    ## check if list end points ar on convex hull
    ## if yes mark them with negative sign
    ch = interp::on.convex.hull(t.triSht,t.triSht$x[tlist[tlend]],t.triSht$y[tlist[tlend]])
    tlist[tlend[ch]]=-tlist[tlend[ch]]
    ## collect output
    obj=list(
        n=t.triSht$n,
        x=t.triSht$x,
        y=t.triSht$y,
        tlist=tlist,
        tlptr=tlptr,
        tlend=tlend,
        tlnew=tlend[length(tlend)]+1,
        nc=0,
        lc=0,
        call="converted from interp",
        adjlist=msl
    )
    class(obj)<-"tri"
    obj
}

convex.hull<-function(tri.obj, plot.it=FALSE, add=FALSE,...)
{
  if(!inherits(tri.obj,"triSht"))
    stop("tri.obj must be of class \"triSht\"")

  ret<-list(x=tri.obj$x[tri.obj$chull],
            y=tri.obj$y[tri.obj$chull],
            i=tri.obj$chull)
  if(plot.it)
    {
      if (!add)
        {
          plot.new()
          plot.window(range(ret$x), range(ret$y), "")
        }
      lines(cbind(ret$x,ret$x[1]),cbind(ret$y,ret$y[1]), ...)
      invisible(ret)
    }
  else
    ret
}

on.convex.hull<-function(tri.obj,x,y,eps=1E-16)
{
  if(!inherits(tri.obj,"triSht"))
    stop("tri.obj must be of class \"triSht\"")
  if(length(x)!=length(y))
    stop("x and y must be of same length")
  n<-length(x)
  if(n==0)
    stop("length of x (resp. y) is 0")
  onhull <- onHull(tri.obj,x,y,eps)
  onhull
}

cells<-function(voronoi.obj)
{
  if(!inherits(voronoi.obj,"voronoi"))
    stop("voronoi.obj must be of class \"voronoi\"")

  tri <- voronoi.obj$tri
  
  nnabs <- integer(tri$n)
  nptr <- integer(tri$n)
  nptr1 <- integer(tri$n)
  nbnos <- integer(tri$n)

  ret <- NULL
  for(i in 1:tri$n){
    vs <- voronoi.findvertices(i, voronoi.obj)
    if(length(vs)>0){
      center <- c(tri$x[i],tri$y[i])
      neighbours <- sort(c(arcs(tri)[arcs(tri)[,1]==i,2],arcs(tri)[arcs(tri)[,2]==i,1]))
      nodes <- rbind(voronoi.obj$x[vs],voronoi.obj$y[vs])
      rownames(nodes) <- c("x","y")
      area <- voronoi.polyarea( voronoi.obj$x[vs], voronoi.obj$y[vs])
      ret[[i]] <- list(cell=i,center=center,
                       neighbours=neighbours,
                       nodes=nodes,area=area)
    } else {
      center <- c(tri$x[i],tri$y[i])
      neighbours <- sort(c(arcs(tri)[arcs(tri)[,1]==i,2],arcs(tri)[arcs(tri)[,2]==i,1]))
      nodes <- NA # should better return at least the non-dummy nodes
      area <- NA
      ret[[i]] <- list(cell=i,center=center,
                       neighbours=neighbours,
                       nodes=nodes,area=area)
    }
  }
  
  ret
}

interpp <- function(x, y=NULL, z, xo, yo=NULL, linear = TRUE, extrap = FALSE,
                    duplicate = "error", dupfun = NULL,
                    deltri = "shull"){
    interp(x,y,z,xo,yo,linear,extrap,duplicate,dupfun,deltri,
           input="points", output="points")
}


interp <- function(x, y=NULL, z,
                   xo = seq(min(x), max(x), length = nx),
                   yo = seq(min(y), max(y), length = ny),
                   linear = (method=="linear"), extrap = FALSE,
                   duplicate = "error", dupfun = NULL,
                   nx = 40, ny = 40, input = "points", output = "grid",
                   method="linear", deltri="shull",
                   h=0, kernel="gaussian", solver="QR", degree=3,
                   baryweight=TRUE,
                   autodegree=FALSE,
                   adtol=0.1,
                   smoothpde=FALSE,
                   akimaweight=TRUE,
                   nweight=25)
    {
        if(method=="linear")
            linear <- TRUE
        ## handle sp data, save coordinate and value names
        is.sp <- FALSE
        sp.coord <- NULL
        sp.z <- NULL
        sp.proj4string <- NULL
        if(is.null(y)&&is.character(z)){
            if(inherits(x,"SpatialPointsDataFrame") &&
                requireNamespace("sp", quietly=TRUE)) {
                sp.coord <- dimnames(sp::coordinates(x))[[2]]
                sp.z <- z
                sp.proj4string <- x@proj4string
                z <- x@data[,z]
                y <- sp::coordinates(x)[,2]
                x <- sp::coordinates(x)[,1]
                is.sp <- TRUE
                xo = seq(min(x), max(x), length = nx)
                yo = seq(min(y), max(y), length = ny)
            } else
                stop("either x,y,z are numerical or x is SpatialPointsDataFrame and z a name of a data column in x")
        }
        if(!(all(is.finite(x)) && all(is.finite(y)) && all(is.finite(z))))
            stop("missing values and Infs not allowed")
        drx <- diff(range(x))
        dry <- diff(range(y))
        if(drx == 0 || dry == 0)
            stop("all data collinear")    # other cases caught in Fortran code
        if(drx/dry > 10000 || drx/dry < 0.0001)
            stop("scales of x and y are too dissimilar")
        n <- length(x)
        nx <- length(xo)
        ny <- length(yo)
        if(input=="points" && (length(y) != n || length(z) != n))
            stop("Lengths of x, y, and z do not match")
        if(input=="points"){
           dups_found <- isTRUE(anyDuplicated(cbind(x, y), MARGIN=1) != 0L)
           if (dups_found) {
               if(duplicate == "error") {
                   stop("duplicate data points: need to set 'duplicate = ..' ")
               }   else { ## duplicate != "error"
        
                   xy <- paste(x, y, sep = ",") # trick for 'duplicated' (x,y)-pairs
                   i <- match(xy, xy)
                   if(duplicate == "user")
                       dupfun <- match.fun(dupfun)#> error if it fails
        
                   ord <- !duplicated(xy)
                   if(duplicate != "strip") {
                       centre <- function(x)
                           switch(duplicate,
                                  mean = mean(x),
                                  median = median(x),
                                  user = dupfun(x))
                       z <- unlist(lapply(split(z,i), centre))
                   } else {
                       z <- z[ord]
                   }
                   x <- x[ord]
                   y <- y[ord]
                   n <- length(x)
               }
           }
        }
        if(input=="grid"){
          nxi <- length(x)
          nyi <- length(y)

          x<- c(matrix(rep(x,nyi),nrow=nxi,ncol=nyi,byrow=FALSE))
          y<- c(matrix(rep(y,nxi),nrow=nxi,ncol=nyi,byrow=TRUE))
	  z<- c(z)
        }
        if(method=="linear"||method=="akima"){

            if(deltri=="deldir"){
                if(!linear)
                    stop("method=\"akima\" (linear=FALSE) is not implemented for deltri=\"deldir\"!")
                triangles <- triang.list(deldir(x=x,y=y,z=z))
                ans <- interpDeltri(xo,yo,z,triangles,input,output)
            } else if(deltri=="shull"){
                ans <- interpShull(xo,yo,x,y,z,linear,input,output,
                                   kernel,h,
                                   solver,degree,
                                   baryweight,
                                   autodegree,adtol,
                                   smoothpde,akimaweight,nweight)
                if(output=="points") # back to vector from matrix:
                    ans$z <- c(ans$z)
            } else
                stop(paste("unknown triangulation method", deltri))
        } else
            stop(paste("method=\"",method,"\" not implemented!",sep=""))
        ## prepare return value
        if (is.sp && requireNamespace("sp", quietly=TRUE)) {
            zm <- nx
            zn <- ny
            zvec <- c(ans$z)
            xvec <- c(matrix(rep(ans$x,zn),nrow=zm,ncol=zn,byrow=FALSE))
            yvec <- c(matrix(rep(ans$y,zm),nrow=zm,ncol=zn,byrow=TRUE))
            nona <- !is.na(zvec)
            ret <- data.frame(xvec[nona],yvec[nona],zvec[nona])
            names(ret) <- c(sp.coord[1],sp.coord[2],sp.z)
            sp::coordinates(ret) <- sp.coord
            ret@proj4string <- sp.proj4string
            sp::gridded(ret) <- TRUE
        } else {
            if(output=="grid")
                ret <- list(x=ans$x,y=ans$y,z=matrix(ans$z,nx,ny))
            else
                ret <- list(x=ans$x,y=ans$y,z=ans$z)
        }
        ret
    }

triangles<-function(tri.obj){
  if(!inherits(tri.obj,"triSht"))
    stop("tri.obj must be of class \"triSht\"")

  ret<-tri.obj$trlist
  colnames(ret)<-c("node1","node2","node3","tr1","tr2","tr3","arc1","arc2","arc3")
  ret
}

arcs<-function(tri.obj){
  if(!inherits(tri.obj,"triSht"))
    stop("tri.obj must be of class \"triSht\"")

  ret<-cbind(tri.obj$arcs[,"from"],tri.obj$arcs[,"to"])
  colnames(ret)<-c("from","to")
  ret
}

area<-function(tri.obj){
    if(!inherits(tri.obj,"triSht"))
        stop("tri.obj must be of class \"triSht\"")

    ret<-tri.obj$cclist[,"area"]

    ret
}

plot.triSht<-function(x,add=FALSE,xlim=range(x$x),
                      ylim=range(x$y),do.points=TRUE,
                      do.labels=FALSE, isometric=TRUE,
                      do.circumcircles=FALSE,
                      segment.lty="dashed", circle.lty="dotted", ...)
{
    if(!inherits(x,"triSht"))
        stop("x must be of class \"triSht\"")

    if(isometric){
        xlim=range(x$x)
        ylim=range(x$y)
        xrange <- diff(xlim)
        yrange <- diff(ylim)
        maxrange <- max(xrange,yrange)
        midx <- sum(xlim)/2
        midy <- sum(ylim)/2
        xlim <- midx+(xlim-midx)/xrange*maxrange
        ylim <- midy+(ylim-midy)/yrange*maxrange
    }

    if(!add)
        plot(x$x,x$y,type="n", xlim=xlim, ylim=ylim)
    if(do.points)
        points(x$x,x$y)


    segments(x$x[x$arcs[,"from"]],x$y[x$arcs[,"from"]],
             x$x[x$arcs[,"to"]],x$y[x$arcs[,"to"]], lty=segment.lty, ...)
    if(do.labels){
        midsx <- 1/3*(x$x[x$trlist[,1]]+x$x[x$trlist[,2]]+
                      x$x[x$trlist[,3]])
        midsy <- 1/3*(x$y[x$trlist[,1]]+x$y[x$trlist[,2]]+
                      x$y[x$trlist[,3]])
        text(midsx,midsy,1:x$nt,...)
        text(x$x+0.025*diff(xlim),x$y+0.025*diff(ylim),1:x$n,font=4, ...)
        arcmidsx <- 1/2*(x$x[x$arcs[,"from"]]+x$x[x$arcs[,"to"]])
        arcmidsy <- 1/2*(x$y[x$arcs[,"from"]]+x$y[x$arcs[,"to"]])
        text(arcmidsx+0.025*diff(xlim),arcmidsy+0.025*diff(ylim),
             1:x$narcs,font=3,...)
    }
    if(do.circumcircles)
        circles(x$cclist[,"x"],x$cclist[,"y"],x$cclist[,"r"],
                lty=circle.lty, ...)
}

locpoly <- function(x, y, z,
                    xo = seq(min(x), max(x), length = nx),
                    yo = seq(min(y), max(y), length = ny),
                    nx = 40, ny = 40,
                    input = "points", output = "grid",
                    h = 0, kernel = "uniform", solver = "QR", degree = 3,
                    pd = ""){

    ## secondary use of the partial derivatives estimate for Akimas splines:
    ## use them directly grid- or pointwise.

    if(!(output %in% c("grid","points"))){
        stop("unknown value for \"output\"!")
    }
    if(!(input %in% c("grid","points"))){
        stop("unknown value for \"output\"!")
    }

    if(input=="grid"){
        lnx <- length(x)
        lny <- length(y)
        if(dim(z)[1]!=lnx | dim(z)[2]!=lny)
            stop("wrong dimensions of x, y, and z!")
        x <- matrix(rep(x,lny),lnx,lny)
        y <- t(matrix(rep(y,lnx),lny,lnx))
    }
    
    if(pd=="all"){
        if(output=="grid"){
            ans <- locpoly.partderiv.grid(xo,yo,x,y,z,kernel,h,solver,degree)
            ans$x=xo
            ans$y=yo
        } else {
            ans <- locpoly.partderiv.points(xo,yo,x,y,z,kernel,h,solver,degree)
            ans$x=xo
            ans$y=yo
        }
    } else if(pd==""){
        if(output=="grid")
            ans <- list(x=xo,y=yo,z=locpoly.partderiv.grid(xo,yo,x,y,z,kernel,h,solver,degree)$z)
        else
            ans <- list(x=xo,y=yo,z=locpoly.partderiv.points(xo,yo,x,y,z,kernel,h,solver,degree)$z)

    } else if(pd=="x"){
        if(degree>0){
            if(output=="grid")
                ans <- list(x=xo,y=yo,zx=locpoly.partderiv.grid(xo,yo,x,y,z,kernel,h,solver,degree)$zx)
            else
                ans <- list(x=xo,y=yo,zx=locpoly.partderiv.points(xo,yo,x,y,z,kernel,h,solver,degree)$zx)
        } else stop("need degree>0 for pd=\"x\"")
    } else if(pd=="y"){
        if(degree>0){
            if(output=="grid")
                ans <- list(x=xo,y=yo,zy=locpoly.partderiv.grid(xo,yo,x,y,z,kernel,h,solver,degree)$zy)
            else
                ans <- list(x=xo,y=yo,zy=locpoly.partderiv.points(xo,yo,x,y,z,kernel,h,solver,degree)$zy)
        } else stop("need degree>0 for pd=\"y\"")
    } else if(pd=="xx"){
        if(degree>1){
            if(output=="grid")
                ans <- list(x=xo,y=yo,zxx=locpoly.partderiv.grid(xo,yo,x,y,z,kernel,h,solver,degree)$zxx)
            else
                ans <- list(x=xo,y=yo,zxx=locpoly.partderiv.points(xo,yo,x,y,z,kernel,h,solver,degree)$zxx)
        } else stop("need degree>1 for pd=\"xx\"")
    } else if(pd=="yy"){
        if(degree>1){
            if(output=="grid")
                ans <- list(x=xo,y=yo,zyy=locpoly.partderiv.grid(xo,yo,x,y,z,kernel,h,solver,degree)$zyy)
            else
                ans <- list(x=xo,y=yo,zyy=locpoly.partderiv.points(xo,yo,x,y,z,kernel,h,solver,degree)$zyy)
        } else stop("need degree>1 for pd=\"yy\"")
    } else if(pd=="xy"){
        if(degree>1){
            if(output=="grid")
                ans <- list(x=xo,y=yo,zxy=locpoly.partderiv.grid(xo,yo,x,y,z,kernel,h,solver,degree)$zxy)
            else
                ans <- list(x=xo,y=yo,zxy=locpoly.partderiv.points(xo,yo,x,y,z,kernel,h,solver,degree)$zxy)
        } else  stop("need degree>1 for pd=\"xy\"")
    } else if(pd=="xxx"){
        if(degree>2){
            if(output=="grid")
                ans <- list(x=xo,y=yo,zxxx=locpoly.partderiv.grid(xo,yo,x,y,z,kernel,h,solver,degree)$zxxx)
            else
                ans <- list(x=xo,y=yo,zxxx=locpoly.partderiv.points(xo,yo,x,y,z,kernel,h,solver,degree)$zxxx)
        } else  stop("need degree>2 for pd=\"xxx\"")
    } else if(pd=="yyy"){
        if(degree>2){
            if(output=="grid")
                ans <- list(x=xo,y=yo,zyyy=locpoly.partderiv.grid(xo,yo,x,y,z,kernel,h,solver,degree)$zyyy)
            else
                ans <- list(x=xo,y=yo,zyyy=locpoly.partderiv.points(xo,yo,x,y,z,kernel,h,solver,degree)$zyyy)
        } else stop("need degree>2 for pd=\"yyy\"")
    } else if(pd=="xxy"){
        if(degree>2){
            if(output=="grid")
                ans <- list(x=xo,y=yo,zxxy=locpoly.partderiv.grid(xo,yo,x,y,z,kernel,h,solver,degree)$zxxy)
            else
                ans <- list(x=xo,y=yo,zxxy=locpoly.partderiv.points(xo,yo,x,y,z,kernel,h,solver,degree)$zxxy)
        } else stop("need degree>2 for pd=\"xxy\"")
    } else if(pd=="xyy"){
        if(degree>2){
            if(output=="grid")
                ans <- list(x=xo,y=yo,zxyy=locpoly.partderiv.grid(xo,yo,x,y,z,kernel,h,solver,degree)$zxyy)
            else
                ans <- list(x=xo,y=yo,zxyy=locpoly.partderiv.points(xo,yo,x,y,z,kernel,h,solver,degree)$zxyy)
        } else stop("need degree>2 for pd=\"xyy\"")
    } else
        stop(paste("unsupported value for pd: ", pd,
                   "\nonly partial derivatives of order up to 3 can be estimated (needs degree=3)!"))

    ans
}

"voronoi.mosaic" <- function(x,y=NULL,duplicate="error")
  {

    dummy.node<-function(x0,y0,x1,y1,x2,y2,d)
      {
        # determine a direction orthogonal to p1--p2
        #
        #              p_1
        #               |
        #               |d
        #    p_0 ------>+ - - - - -> dummy_node
        #          r    |
        #               V
        #              p_2------->
        #                    n
        # two versions, r and n
        #

        dx<-  x2-x1
        dy<-  y2-y1
        nx<- -dy
        ny<-  dx

        rx<-(x1+x2)/2-x0
        ry<-(y1+y2)/2-y0

        lr<-sqrt(rx^2+ry^2)
        ln<-sqrt(nx^2+ny^2)
        # choose the numerically better version
        if(lr > ln)
          {
            vx<-rx/lr
            vy<-ry/lr

            if(in.convex.hull(ret$tri,x0,y0))
              d <- d
            else
              d <- -d
          }
        else
          {
            vx<-nx/ln
            vy<-ny/ln
            eps<-1e-7
            if(in.convex.hull(ret$tri,(x1+x2)/2+eps*vx,(y1+y2)/2+eps*vy))
              d <- - d
            else
              d <- d
          }
        list(x=x0+d*vx,y=y0+d*vy)
      }

    if(inherits(x,"tri")){
        if(!is.null(x$tlist))
            stop("this \"tri\" object has been created with tripack::tri.mesh,\n  recreate it with interp::tri.mesh!\n  The $call element gives a hint how it was created.")
        tri.obj <- x
    } else
        tri.obj<-tri.mesh(x=x,y=y,duplicate=duplicate)

    nt<-tri.obj$nt

    ret<-list(x=tri.obj$cclist[,"x"],
              y=tri.obj$cclist[,"y"],
              node=(tri.obj$cclist[,"area"]>0),
              area=tri.obj$cclist[,"area"],
              ratio=tri.obj$cclist[,"ratio"],
              radius=tri.obj$cclist[,"r"],
              n1=tri.obj$trlist[,"j1"],
              n2=tri.obj$trlist[,"j2"],
              n3=tri.obj$trlist[,"j3"],
              p1=tri.obj$trlist[,"i1"],
              p2=tri.obj$trlist[,"i2"],
              p3=tri.obj$trlist[,"i3"],
              tri=tri.obj)


    ret$dummy.x<-integer(0)
    ret$dummy.y<-integer(0)
    dummy.cnt<-0
    dmax<-max(diff(range(ret$x)),diff(range(ret$y)))
    n<-length(ret$x)
    # add dummy nodes on the border of the triangulation
    for (i in 1:n)
      {
        if(ret$node[i])
          # Triangle i has positive area.
          {
            # Find neighbour triangles
            tns<-sort(c(ret$n1[i],ret$n2[i],ret$n3[i]))
            ins <- order(c(ret$n1[i],ret$n2[i],ret$n3[i]))
            tn1<-tns[1]
            tn2<-tns[2]
            tn3<-tns[3]
            # Handle special cases on the border:
            # (This should better be done in the FORTRAN code!)
            if(any(tns==0))
              {
                if(tns[2]!=0)
                  {
                    # Only one edge of i coincides with border.
                    # Determine nodes of triangle i
                    tr<-c(ret$p1[i],ret$p2[i],ret$p3[i])
                    # Which of these nodes are border nodes (2)?
                    ns<-tr[on.convex.hull(ret$tri,
                                          ret$tri$x[tr],
                                          ret$tri$y[tr])]
                    if(length(ns)==2)
                      {
                        # 2 points on hull
                        i1<-ns[1]
                        i2<-ns[2]
                        # Find a dummy node
                        pn<-dummy.node(ret$x[i],ret$y[i],
                                       ret$tri$x[i1],ret$tri$y[i1],
                                       ret$tri$x[i2],ret$tri$y[i2],
                                       dmax)
                        dummy.cnt<- dummy.cnt+1
                        ret$dummy.x[dummy.cnt]<-pn$x
                        ret$dummy.y[dummy.cnt]<-pn$y
                        # update neighbour relation
                        # (negative index indicates dummy node)
                        if(ret$n1[i]==0) ret$n1[i]<- -dummy.cnt
                        if(ret$n2[i]==0) ret$n2[i]<- -dummy.cnt
                        if(ret$n3[i]==0) ret$n3[i]<- -dummy.cnt
                      }
                    # Other cases:
                    #   1 point on hull -- should not happen at all
                    #   3 points on hull -- should not happen here
                    #     see "else" tree
                  }
                else
                  {
                    # Two edges of i coincide with border.
                    # (= 3 points on hull )
                    # that means this triangle forms one corner of
                    # the convex hull
                    # Find out which edge of triangle i is not
                    # on the border: (check if midpoints of edges lay
                    # on hull)
                    tr<-c(ret$p1[i],ret$p2[i],ret$p3[i])
                    edge<-list(from=tr[c(1,2,3)],to=tr[c(2,3,1)])
                    mx <- (ret$tri$x[edge$from]+ret$tri$x[edge$to])/2
                    my <- (ret$tri$y[edge$from]+ret$tri$y[edge$to])/2
                    eonb <- on.convex.hull(ret$tri,mx,my)
                    # Find two dummy nodes
                    for (id in 1:3){
                      if (eonb[id]){
                        pn<-dummy.node(ret$x[i],ret$y[i],
                                       ret$tri$x[edge$from[id]],
                                       ret$tri$y[edge$from[id]],
                                       ret$tri$x[edge$to[id]],
                                       ret$tri$y[edge$to[id]],
                                       dmax)
                        dummy.cnt<- dummy.cnt+1
                        ret$dummy.x[dummy.cnt]<-pn$x
                        ret$dummy.y[dummy.cnt]<-pn$y
                        # update neighbour relation
                        # (negative index indicates dummy node)
                        if(ret$n1[i]==0) ret$n1[i]<- -dummy.cnt
                        else
                          if(ret$n2[i]==0) ret$n2[i]<- -dummy.cnt
                          else
                            if(ret$n3[i]==0) ret$n3[i]<- -dummy.cnt
                      }
                    }
                  }
              }
          }
        else
          {
            # A triangle i with area 0:
            # This can't happen on the border (already removed in FORTRAN code!).
            # Do nothing.
            tmp<-0
          }
      }
    ret$call <- match.call()
    class(ret) <- "voronoi"
    ret
  }

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

aSpline <- function(x, y, xout, method = "improved", degree = 3L) {
    .Call('_interp_aSpline', PACKAGE = 'interp', x, y, xout, method, degree)
}

circum <- function(x, y) {
    .Call('_interp_circum', PACKAGE = 'interp', x, y)
}

interpDeltri <- function(x, y, zD, t, input = "points", output = "grid") {
    .Call('_interp_interpDeltri', PACKAGE = 'interp', x, y, zD, t, input, output)
}

interpShull <- function(x, y, xD, yD, zD, linear = TRUE, input = "points", output = "grid", kernel = "gaussian", h = as.numeric( c(0.0)), solver = "QR", degree = 3L, baryweight = TRUE, autodegree = FALSE, adtol = 1E-6, smoothpde = FALSE, akimaweight = TRUE, nweight = 25L) {
    .Call('_interp_interpShull', PACKAGE = 'interp', x, y, xD, yD, zD, linear, input, output, kernel, h, solver, degree, baryweight, autodegree, adtol, smoothpde, akimaweight, nweight)
}

locpoly.partderiv.grid <- function(x, y, xD, yD, zD, kernel = "gaussian", h = as.numeric( c(0.25,0.25)), solver = "QR", degree = 3L, smoothpde = FALSE, akimaweight = FALSE, nweight = 25L) {
    .Call('_interp_partDerivGrid', PACKAGE = 'interp', x, y, xD, yD, zD, kernel, h, solver, degree, smoothpde, akimaweight, nweight)
}

locpoly.partderiv.points <- function(x, y, xD, yD, zD, kernel = "gaussian", h = as.numeric( c(0.25,0.25)), solver = "QR", degree = 3L, smoothpde = FALSE, akimaweight = FALSE, nweight = 25L) {
    .Call('_interp_partDerivPoints', PACKAGE = 'interp', x, y, xD, yD, zD, kernel, h, solver, degree, smoothpde, akimaweight, nweight)
}

nearest.neighbours <- function(x, y) {
    .Call('_interp_nearestNeighbours', PACKAGE = 'interp', x, y)
}

shull.deltri <- function(x, y) {
    .Call('_interp_shullDeltri', PACKAGE = 'interp', x, y)
}

triFind <- function(nT, xT, yT, i1, i2, i3, x, y) {
    .Call('_interp_triFind', PACKAGE = 'interp', nT, xT, yT, i1, i2, i3, x, y)
}

left <- function(x1, y1, x2, y2, x0, y0, eps = 1E-16) {
    .Call('_interp_left', PACKAGE = 'interp', x1, y1, x2, y2, x0, y0, eps)
}

on <- function(x1, y1, x2, y2, x0, y0, eps = 1E-16) {
    .Call('_interp_on', PACKAGE = 'interp', x1, y1, x2, y2, x0, y0, eps)
}

inHull <- function(triObj, x, y, eps = 1E-16) {
    .Call('_interp_inHull', PACKAGE = 'interp', triObj, x, y, eps)
}

onHull <- function(triObj, x, y, eps = 1E-16) {
    .Call('_interp_onHull', PACKAGE = 'interp', triObj, x, y, eps)
}

identify.triSht<-function(x,...)
  {
    if(!inherits(x,"triSht"))
      stop("x must be of class \"tri\"")
    labels<-paste("(",round(x$x,5),",",round(x$y,5),")", sep ="")
    identify(x$x,x$y,labels=labels)
  }

tri.mesh <- function(x,y=NULL,duplicate="error"){
    if(is.null(x))
        stop("argument x missing.")
    if(is.null(y)){
        x1<-x$x
        y1<-x$y
        if (is.null(x1) || is.null(y1))
            stop("argument y missing and x contains no $x or $y component.")
    } else {
        x1<-x
        y1<-y
    }

    n <- length(x1)
    if(length(y1)!=n)
        stop("length of x and y differ.")
    ## handle duplicate points:
    xy <- paste(x1, y1, sep =",")
    i <- match(xy, xy)
    if(duplicate!="error")
        {
            if(duplicate!="remove" & duplicate!="error" & duplicate!="strip"){
                stop("possible values for \'duplicate\' are \"error\", \"strip\" and \"remove\"")
            }
            else{
                if(duplicate=="remove")
                    ord <- !duplicated(xy)
                if(duplicate=="strip")
                    ord <- (hist(i,plot=FALSE,freq=TRUE,breaks=seq(0.5,max(i)+0.5,1))$counts==1)
                x1 <- x1[ord]
                y1 <- y1[ord]
                n <- length(x1)
            }
        }
    else
        if(any(duplicated(xy)))
            stop("duplicate data points")

    ans <- shull.deltri(x1,y1)
    nt <- length(ans$i1)

    ## note: triangles are enumerated in c++ starting with 0, so add 1 here
    ## points are enumerated started with 1
    tri.obj<-list(n=ans$n,x=ans$x,y=ans$y,
                  nt=ans$nt,
                  trlist=ans$trlist,
                  cclist=ans$cclist,
                  nchull=ans$nch,
                  chull=ans$ch,
                  narcs=ans$na,
                  arcs=cbind(ans$a1,ans$a2),
                  call=match.call())

    colnames(tri.obj$trlist) <- c("i1","i2","i3","j1","j2","j3","k1","k2","k3")
    colnames(tri.obj$cclist) <- c("x","y","r","area","ratio")
    colnames(tri.obj$arcs) <- c("from","to")
    class(tri.obj)<-"triSht"
    invisible(tri.obj)
}

circles <- function(x,y,r,...){
  n <- length(x)
  if(length(y)!=n || length(r)!=n)
    stop("arguments should be of same length!")
  phi <- seq(0,2*pi,length=360)
  for(i in 1:n){
    lines(c(x[i]+r[i]*cos(phi),x[i]+r[i]),c(y[i]+r[i]*sin(phi),y[i]),type="l",...)
  }
}

print.summary.triSht<-function(x,...)
  {
    cat("triangulation:\n")
    cat("Call:", deparse(x$call),"\n")
    cat("number of nodes:",x$n,"\n")
    cat("number of arcs:",x$na,"\n")
    cat("number of boundary nodes:",x$nb,"\n")
    cat("number of triangles:",x$nt,"\n")
  }

bilinear <- function(x,y,z,x0,y0){
  nx <- length(x)
  ny <- length(y)
  if(dim(z)[1]!=nx)
    stop("dim(z)[1] and length of x differs!")
  if(dim(z)[2]!=ny)
    stop("dim(z)[2] and length of y differs!")
  n0 <- length(x0)
  if(length(y0)!=n0)
    stop("length of y0 and x0 differs!")

  ret <- .Fortran("biliip",
                  as.double(x0),
                  as.double(y0),
                  z0=double(n0),
                  as.integer(n0),
                  as.double(x),
                  as.double(y),
                  as.double(z),
                  as.integer(nx),
                  as.integer(ny),
                  ier=integer(1),
                  PACKAGE="interp")
  if(ret$ier==1)
      stop("duplicate coordinates in input grid!")
  else
      list(x=x0,y=y0,z=ret$z0)
}


bilinear.grid <- function(x,y,z,xlim=c(min(x),max(x)),ylim=c(min(y),max(y)),
                         nx=40,ny=40,dx=NULL,dy=NULL){
  Nx <- length(x)
  Ny <- length(y)
  if(dim(z)[1]!=Nx)
    stop("dim(z)[1] and length of x differs!")
  if(dim(z)[2]!=Ny)
    stop("dim(z)[2] and length of y differs!")
  if(!is.null(dx)){
      xi <- seq(xlim[1],xlim[2],by=dx)
      nx <- length(xi)
  } else {
      xi <- seq(ylim[1],ylim[2],length=nx)
  }

  if(!is.null(dx)){
      yi <- seq(ylim[1],ylim[2],by=dy)
      ny <- length(yi)
  } else {
      yi <- seq(ylim[1],ylim[2],length=ny)
  }
  xmat <- matrix(rep(xi,ny),nrow=ny,ncol=nx,byrow=TRUE)
  ymat <- matrix(rep(yi,nx),nrow=ny,ncol=nx,byrow=FALSE)

  xy <- cbind(c(xmat),c(ymat))

  n0 <- nx*ny

  ret <- bilinear(x,y,z,xy[,1],xy[,2])

 # return cell boundaries
  list(x=xi,y=yi,z=t(matrix(ret$z,nrow=ny,ncol=nx,byrow=F)))
}

voronoi.area <- function(voronoi.obj)
{
  ## Compute the area of each Voronoi polygon.
  ## If the area of a polygon cannot be computed, NA is returned.
  ##
  ## TODO: currently, the list of Voronoi vertices (vs) of each site
  ## is found, but then discarded.  They could be reused for other
  ## calls?
  
  nsites <- length(voronoi.obj$tri$x)
  areas <- double(nsites)
  for (i in 1:nsites) {
    vs <- voronoi.findvertices(i, voronoi.obj)
    if (length(vs) > 0) {
      areas[i] <- voronoi.polyarea( voronoi.obj$x[vs], voronoi.obj$y[vs])
    } else {
      areas[i] <- NA
    }
  }
  areas
}


voronoi.findvertices <- function(site, vor) {
  ## Helper function.
  ## Return the ordered list of Voronoi vertices for site number SITE
  ## in the Voronoi tesselation.
  
  p <- cbind(vor$p1, vor$p2, vor$p3)
  a <- which(p == site, arr.ind=TRUE)
  vertices <- a[,1]                     #list of the vertice indexes.
  triples <- p[a[,1],]
  triples
  ## Now remove the entries that are not site.

  ## Need to take transpose, as `which' runs down by column, rather
  ## than by row, and we want to keep rows together.
  triples <- t(triples)
  pairs <- triples[ which (triples!= site)]
  m <- matrix(pairs, ncol=2, byrow=TRUE)

  ## Now go through the list of sites and order the vertices.  We
  ## build up the list of vertices in the vector `orderedvs'.  This
  ## vector is truncated to the exact size at the end of the function.


  ## To order the vertices of the Voronoi polygon associated with a
  ## site, we first find all vertices that are associated with a site.
  ## These will come in threes, from the array `triples'.  We then
  ## remove the site number itself from the triples to come up with a
  ## list of pairs.  e.g. trying to find the vertices for site 6:
  
  ## sites     v number
  ## 3 9 6     6
  ## 6 4 3     2
  ## 9 6 7     3
  ## 6 7 4     9
  ##
  ## remove the `6':
  ## sites   v number
  ## 3 9     6
  ## 4 3     2
  ## 9 7     3
  ## 7 4     9
  
  ## and then starting with site 3, we find each subsequent site.
  ## i.e. 3 then 9 (output v 6), then 7 (output v 3), then 4 (output v
  ## 9) then 3 (output v 2).  We are now back to the starting site so
  ## the ordered list of vertices is 6, 3, 9, 2.
  
  orderedvs <- integer(30); vnum <- 1
  orderedvs[vnum] <- vertices[1]; vnum <- 1 + vnum
  firstv <- m[1,1];   nextv <- m[1,2]; m[1,] <- -1; #blank 1st row out.
  looking <- TRUE
  while (looking) {
    ##cat(paste("looking for ", nextv, "\n"))
    t <- which(m == nextv, arr.ind=TRUE)
    if (length(t) == 0) {               #could check length(t) != 1
      ## cannot compute area...
      vnum <- 1; looking <- FALSE
    } else {
      t.row <- t[1,1]
      t.col <- t[1,2]
      orderedvs[vnum] <- vertices[t.row]; vnum <- 1 + vnum
      othercol <- (3 - t.col)            #switch 1 to 2 and vice-versa.
      nextv <- m[ t.row, othercol]
      m[t.row,] <- -1                    #blank this row out.
      if (nextv == firstv) looking <- FALSE
    }
  }

  orderedvs[1:vnum-1]                   #truncate vector to exact length.
}

  
voronoi.polyarea <- function (x, y)
{
  ## Return the area of the polygon given by the points (x[i], y[i]).
  ## Absolute value taken in case coordinates are clockwise.
  ## Taken from the Octave implementation.
  ## Helper function.
  r <- length(x)
  p <- matrix(c(x, y), ncol=2, nrow=r)
  p2 <- matrix( c(y[2:r], y[1],  -x[2:r], -x[1]), ncol=2, nrow=r)
  a <- abs(sum (p * p2 ) / 2)
}

%% -*- mode: Rnw; coding: utf-8; -*-
%\VignetteIndexEntry{Local polynomial regression in two variables: Estimating partial derivatives}
%\VignetteDepends{Deriv,Ryacas,ggplot2,gridExtra,lattice,stringi,stringr}
%\VignetteKeywords{nonparametric}
%\VignettePackage{interp}

\documentclass[nojss]{jss}
\usepackage[utf8]{inputenc}
%\usepackage{Sweave}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{amsmath}
\usepackage{amsthm}
\usepackage{bm}
\usepackage{graphicx}

% put floats before next section:
\usepackage[section]{placeins}

% collect appendices as subsections
\usepackage[toc,page]{appendix}

% customize verbatim parts
\usepackage{listings}
\lstdefinestyle{Sstyle}{
  basicstyle=\ttfamily\rsize,
  columns=fixed,
  breaklines=true, % sets automatic line breaking
  breakatwhitespace=false,
  postbreak=\raisebox{0ex}[0ex][0ex]{\ensuremath{\color{red}\hookrightarrow\space}},
  fontadjust=true,
  basewidth=0.5em,
  inputencoding=utf8,
  extendedchars=true,
  literate={‘}{{'}}1 {’}{{'}}1 % Zeichencodes für Ausgabe von lm() !
  {á}{{\'a}}1 {é}{{\'e}}1 {í}{{\'i}}1 {ó}{{\'o}}1 {ú}{{\'u}}1
  {Á}{{\'A}}1 {É}{{\'E}}1 {Í}{{\'I}}1 {Ó}{{\'O}}1 {Ú}{{\'U}}1
  {à}{{\`a}}1 {è}{{\`e}}1 {ì}{{\`i}}1 {ò}{{\`o}}1 {ù}{{\`u}}1
  {À}{{\`A}}1 {È}{{\'E}}1 {Ì}{{\`I}}1 {Ò}{{\`O}}1 {Ù}{{\`U}}1
  {ä}{{\"a}}1 {ë}{{\"e}}1 {ï}{{\"i}}1 {ö}{{\"o}}1 {ü}{{\"u}}1
  {Ä}{{\"A}}1 {Ë}{{\"E}}1 {Ï}{{\"I}}1 {Ö}{{\"O}}1 {Ü}{{\"U}}1
  {â}{{\^a}}1 {ê}{{\^e}}1 {î}{{\^i}}1 {ô}{{\^o}}1 {û}{{\^u}}1
  {Â}{{\^A}}1 {Ê}{{\^E}}1 {Î}{{\^I}}1 {Ô}{{\^O}}1 {Û}{{\^U}}1
  {œ}{{\oe}}1 {Œ}{{\OE}}1 {æ}{{\ae}}1 {Æ}{{\AE}}1 {ß}{{\ss}}1
  {ű}{{\H{u}}}1 {Ű}{{\H{U}}}1 {ő}{{\H{o}}}1 {Ő}{{\H{O}}}1
  {ç}{{\c c}}1 {Ç}{{\c C}}1 {ø}{{\o}}1 {å}{{\r a}}1 {Å}{{\r A}}1
  {€}{{\euro}}1 {£}{{\pounds}}1 {«}{{\guillemotleft}}1
  {»}{{\guillemotright}}1 {ñ}{{\~n}}1 {Ñ}{{\~N}}1 {¿}{{?`}}1
}
% switch to above defined style
\lstset{style=Sstyle}

% nice borders for code blocks
\usepackage{tcolorbox}
% enable boxes over several pages:
\tcbuselibrary{breakable,skins}
\tcbset{breakable,enhanced}

\definecolor{grey2}{rgb}{0.6,0.6,0.6}
\definecolor{grey1}{rgb}{0.8,0.8,0.8}



% some abbreviations:
\newcommand{\R}{\mathbb{R}}
\newcommand{\EV}{\mathbb{E}}
\newcommand{\Vect}[1]{\underline{#1}}
\newcommand{\Mat}[1]{\boldsymbol{#1}}
\newcommand{\Var}{\mbox{Var}}
\newcommand{\Cov}{\mbox{Cov}}
% lstinline can break code across lines
\def\cmd{\lstinline[basicstyle=\ttfamily,keywordstyle={},breaklines=true,breakatwhitespace=false]}
% but lstinline generates ugly sectionnames in PDF TOC, so use \texttt there
\newcommand{\cmdtxt}[1]{\texttt{#1}}

\newtheorem{definition}{Definition}[section]
\newtheorem{remark}{Remark}[section]
\newtheorem{lemma}{Lemma}[section]

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% declarations for jss.cls %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% almost as usual
\author{
  Albrecht Gebhardt\\ %Department of Statistics,
  University Klagenfurt
\And
  Roger Bivand\\ %Department of Economics,
  Norwegian School of Economics}

\title{Local Polynomial Regression: How the \proglang{R} Package
  \pkg{interp} estimates partial derivatives for later use in Spline
  Interpolation}

%% for pretty printing and a nice hypersummary also set:
\Plainauthor{Albrecht Gebhardt, Roger Bivand} %% comma-separated
\Plaintitle{Local Polynomial Regression: How the R Package interp estimates partial derivatives for later use in Spline Interpolation} %% without formatting
\Shorttitle{Local Polynomial Regression in \proglang{R} Package \pkg{interp}} %% a short title (if necessary)

%% an abstract and keywords
\Abstract{
This vignette presents the \proglang{R} package \pkg{interp}
and focuses on local polynomial regression for estimating partial derivatives.

This is the first of planned three vignettes for this package (not yet finished).
}
\Keywords{local polynomial regression, partial derivatives, \proglang{R} software}
\Plainkeywords{local polynomial regression, partial derivatives, R software}
%% without formatting
%% at least one keyword must be supplied

%% publication information
%% NOTE: Typically, this can be left commented and will be filled out by the technical editor
%% \Volume{13}
%% \Issue{9}
%% \Month{September}
%% \Year{2004}
%% \Submitdate{2004-09-29}
%% \Acceptdate{2004-09-29}

%% The address of (at least) one author should be given
%% in the following format:
\Address{
  Albrecht Gebhardt\
  Institut für Statistik\\
  Universität Klagenfurt\
  9020 Klagenfurt, Austria\\
  E-mail: \email{albrecht.gebhardt@aau.at}\
  %URL: \url{http://statmath.wu-wien.ac.at/~zeileis/}
}
%% It is also possible to add a telephone and fax number
%% before the e-mail in the following format:
%% Telephone: +43/1/31336-5053
%% Fax: +43/1/31336-734

%% for those who use Sweave please include the following line (with % symbols):
%% need no \usepackage{Sweave.sty}

%% end of declarations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% for Sinput to set font size of R input code:
\newcommand\rsize{%
   \fontsize{8.5pt}{9.1pt}\selectfont%
}

\begin{document}
% undefine Sinput, Soutput, Scode to be able to redefine them as
% \lstnewenvironment{Sinput}...
\makeatletter
\let\Sinput\@undefined
\let\endSinput\@undefined
\let\Soutput\@undefined
\let\endSoutput\@undefined
\let\Scode\@undefined
\let\endScode\@undefined
\makeatother

\hypersetup{pdftitle={Local Polynomial Regression: How the R Package interp estimates partial derivatives for later use in Spline Interpolation},pdfauthor={Albrecht Gebhardt and Roger Bivand},
  pdfborder=1 1 1 1 1}

% Sweave stuff:
% graphics dimension:
\setkeys{Gin}{width=0.8\textwidth}
%\setkeys{Gin}{width=1in}
% all in- and output black:
\definecolor{Sinput}{rgb}{0,0,0}
\definecolor{Soutput}{rgb}{0,0,0}
\definecolor{Scode}{rgb}{0,0,0}
% redefine Sinput, Soutput, Scode, variant 1 use fancy verbatim
%
%\DefineVerbatimEnvironment{Sinput}{Verbatim}
% gobble=0 !!! otherwise 2 characters of S lines are hidden !!!
%{formatcom = {\color{Sinput}},fontsize=\rsize,xleftmargin=2em,gobble=0}
%\DefineVerbatimEnvironment{Soutput}{Verbatim}
%{formatcom = {\color{Soutput}},fontsize=\rsize,xleftmargin=2em,gobble=0}
%\DefineVerbatimEnvironment{Scode}{Verbatim}
%{formatcom = {\color{Scode}},fontsize=\rsize,xleftmargin=2em,gobble=0}
%\fvset{listparameters={\setlength{\topsep}{0pt}}}
%\renewenvironment{Schunk}{\vspace{\topsep}}{\vspace{\topsep}}
%
% redefine Sinput, Soutput, Scode, variant 2, use color boxes (tcb)
\lstnewenvironment{Sinput}{\lstset{style=Sstyle}}{}%
\lstnewenvironment{Soutput}{\lstset{style=Sstyle}}{}%
\lstnewenvironment{Scode}{\lstset{style=Sstyle}}{}%
\renewenvironment{Schunk}{\vspace{\topsep}\begin{tcolorbox}[breakable,colback=grey1]}{\end{tcolorbox}\vspace{\topsep}}
% see http://www.stat.auckland.ac.nz/~ihaka/downloads/Sweave-customisation.pdf
%

% all in one line!!! setting for direct PDF output !
\SweaveOpts{keep.source=TRUE,engine=R,eps=FALSE,pdf=TRUE,strip.white=all,prefix=TRUE,prefix.string=fig-,include=TRUE,concordance=FALSE,width=6,height=6.5}

% Sweave initialization:
% restrict line length of R output, no "+" for continued lines,
% set plot margins:
% initialize libraries and RNG if necessary
<<label=init, echo=FALSE, results=hide>>=
set.seed(42)
options(width=80)
options(continue=" ")
options(SweaveHooks=list(fig=function()
    par(mar=c(5.1, 4.1, 1.1, 2.1))))
library(interp)
library(Deriv)
library(Ryacas)
library(gridExtra)
library(grid)
library(ggplot2)
library(lattice)
@


\section[Note]{Note}
\label{sec:note}
Notice: This is a preliminary and not yet complete version of this vignette.
Finally three vignettes will be available for this package:
\begin{enumerate}
\item this one related to partial derivatives estimation,
\item a next one describing interpolation related stuff
\item and a third one dealing with triangulations and voronoi mosaics.
\end{enumerate}
Currently only the first text is available and not yet finished.

\section[Introduction]{Introduction}
\label{sec:intro}
Altough the main intention of this \cmd{R} package is
interpolation, it also contains routines for local polynomial
regression. The reason is that the spline interpolation implemented by
\cmd{interp::interp(...,method="akima")} needs estimates of the
partial derivatives of the interpolated function up to degree 2.

One approach to get such estimates is to perform a local polynomial
regression \citep[see e.g.][p. 19]{fan1996local} and get the 
partial derivatives as a side
effect, as explained later. This is also applied in Akimas original
code in a special hardcoded way (using a fixed local bandwidth and a
uniform kernel). Once this routines had been implemented and used
internally in the \cmd{interp::interp(...,method="akima")} it was an
obvious decision to make these routines also available to end users of
package \cmd{"interp"}.

\section{Kernel Functions}
\label{sec:kernel}
In the next section we will use the notion of kernel functions, so
lets start with this definition.

\begin{definition}
A one-dimensional kernel function\index{kernel function} $K(x)$ is
\begin{enumerate}
\item a density function, hence
  \begin{enumerate}
  \item $K(x)\ge 0$
  \item $\int_{\R}K(x)dx=1$
  \end{enumerate}
  Lets denote the associated stochastic variable with $X_{K}$ for
  easier notation, it otherwise carries no meaning.
\item $K$ has the property $\int_{\R}x\cdot K(x)=0$ (i.e. $\EV X_{K}=0$,
  kernel function is centered at zero) and
  
\item $K$ is assumed to be symmtric $K(-x)=K(x)$ and
\item $0<\int_{\R}x^{2}\cdot K(x)dx=\sigma^{2}_{K}<\infty$, i.e.
  $\Var X_{K}$ exists.
  \end{enumerate}
\end{definition}
The kernel functions currently implemented in this library are listed
in table \ref{tab:kernels}.
\begin{table}[htbp]
  \centering
  \begin{tabular}{l|c|l}
    name & function & support of $K$ (outside: $K(x)=0$)\\
    \hline
    gaussian      & $\frac{1}{\sqrt{2\pi}}e^{-\frac{x^{2}}{2}}$ & $x\in\R$\\
    cosine       & $\frac{1}{2}\cos(x)$ &$x\in(-\frac{\pi}{2},\frac{\pi}{2}]$\\
    epanechnikov & $\frac{3}{4}(1-x^{2})$&$x\in(-1,1]$\\
    biweight     & $\frac{15}{16}(1-x^{2})^{2}$&$x\in(-1,1]$\\
    tricube      & $\frac{70}{81}(1-|x|^{3})^{3}$ &$x\in(-1,1]$\\
    triweight    & $\frac{35}{32}(1-x^{2})^{3}$  &$x\in(-1,1]$\\
    uniform      & $\frac{1}{2}$ & $x\in(-1,1]$\\
    triangular   & $1-|x|$  &$x\in(-1,1]$
  \end{tabular}
\index{kernel functions}
  \caption{kernels}
  \label{tab:kernels}
\end{table}

A common approach to create twodimensional kernel functions is to
derive them from onedimensional kernels as bivariate densities with
independent components:
\begin{eqnarray*}
  K_{X,Y}(x,y)&=&K_{X}(x)K_{Y}(y)
\end{eqnarray*}
Both $K_X$ and $K_Y$ are choosen from the same kernel function type.


\section{Bivariate Local Polynomial Regression}
\label{sec:local-polyn-regr}
Lets start with a data set $\{(\Vect{x}_{i},z_{i})|i=1,\ldots,n\}$
with vectors $\Vect{x}_{i}=(x_{i},y_{i})^{\top}\in\R^{2}$ and real
numbers $z_{i}\in\R$. Assume a trend model
$$
z=m(\Vect{x})+\varepsilon
$$
with independent random errors $\varepsilon$
and a bivariate polynomial of degree $r$ as setup for $m$:
$$
m(\Vect{x})=m(x,y)=\sum_{i=0}^{r}\sum_{j=0}^{r-i}\beta_{ij}x^{i}y^{j}.
$$
Note that the sum of exponents $i$ and $j$ in each term of the sum is
bounded above by $r$.

Local regression aims to minimize a weighted sum of squares where the
weights are determined by a bivariate kernel function centered at the
actual location for prediction $\Vect{x}$ which decreases with increasing
distance from this centering point:
$$
\sum_{k=1}^{n}K_{X}\left(\frac{x-x_k}{h_{x}}\right)K_{Y}\left(\frac{y-y_k}{h_{y}}\right)
\left[z_k-\sum_{i=0}^{r}\sum_{j=0}^{r-i}\beta_{ij}x_k^{i}y_k^{j}\right]^2 \rightarrow Min
$$

A Taylor expansion of $m(x,y)$ in a location
$\Vect{x}_{0}=(x_{0},y_{0})$ can be used as a starting point to
interpret the estimated parameters:
\begin{eqnarray*}
  m(x,y) &=& \sum_{i=0}^{r-1}\sum_{j=0}^{r-1-i}  \frac{\frac{\partial^{i+j} m}{\partial x^{i}\partial y^{j}}(x_0)}{i!j!}(x-x_0)^{i}(y-y_0)^{j}\\
  &=& \sum_{i=1}^{r}\sum_{j=1}^{r-i} \underbrace{\frac{\frac{\partial^{i+j} m}{\partial x^{i-1}\partial y^{j-1}}(x_0)}{(i-1)!(j-1)!}}_{=\beta_{ij}}(x-x_0)^{i-1}(y-y_0)^{j-1}\\
  &=& \sum_{i=1}^{r}\sum_{j=1}^{r-i} \beta_{ij} (x-x_0)^{i-1}(y-y_0)^{j-1}\\
\end{eqnarray*}
With the estimates
$\widehat{\beta}_{ij}, i=1,\ldots,r, j=1,\ldots,r-i$ for a given
location $\Vect{x}$ we evaluate this Taylor expansion at
$\Vect{x}=\Vect{x}_0$, which means that all terms
$(x-x_0)^{i}(y-y_0)^{j}$ with $i>0$ or $j>0$ vanish.  Only the
estimated function and its derivatives at location $\Vect{x}=\Vect{x}_0$ remain:
\begin{eqnarray}
  \label{eq:estderivs}
  \widehat{m}(x,y)&=&\sum_{i=1}^{r}\sum_{j=1}^{r-i}\widehat{\beta}_{ij} (x-x_0)^{i-1}(y-y_0)^{j-1}\\
  &=&\widehat{\beta}_{1,1}y
\end{eqnarray}
The remaining components of $\widehat{\beta}$ can  now be used to estimate
the values of the derivatives of $m$ in
\begin{eqnarray}
  \label{eq:estderiv}
  \widehat{\frac{\partial^{i+j} m}{\partial x^{i}\partial y^{j}}(x_0)}&=&(i-1)!(j-1)!\widehat{\beta}_{ij}, 
                                                              \quad i=1,\ldots,r, j=1,\ldots,r-i
\end{eqnarray}

%FIXME: correct index shifting of $i$ and $j$

\section{Implementation details}
\label{sec:impl}
Function \cmd{interp::locpoly()} returns estimated values of the
regression function as well as estimated partial derivatives up to
order 3 (Akima splines only need derivatives up to order 2). 
This access to the partial derivatives was the main intent
for writing this code as there are already many other local polynomial
regression implementations in R. Beside the univariate local
estimators \cmd{stats::ksmooth()}, \cmd{locpol::locPolSmootherC()} and
\cmd{KernSmooth::locpoly()} (the last two also return univariate
derivatives) the packages \cmd{locfit} and \cmd{sm} provide amongst
other things bivariate local regression methods. But to our knowledge
currently (spring 2022) no bivariate local regression estimators for
partial derivatives exists. 
%(TODO: double check). 
But anyhow, to be
used from within the C++ implementation of \cmd{interp::interp()} we
had to implement this estimator directly also in C++ in package {interp}.


This is a short overview (to be extend in a later version of this document) 
of the steps that had to be implemented:
\begin{itemize}
\item Formulate the normal equations for the above weighted least squares 
problem. 
\item Use package \cmd{RcppEigen} to perform the numeric solution. 
\item Package \cmd{RcppEigen} provides a sample implementaion \cmd{fastLm} to 
solve ordinary (unweighted) least squares problems. We just used this and 
extended it for the weighted case.  
\item \cmd{fastLm} has the option to use different solvers provided 
in \cmd{RcppEigen}. Our implementation inherits these options.
\end{itemize}


\section[Regular Grid]{Application To A Regular Grid}
\label{sec:regular}

We will test \texttt{locpoly()} now with a bicubic polynomial on the
unit square on a \texttt{ng} by \texttt{ng} grid. Later tests using
Franke functions will follow.

Set the $x$ - $y$ size of a square data grid to
<<>>=
ng <- 11
@
resulting in \Sexpr{ng*ng} grid points.

First let us choose a kernel
<<>>=
knl <- "gaussian"
@ 
Other Options would have been \texttt{"uniform"}, \texttt{"cosine"},
\texttt{"biweight"}, \texttt{"triweight"}, \texttt{"tricube"} and
\texttt{"epanechikov"}, compare section \ref{sec:kernels}.

Next both a fixed global and a varying local bandwidth is needed:
<<>>=
bwg <- 0.33  
bwl <- 0.11  
@ 
The global bandwidth (=\Sexpr{bwg}) is interpreted as ratio of the
$x$ and $y$ range respective. So in this example the ``moving window''
of the kernel function covers a rectangular data region of
$1/3\times 1/3=1/9$ of the bounding box of the data set.

The local bandwidth indicates the proportion of the data set choosen
as local search neighbourhood. Its value \Sexpr{bwl} has been choosen
to match the coverage of the global bandwidth above.

Now set the degree of the local polynomial model (maximum supported
value is 3)
<<>>=
dg=3
@
and define a bicubic polynomial:
<<>>=
f <- function(x,y) (x-0.5)*(x-0.2)*(y-0.6)*y*(x-1)
@
Now we prepare symbolic derivatives of $f$ both for calculating exact
values (via package \texttt{Deriv}) and for pretty printing (using
package \texttt{Ryacas}). The helper functions used for these
preparation steps are shown in appendix~\ref{sec:appendix}:
<<helperR2Yacas,echo=FALSE>>=
# helper functions for translation between R and Yacas
fn_y  <- function(f){
    b <- toString(as.expression(body(f)))
    b <- stringr::str_replace_all(b,"cos","Cos")
    b <- stringr::str_replace_all(b,"sin","Sin")
    b <- stringr::str_replace_all(b,"exp","Exp")
    b <- stringr::str_replace_all(b,"log","Log")
    b <- stringr::str_replace_all(b,"sqrt","Sqrt")
    b
}
@
<<helperYacas2R,echo=FALSE>>=
ys_fn  <- function(f){
    f <- stringr::str_replace_all(f,"Cos","cos")
    f <- stringr::str_replace_all(f,"Sin","sin")
    f <- stringr::str_replace_all(f,"Exp","exp")
    f <- stringr::str_replace_all(f,"Log","log")
    f <- stringr::str_replace_all(f,"Sqrt","sqrt")
    f
}
@
<<helperDerivs,echo=FALSE>>=
derivs <- function(f,dg){
    ret<-list(f=f,
              f_str=ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),""),")"))))

    if(dg>0){

        ret$fx <- function(x,y){
            myfx <- Deriv(f,"x");
            tmp <- myfx(x,y);
            if(length(tmp)==1)
                return(rep(tmp,length(x)))
            else
                return(tmp)
        }
        ret$fx_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)"),")")))


        ret$fy <- function(x,y){
            myfy <- Deriv(f,"y");
            tmp <- myfy(x,y);
            if(length(tmp)==1)
                return(rep(tmp,length(x)))
            else
                return(tmp)
        }
        ret$fy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(y)"),")")))


        if(dg>1){
            ret$fxy <- function(x,y){
                myfxy <- Deriv(Deriv(f,"y"),"x");
                tmp <- myfxy(x,y);
                if(length(tmp)==1)
                    return(rep(tmp,length(x)))
                else
                    return(tmp)
            }
            ret$fxy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(y)"),")")))

            ret$fxx <- function(x,y){
                myfxx <- Deriv(Deriv(f,"x"),"x");
                tmp <- myfxx(x,y);
                if(length(tmp)==1)
                    return(rep(tmp,length(x)))
                else
                    return(tmp)
            }
            ret$fxx_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(x)"),")")))

            ret$fyy <- function(x,y){
                myfyy <- Deriv(Deriv(f,"y"),"y");
                tmp <- myfyy(x,y);
                if(length(tmp)==1)
                    return(rep(tmp,length(x)))
                else
                    return(tmp)
            }
            ret$fyy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(y)D(y)"),")")))

            if(dg>2){
                ret$fxxy <- function(x,y){
                    myfxxy <- Deriv(Deriv(Deriv(f,"y"),"x"),"x");
                    tmp <- myfxxy(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fxxy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(x)D(y)"),")")))

                ret$fxyy <- function(x,y){
                    myfxyy <- Deriv(Deriv(Deriv(f,"y"),"y"),"x");
                    tmp <- myfxyy(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fxyy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(y)D(y)"),")")))

                ret$fxxx <- function(x,y){
                    myfxxx <- Deriv(Deriv(Deriv(f,"x"),"x"),"x");
                    tmp <- myfxxx(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fxxx_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(x)D(x)D(x)"),")")))

                ret$fyyy <- function(x,y){
                    myfyyy <- Deriv(Deriv(Deriv(f,"y"),"y"),"y");
                    tmp <- myfyyy(x,y);
                    if(length(tmp)==1)
                        return(rep(tmp,length(x)))
                    else
                        return(tmp)
                }
                ret$fyyy_str  <- ys_fn(yac(paste("Simplify(",y_fn(fn_y(f),"D(y)D(y)D(y)"),")")))
            }
        }
    }
    ret
}
@
<<>>=
df <- derivs(f,dg)
@
Now build and fill the grid with the theoretical values:
<<>>=
xg <- seq(0,1,length=ng)
yg <- seq(0,1,length=ng)
xyg <- expand.grid(xg,yg)
@
<<echo=false>>=
af=4
@
and prepare a finer grid for detailed plotting at a larger
resolution by increasing the grid density by factor \Sexpr{af} in both axes:
<<>>=
af <- 4
xfg <- seq(0,1,length=af*ng)
yfg <- seq(0,1,length=af*ng)
xyfg <- expand.grid(xfg,yfg)
@
Create coordinate matrices \texttt{xx} and \texttt{yy} as  matching the grid matrix \texttt{fg}
<<>>=
nx <- length(xg)
ny <- length(yg)
xx <- t(matrix(rep(xg,ny),nx,ny))
yy <- matrix(rep(yg,nx),ny,nx)
@
Now fill all exact results deriven from symbolic computation into the
grid matrices, again one of the helper functions from appendix
\ref{sec:appendix} is used:
<<helperGrid,echo=FALSE>>=
# for plots of exact values
fgrid <- function(f,xg,yg,dg){
  ret <- list(f=outer(xg,yg,f))
  df <- derivs(f,dg)
  if(dg>0){
    ret$fx  <- outer(xg,yg,df$fx)
    ret$fy  <- outer(xg,yg,df$fy)
    if(dg>1){
      ret$fxy <- outer(xg,yg,df$fxy)
      ret$fxx <- outer(xg,yg,df$fxx)
      ret$fyy <- outer(xg,yg,df$fyy)
      if(dg>2){
        ret$fxxy <- outer(xg,yg,df$fxxy)
        ret$fxyy <- outer(xg,yg,df$fxyy)
        ret$fxxx <- outer(xg,yg,df$fxxx)
        ret$fyyy <- outer(xg,yg,df$fyyy)
      }
    }
  }
  ret
}
@
<<>>=
## data for local regression
fg   <- outer(xg,yg,f)
## data for exact plots on fine grid
ffg <- fgrid(f,xfg,yfg,dg)
@
Now perform the local regression estimation, get both global and local
bandwidth results:
<<>>=
## global bandwidth:
pdg <- interp::locpoly(xg,yg,fg, input="grid", pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel=knl,nx=af*ng,ny=af*ng)
## local bandwidth:
pdl <- interp::locpoly(xg,yg,fg, input="grid", pd="all", h=bwl, solver="QR", degree=dg,kernel=knl,nx=af*ng,ny=af*ng)
@
<<helperSplit,echo=false>>=
split_str <- function(txt,l){
  start <- seq(1, nchar(txt), l)
  stop <- seq(l, nchar(txt)+l, l)[1:length(start)]
  substring(txt, start, stop)
}
@
<<helperImage,echo=false>>=
grid2df <- function(x,y,z)
    subset(data.frame(x = rep(x, nrow(z)),
                      y = rep(y, each = ncol(z)),
                      z = as.numeric(z)),
           !is.na(z))

gg1image2contours <- function(x,y,z1,z2,z3,xyg,ttl=""){
    breaks <- pretty(seq(min(z1,na.rm=T),max(z1,na.rm=T),length=11))
    griddf1 <- grid2df(x,y,z1)
    griddf2 <- grid2df(x,y,z2)
    griddf3 <- grid2df(x,y,z3)
    griddf  <- data.frame(x=griddf1$x,y=griddf1$y,z1=griddf1$z,z2=griddf2$z,z3=griddf3$z)
    ggplot(griddf, aes(x=x, y=y, z = z1)) +
        ggtitle(ttl) +
        theme(plot.title = element_text(size = 6, face = "bold"),
              axis.line=element_blank(),axis.text.x=element_blank(),
              axis.text.y=element_blank(),axis.ticks=element_blank(),
              axis.title.x=element_blank(),
              axis.title.y=element_blank(),legend.position="none",
              panel.background=element_blank(),panel.border=element_blank(),panel.grid.major=element_blank(),
              panel.grid.minor=element_blank(),plot.background=element_blank()) +
        geom_contour_filled(breaks=breaks) +
        scale_fill_brewer(palette = "YlOrRd") +
        geom_contour(aes(z=z2),breaks=breaks,color="green",lty="dashed",lwd=0.5) +
        geom_contour(aes(z=z3),breaks=breaks,color="blue",lty="dotted",lwd=0.5) +
        theme(legend.position="none") +
        geom_point(data=xyg, aes(x=Var1,y=Var2), inherit.aes = FALSE,size=1,pch="+")
}
@
<<helperPrint,echo=FALSE>>=
print_deriv <- function(txt,l,at=42){
    ret<-""
    for(t in txt){
        if(stringi::stri_length(t)<at)
            btxt <- t
        else
            btxt <- split_str(t,at)
        ftxt <- rep(paste(rep(" ",stringi::stri_length(l)),sep="",collapse=""),length(btxt))
        ftxt[1] <- l
        ret <- paste(ret,paste(ftxt,btxt,sep="",collapse = "\n"),sep="",collapse = "\n")
    }
    ret
}
print_f <- function(f,df,dg,offset=0.8){
  lns <- c(print_deriv(df$f_str,"f(x,y) ="))
  if(dg>=1)
    lns <- c(lns,
    print_deriv(df$fx_str,"f_x(x,y) ="),
    print_deriv(df$fy_str,"f_y(x,y) ="))
  if(dg>=2)
    lns <- c(lns,
    print_deriv(df$fxx_str,"f_xx(x,y) ="),
    print_deriv(df$fyy_str,"f_yy(x,y) ="),
    print_deriv(df$fxy_str,"f_xy(x,y) ="))
  if(dg>=3)
    lns <- c(lns,
    print_deriv(df$fxxx_str,"f_xxx(x,y) ="),
    print_deriv(df$fyyy_str,"f_yyy(x,y) ="),
    print_deriv(df$fxxy_str,"f_xxy(x,y) ="),
    print_deriv(df$fxyy_str,"f_xyy(x,y) ="))
  txt <- grid.text(paste(lns,
    collapse="\n"),gp=gpar(fontsize=8),
    x=0,y=offset,draw=FALSE,
    just = c("left","top"))
  txt
}
@
<<prepare1,echo=FALSE>>=
t1 <- grid.text(paste(c(paste("regular data grid",nx,"x",ny),
  "colors = exaxt values",
  "dashed green = global bw",
  "dotted blue = local bw",
  "crosses: data points"),collapse="\n"),
  gp=gpar(fontsize=8),
  x=0,y=0.8,draw=FALSE,
  just = c("left","top"))

t3 <- grid.text(paste(c(paste("kernel:",knl),
                        paste("global bandwidth",bwg*100,"%"),
                        paste("local bandwidth",bwl*100,"%")),
                      collapse="\n"),
                gp=gpar(fontsize=8),x=0,y=0.8,draw=FALSE,
                just = c("left","top"))

@
Now finally generate the plots. Again a collection of helper function
is used here to fit all 10 plots and descriptions in a single plot.
For interested users they are shown in the appendix.
<<>>=
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xyg,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xyg,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xyg,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xyg,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xyg,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xyg,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xyg,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xyg,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xyg,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xyg,"f_yyy")
## t1 and t3 contain pure texts generated hidden in this Sweave file.
## t2 contains aas much of the symbolic computation output as possible:
t2 <- print_f(f,df,3)
@
Now we use features of the gridExtra package to arrange all texts and plots:
<<label=plotbicubic>>=
lay<-rbind(c( 1, 2, 3, 3),
           c( 4, 5, 3, 3),
           c( 6, 7, 8, 9),
           c(10,11,12,13))
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)
@
For the resulting plot see figure \ref{fig:poly}. They show a colored background image
with two (a dashed green and a dotted blue) overlay of isolines.
The colored background represents the exact function resp. its exact derivatives.
Dashed green isolines are global bandwidth estimators, dotted blue isolines are local 
nearest neighbour estimates. All three overlays (colors and isolines) share the same 
step sizes for binning the colors and isoline levels.

Due to the nature of the different used functions only a varying part of 
the symbolic derivatives can be shown as text in the picture.


\begin{figure}[htb]
\centering
<<fig=TRUE,echo=FALSE,out.width='6in'>>=
<<plotbicubic>>
@ 
\caption{A bicubic polynomial and its derivatives, exact and estimated values, regular grid}
\label{fig:poly}
\end{figure}


Now the same steps are repeated for Franke function 1:
<<>>=
f <- function(x,y) 0.75*exp(-((9*x-2)^2+(9*y-2)^2)/4)+0.75*exp(-((9*x+1)^2)/49-(9*y+1)/10)+0.5*exp(-((9*x-7)^2+(9*y-3)^2)/4)-0.2*exp(-(9*x-4)^2-(9*y-7)^2)
fg  <- outer(xg,yg,f)
ffg <- fgrid(f,xfg,yfg,dg)
df  <- derivs(f,dg)
@
Again estimate with global and local bandwidth
<<>>=
## global bw,
pdg <- interp::locpoly(xg,yg,fg, input="grid", pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel=knl,nx=af*ng,ny=af*ng)
## local bw:
pdl <- interp::locpoly(xg,yg,fg, input="grid", pd="all", h=bwl, solver="QR", degree=dg,kernel=knl,nx=af*ng,ny=af*ng)
@ 
and repeat the plot. Technical details are now hidden and only the
plot is shown as the commands above are more or less repeated.
<<label=plotfranke1, echo=false>>=
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xyg,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xyg,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xyg,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xyg,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xyg,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xyg,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xyg,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xyg,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xyg,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xyg,"f_yyy")

t2 <- print_f(f,df,1,0.9)

gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix=lay)
@
Results are shown in figure \ref{fig:franke1}. The same interpretation for colors and isolines as in the first plot is applied.
\begin{figure}[htb]
\centering
<<fig=TRUE,echo=FALSE,out.width='6in'>>=
<<plotfranke1>>
@
\caption{Franke function 1 and its derivatives, exact and estimated values, regular grid}
\label{fig:franke1}
\end{figure}


\section[Irregular Grid]{Application To An Irregular Grid}
\label{sec:irreg}

Next we repeat the estmations with an irregular gridded data set using the
same number of $\Sexpr{ng}\times\Sexpr{ng}$=\Sexpr{ng*ng} points:
<<>>=
n <- ng*ng
@
Start with the same polynomial as in the last section:
<<>>=
f <- function(x,y) (x-0.5)*(x-0.2)*(y-0.6)*y*(x-1)
@
The kernel settings stay the same (\cmd{kernel=}"\Sexpr{knl}", global/local bandwidth \Sexpr{bwg}/\Sexpr{bwl}).
<<>>=
## random irregular data
x<-runif(n)
y<-runif(n)
xy<-data.frame(Var1=x,Var2=y)
z <- f(x,y)
@ 
Again fill the grids for plotting the exact values  
<<>>=
ffg <- fgrid(f,xfg,yfg,dg)
df <- derivs(f,dg)
@ 
and perform the estmation steps:
<<>>=
## global bandwidth
pdg <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel=knl)
## local bandwidth:
pdl <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=bwl, solver="QR", degree=dg,kernel=knl)
@ 
The remaining steps to generate the plots are again similar to the
first plot and therefore hidden. The output for the bicubic polynomial is shown in figure
\ref{fig:poly2}, results for Franke function 1 in figure \ref{fig:franke12}.
<<echo=false>>=
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xy,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xy,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xy,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xy,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xy,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xy,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xy,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xy,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xy,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xy,"f_yyy")

t1 <- grid.text(paste(c(paste("irregular data grid",n,"pts"),
  "colors = exaxt values",
  "dashed green = global bw",
  "dotted blue = local bw",
  "crosses: data points"),collapse="\n"),
  gp=gpar(fontsize=8),
  x=0,y=0.8,draw=FALSE,
  just = c("left","top"))

t2 <- print_f(f,df,3)
@
<<label=plotbicubic2,echo=false>>=
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)
@
\begin{figure}[htb]
\centering
<<fig=TRUE,echo=FALSE,out.width='6in'>>=
<<plotbicubic2>>
@
\caption{A bicubic polynomial and its derivatives, exact and estimated, irregular data set}
\label{fig:poly2}
\end{figure}
The results for Franke function 1 are shown in figure \ref{fig:franke12}. 
<<echo=false>>=
f <- function(x,y) 0.75*exp(-((9*x-2)^2+(9*y-2)^2)/4)+0.75*exp(-((9*x+1)^2)/49-(9*y+1)/10)+0.5*exp(-((9*x-7)^2+(9*y-3)^2)/4)-0.2*exp(-(9*x-4)^2-(9*y-7)^2)
@
<<echo=false>>=
z <- f(x,y)
fg  <- outer(xg,yg,f)
ffg <- fgrid(f,xfg,yfg,dg)
df <- derivs(f,dg)
@ 
<<echo=false>>=
## global bandwidth:
ttg <- system.time(pdg <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel=knl))

## local bandwidth:
ttl <- system.time(pdl <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=bwl, solver="QR", degree=dg,kernel=knl))
@ 
<<echo=false>>=
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xy,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xy,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xy,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xy,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xy,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xy,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xy,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xy,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xy,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xy,"f_yyy")

t2 <- print_f(f,df,1,0.9)
@
<<label=plotfranke12,echo=false>>=
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)
@
\begin{figure}[htb]
\centering
<<fig=TRUE,echo=FALSE,out.width='6in'>>=
<<plotfranke12>>
@
\caption{Franke function 1 and its derivatives, exact and estimated, irregular data set}
\label{fig:franke12}
\end{figure}

\section{Different Kernels}
\label{sec:kernels}
Now we try different kernels. We just continue with Franke function 1 and
the irregular gridded data from last section. We show the results of \cmd{kernel="uniform"} and 
\cmd{kernel="epanechnikov"} in figures \ref{fig:franke12unif} and \ref{fig:franke12epa}.
<<>>=
## global bandwidth:
pdg <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel="uniform")
## local bandwidth:
pdl <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=bwl, solver="QR", degree=dg,kernel="uniform")
@ 
<<echo=false>>=
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xy,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xy,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xy,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xy,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xy,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xy,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xy,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xy,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xy,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xy,"f_yyy")

t2 <- print_f(f,df,1,0.9)
t3 <- grid.text(paste(c(paste("kernel:","uniform"),
                        paste("global bandwidth",bwg*100,"%"),
                        paste("local bandwidth",bwl*100,"%")),
                      collapse="\n"),
                gp=gpar(fontsize=8),x=0,y=0.8,draw=FALSE,
                just = c("left","top"))

@
<<label=plotfranke12unif,echo=false>>=
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)
@
\begin{figure}[htb]
\centering
<<fig=TRUE,echo=FALSE,out.width='6in'>>=
<<plotfranke12unif>>
@
\caption{Franke function 1 and its derivatives, uniform kernel}
\label{fig:franke12unif}
\end{figure}
<<>>=
## global bandwidth:
pdg <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=c(bwg,bwg), solver="QR", degree=dg,kernel="epanechnikov")
## local bandwidth:
pdl <- interp::locpoly(x,y,z, xfg,yfg, pd="all", h=bwl, solver="QR", degree=dg,kernel="epanechnikov")
@ 
<<echo=false>>=
pf <- gg1image2contours(xfg,yfg,ffg$f,pdg$z,pdl$z,xy,"f")
pfx <- gg1image2contours(xfg,yfg,ffg$fx,pdg$zx,pdl$zx,xy,"f_x")
pfy <- gg1image2contours(xfg,yfg,ffg$fy,pdg$zy,pdl$zy,xy,"f_x")
pfxx <- gg1image2contours(xfg,yfg,ffg$fxx,pdg$zxx,pdl$zxx,xy,"f_xx")
pfxy <- gg1image2contours(xfg,yfg,ffg$fxy,pdg$zxy,pdl$zxy,xy,"f_xy")
pfyy <- gg1image2contours(xfg,yfg,ffg$fyy,pdg$zyy,pdl$zyy,xy,"f_yy")
pfxxx <- gg1image2contours(xfg,yfg,ffg$fxxx,pdg$zxxx,pdl$zxxx,xy,"f_xxx")
pfxxy <- gg1image2contours(xfg,yfg,ffg$fxxy,pdg$zxxy,pdl$zxxy,xy,"f_xxy")
pfxyy <- gg1image2contours(xfg,yfg,ffg$fxyy,pdg$zxyy,pdl$zxyy,xy,"f_xyy")
pfyyy <- gg1image2contours(xfg,yfg,ffg$fyyy,pdg$zyyy,pdl$zyyy,xy,"f_yyy")

t2 <- print_f(f,df,1,0.9)
t3 <- grid.text(paste(c(paste("kernel:","epanechnikov"),
                        paste("global bandwidth",bwg*100,"%"),
                        paste("local bandwidth",bwl*100,"%")),
                      collapse="\n"),
                gp=gpar(fontsize=8),x=0,y=0.8,draw=FALSE,
                just = c("left","top"))
@
<<label=plotfranke12epa,echo=false>>=
gg <- grid.arrange(grobs=gList(ggplotGrob(pf),t1,t2,ggplotGrob(pfx),ggplotGrob(pfy),ggplotGrob(pfxx),ggplotGrob(pfxy),ggplotGrob(pfyy),t3,ggplotGrob(pfxxx),ggplotGrob(pfxxy),ggplotGrob(pfxyy),ggplotGrob(pfyyy)),layout_matrix = lay)
@
\begin{figure}[htb]
\centering
<<fig=TRUE,echo=FALSE,out.width='6in'>>=
<<plotfranke12epa>>
@
\caption{Franke function 1 and its derivatives, epanechnikov kernel}
\label{fig:franke12epa}
\end{figure}
Especially the performance of the uniform kernel with its
discontinuous behavior at the borders of its support drops visibly. 
Globally spoken, the local bandwidth estimators capture more details, across all
kernels. But combined with a kernel with bounded support (uniform or
epanechnikov in the test) they show problems at the border of the
region. So the default setting of a gaussian kernel is well founded.
\section{Appendix}
\label{sec:appendix}

These helper functions are needed to convert between \proglang{R}  and  \proglang{Yacas}:
<<>>=
<<helperR2Yacas>>
<<helperYacas2R>>
@

This function applies symbolic derivatives to a \proglang{R} function,
both for later use as \proglang{R} function (via \pkg{Deriv}) and for
printing (via \pkg{Ryacas}).

<<>>=
<<helperDerivs>>
@

The next function calculates exact values of the given function on a
grid and fills it with partial derivatives up to degree \proglang{dg}.

<<>>=
<<helperGrid>>
@

Another helper function for formatting function expressions in the plots:
<<>>=
<<helperSplit>>
@

The combination of image and contour plots are generated by these functions:
<<>>=
<<helperImage>>
@

The expressions for the functions and their derivatives are printed via:
<<>>=
<<helperPrint>>
@

\bibliography{lit}

\addcontentsline{toc}{section}{Tables}
\listoftables
\addcontentsline{toc}{section}{Figures}
\listoffigures

\end{document}

\name{plot.voronoi.polygons}
\alias{plot.voronoi.polygons}
\title{plots an voronoi.polygons object}
\description{
  plots an \code{voronoi.polygons} object
}
\usage{
\method{plot}{voronoi.polygons}(x, which, color=TRUE, isometric=TRUE, ...)
}
\arguments{
  \item{x}{ object of class \code{voronoi.polygons}  }
  \item{which}{ index vector selecting which polygons to plot }
  \item{color}{ logical, determines if plot should be colored, default:
    \code{TRUE} }
  \item{isometric}{generate an isometric plot (default \code{TRUE})}
  \item{\dots}{ additional plot arguments }
}
\author{ A. Gebhardt}
\seealso{ \code{\link{voronoi.polygons}}}
\examples{
data(franke)
fd3 <- franke$ds3
fd3.vm <- voronoi.mosaic(fd3$x,fd3$y)
fd3.vp <- voronoi.polygons(fd3.vm)
plot(fd3.vp)
plot(fd3.vp,which=c(3,4,6,10))
}
\keyword{ spatial }% at least one, from doc/KEYWORDS

\name{plot.triSht}
\title{Plot a triangulation object}
\usage{\method{plot}{triSht}(x, add = FALSE, xlim = range(x$x),
  ylim = range(x$y), do.points = TRUE, do.labels = FALSE, isometric = TRUE,
  do.circumcircles = FALSE, segment.lty = "dashed", circle.lty =
  "dotted", ...)
}
\alias{plot.triSht}
\arguments{
  \item{x}{object of class \code{"triSht"}}
  \item{add}{logical, if \code{TRUE}, add to a current plot.}
  \item{do.points}{logical, indicates if points should be
    plotted. (default \code{TRUE})}
  \item{do.labels}{logical, indicates if points should be labelled.
    (default \code{FALSE})}
  \item{xlim,ylim}{x/y ranges for plot}
  \item{isometric}{generate an isometric plot (default \code{TRUE})}
  \item{do.circumcircles}{logical, indicates if circumcircles should be
    plotted (default \code{FALSE})}
  \item{segment.lty}{line type for triangulation segments}
  \item{circle.lty}{line type for circumcircles}
  \item{...}{additional plot parameters}
}
\description{plots the triangulation object \code{"x"}
}
\value{None
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{triSht}}, \code{\link{print.triSht}},
  \code{\link{summary.triSht}}
}
\examples{
## random points
plot(tri.mesh(rpois(100,lambda=20),rpois(100,lambda=20),duplicate="remove"))
## use a part of the quakes data set:
data(quakes)
quakes.part<-quakes[(quakes[,1]<=-10.78 & quakes[,1]>=-19.4 &
                     quakes[,2]<=182.29 & quakes[,2]>=165.77),]
quakes.tri<-tri.mesh(quakes.part$lon, quakes.part$lat, duplicate="remove")
plot(quakes.tri)
## use the whole quakes data set
## (will not work with standard memory settings, hence commented out)
## plot(tri.mesh(quakes$lon, quakes$lat, duplicate="remove"), do.points=F)
}
\keyword{spatial}

\name{triangles}
\alias{triangles}
\title{Extract a list of triangles from a triangulation object}
\usage{triangles(tri.obj)
}
\arguments{
  \item{tri.obj}{object of class \code{\link{triSht}}}
}
\description{
  This function extracts a list of triangles
  from an triangulation object created by \code{tri.mesh}.
}
\details{
  The vertices in the returned matrix (let's denote it with
  \code{retval}) are ordered counterclockwise.  The columns \code{tr}\eqn{x}
  and \code{arc}\eqn{x}, \eqn{x=1,2,3} index the triangle and arc, respectively,
  which are opposite (not shared by) node \code{node}\eqn{x}, with
  \code{tri}\eqn{x=0} if \code{arc}\eqn{x} indexes a boundary arc.  Vertex indexes
  range from 1 to \eqn{n}, the number of nodes, triangle indexes from 0
  to \eqn{nt}, and arc indexes from 1 to \eqn{na = nt+n-1}.
}

\value{
  A matrix with columns \code{node1}, \code{node2}, \code{node3},
  representing the vertex nodal indexes,
  \code{tr1}, \code{tr2}, \code{tr3}, representing neighboring triangle
  indexes and \code{arc1}, \code{arc2}, \code{arc3} reresenting arc
  indexes.

  Each row represents one triangle.
}
%\references{
%}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{triSht}}, \code{\link{print.triSht}},
  \code{\link{plot.triSht}}, \code{\link{summary.triSht}},
  \code{\link{triangles}}
}
\examples{
# use the smallest Franke data set
data(franke)
fr3.tr<-tri.mesh(franke$ds3$x, franke$ds3$y)
triangles(fr3.tr)
}
\keyword{spatial}

\name{nearest.neighbours}
\alias{nearest.neighbours}
\title{
  Nearest neighbour structure for a data set
}
\description{
  This function can be used to generate nearest neighbour information
  for a set of 2D data points.
}
\usage{
nearest.neighbours(x, y)
}

\arguments{
  \item{x}{
    vector containing \eqn{x} ccordinates of points.
  }
  \item{y}{
    vector containing \eqn{x} ccordinates of points.
  }
}
\details{
  The C++ implementation of this function is used inside the
  \code{\link{locpoly}} and \code{\link{interp}} functions.
}
\value{
  A list with two components
  \item{index}{
    A matrix with one row per data point. Each row contains the indices
    of the nearest neigbours to the point associated with this row, 
    currently the point itself is also listed in the first row, so
    this matrix is of dimension \eqn{n} times \eqn{n} (will change to
    \eqn{n} times \eqn{n-1} later).
  }
  \item{dist}{
    A matrix containing the distances according to the neigbours listed
    in component \code{index}.
  }
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}


\seealso{
  \code{\link{convex.hull}}
}
\examples{
data(franke)
## use only a small subset
fd <- franke$ds1[1:5,]
nearest.neighbours(fd$x,fd$y)
}
\keyword{ utilities }

\name{plot.voronoi}
\title{Plot a voronoi object}
\usage{\method{plot}{voronoi}(x,add=FALSE,
                           xlim=c(min(x$tri$x)-
                             0.1*diff(range(x$tri$x)),
                             max(x$tri$x)+
                             0.1*diff(range(x$tri$x))),
                           ylim=c(min(x$tri$y)-
                             0.1*diff(range(x$tri$y)),
                             max(x$tri$y)+
                             0.1*diff(range(x$tri$y))),
                           all=FALSE,
                           do.points=TRUE,
                           main="Voronoi mosaic",
                           sub=deparse(substitute(x)),
                           isometric=TRUE,
                           ...)
}
\alias{plot.voronoi}
\arguments{
  \item{x}{object of class \code{"voronoi"}}
  \item{add}{logical, if \code{TRUE}, add to a current plot.}
  \item{xlim}{x plot ranges, by default modified to hide dummy 
        points outside of the plot}
  \item{ylim}{y plot ranges, by default modified to hide dummy 
        points outside of the plot}
  \item{all}{show all (including dummy points in the plot}
  \item{do.points}{logical, indicates if points should be plotted.}
  \item{main}{plot title}
  \item{sub}{plot subtitle}
  \item{isometric}{generate an isometric plot (default \code{TRUE})}
  \item{...}{additional plot parameters}
}
\description{Plots the mosaic \code{"x"}.
  Dashed lines are used for outer tiles of the mosaic.
}
\value{None
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{voronoi}}, \code{\link{print.voronoi}}, 
  \code{\link{summary.voronoi}}, \code{\link{plot.voronoi.polygons}} 
}
\examples{
data(franke)
tr <- tri.mesh(franke$ds3)
vr <- voronoi.mosaic(tr)
plot(tr)
plot(vr,add=TRUE)
}
\keyword{spatial}

\name{voronoi.findrejectsites}
\title{Find the Voronoi sites at the border of the region (to be rejected).}
\author{S. J. Eglen}
\usage{voronoi.findrejectsites(voronoi.obj, xmin, xmax, ymin, ymax)
}
\alias{voronoi.findrejectsites}
\arguments{
  \item{voronoi.obj}{object of class \code{"voronoi"}}
  \item{xmin}{minimum x-coordinate of sites in the region}
  \item{xmax}{maximum x-coordinate of sites in the region}
  \item{ymin}{minimum y-coordinate of sites in the region}
  \item{ymax}{maximum y-coordinate of sites in the region}

}
\description{Find the sites in the Voronoi tesselation that lie at the
  edge of the region.  A site is at the edge if any of the vertices of
  its Voronoi polygon lie outside the rectangle with corners (xmin,ymin)
  and (xmax,ymax).
}
\value{A logical vector of the same length as the number of sites.  If
  the site is a reject, the corresponding element of the vector is set
  to TRUE.}
\seealso{
  \code{\link{voronoi.polygons}}
}
\keyword{spatial}

\name{voronoi.area}
\title{Calculate area of Voronoi polygons}
\author{S. J. Eglen}
\usage{voronoi.area(voronoi.obj)
}
\alias{voronoi.area}
\arguments{
  \item{voronoi.obj}{object of class \code{"voronoi"}}
}
\description{Computes the area of each Voronoi polygon.
For some sites at the edge of the region, the Voronoi polygon is not
bounded, and so the area of those sites cannot be calculated, and hence
will be \code{NA}.
}
\value{A vector of polygon areas.}
\seealso{
  \code{\link{voronoi.mosaic}},\code{\link{voronoi.polygons}},
}
\keyword{spatial}

\examples{
data(franke)
fd3 <- franke$ds3
fd3.vm <- voronoi.mosaic(fd3$x,fd3$y)
fd3.vm.areas <- voronoi.area(fd3.vm)
plot(fd3.vm)
text(fd3$x, fd3$y, round(fd3.vm.areas,5))
}

\name{interp}
\alias{interp}
\title{
  Interpolation function
}
\description{
  This function currently implements piecewise linear interpolation
  (=barycentric interpolation).
}
\usage{
interp(x, y = NULL, z, xo = seq(min(x), max(x), length = nx),
       yo = seq(min(y), max(y), length = ny),
       linear = (method == "linear"), extrap = FALSE,
       duplicate = "error", dupfun = NULL,
       nx = 40, ny = 40, input="points", output = "grid",
       method = "linear", deltri = "shull", h=0,
       kernel="gaussian", solver="QR", degree=3,
       baryweight=TRUE, autodegree=FALSE, adtol=0.1,
       smoothpde=FALSE, akimaweight=TRUE, nweight=25)
}
\arguments{
  \item{x}{
    vector of \eqn{x}-coordinates of data points or a
    \code{SpatialPointsDataFrame} object.
    Missing values are not accepted.
}
  \item{y}{
    vector of \eqn{y}-coordinates of data points.
    Missing values are not accepted.

    If left as NULL indicates that \code{x} should be a
    \code{SpatialPointsDataFrame} and \code{z} names the variable of
    interest in this dataframe.
}
  \item{z}{
    vector of \eqn{z}-values at data points or a character variable
    naming the variable of interest in the
    \code{SpatialPointsDataFrame} \code{x}.

    Missing values are not accepted.

    \code{x}, \code{y}, and \code{z} must be the same length
    (execpt if \code{x} is a \code{SpatialPointsDataFrame}) and may
    contain no fewer than four points. The points of \code{x} and
    \code{y} should not be collinear, i.e, they should not fall on the same line
    (two vectors \code{x} and \code{y} such that \code{y = ax + b} for
    some \code{a}, \code{b} will not produce menaningful results).


    \code{interp} is
    meant for cases in which you have \eqn{x}, \eqn{y} values
    scattered over a plane and a \eqn{z} value for each.  If, instead,
    you are trying to evaluate a mathematical function, or get a
    graphical interpretation of relationships that can be described by a
    polynomial, try \code{\link{outer}}.
  }
  \item{xo}{
    If \code{output="grid"} (default): sequence of \eqn{x} locations for
    rectangular output grid, defaults to \code{nx} points between
    \code{min(x)} and \code{max(x)}.

    If \code{output="points"}: vector of \eqn{x} locations for output points.
  }
  \item{yo}{
    If \code{output="grid"} (default): sequence of \eqn{y} locations for
    rectangular output grid, defaults to \code{ny} points between
    \code{min(y)} and \code{max(y)}.

    If \code{output="points"}: vector of \eqn{y} locations for output
    points. In this case it has to be same length as \code{xo}.
  }
  \item{input}{
    text, possible values are \code{"grid"} (not yet implemented) and
    \code{"points"} (default).

    This is used to distinguish between regular and irregular gridded data.
  }
  \item{output}{
    text, possible values are \code{"grid"} (=default) and
    \code{"points"}.

    If \code{"grid"} is choosen then \code{xo} and \code{yo} are
    interpreted as vectors spanning a rectangular grid of points
    \eqn{(xo[i],yo[j])}, \eqn{i=1,...,nx}, \eqn{j=1,...,ny}. This
    default behaviour matches how \code{akima::interp} works.

    In the case of \code{"points"}  \code{xo} and \code{yo} have to be
    of same length and are taken as possibly irregular spaced output
    points \eqn{(xo[i],yo[i])}, \eqn{i=1,...,no} with
    \code{no=length(xo)}. \code{nx} and \code{ny} are ignored in this
    case. This case is meant as replacement for the pointwise
    interpolation done by \code{akima::interpp}. If the input \code{x}
    is a \code{SpatialPointsDataFrame} and \code{output="points"} then
    \code{xo} has to be a \code{SpatialPointsDataFrame}, \code{yo} will
    be ignored.
  }
  \item{linear}{
    logical, only for backward compatibility with \code{akima::interp},
    indicates if piecewise linear interpolation or Akima splines should be
    used. 

    Please use the new \code{method} argument instead!
  }
  \item{method}{
    text, possible methods are (currently only, more is under
    developement) \code{"linear"} (piecewise linear interpolation within
    the triangles of the Delauney triangulation, also
    referred to as barycentric interpolation based on barycentric 
    coordinates) and \code{"akima"} (a reimplementation for Akimas spline 
    algorithms for irregular gridded data with the accuracy of a 
    bicubic polynomial).

    This replaces the old \code{linear} argument of \code{akima::interp}.
  }
  \item{extrap}{
    logical, indicates if extrapolation outside the convex hull is
    intended, will not work for piecewise linear interpolation!
  }
  \item{duplicate}{
    character string indicating how to handle duplicate
    data points. Possible values are
    \describe{
      \item{\code{"error"}}{produces an error message,}
      \item{\code{"strip"}}{remove duplicate z values,}
      \item{\code{"mean"},\code{"median"},\code{"user"}}{calculate
	mean , median or user defined function (\code{dupfun}) of duplicate
	\eqn{z} values.}
    }
  }
  \item{dupfun}{
    a function, applied to duplicate points if
    \code{duplicate= "user"}.}
  \item{nx}{
    dimension of output grid in x direction
  }
  \item{ny}{
    dimension of output grid in y direction
  }
  \item{deltri}{
    triangulation method used, this argument will later be moved
    into a control set together with others related to the spline
    interpolation! Possible values are \code{"shull"} (default, sweep 
    hull algorithm) and \code{"deldir"} (uses package\code{deldir}).
  }
  \item{h}{bandwidth for partial derivatives estimation, compare \code{\link{locpoly}} for details}

  \item{kernel}{kernel for partial derivatives estimation, compare \code{\link{locpoly}} for details}

  \item{solver}{solver used in partial derivatives estimation, compare \code{\link{locpoly}} for details}
  \item{degree}{degree of local polynomial used for partial derivatives
    estimation, compare \code{\link{locpoly}} for details}
  \item{baryweight}{calculate three partial derivatives estimatiors and
    weight them}
  \item{autodegree}{try to reduce degree automatically}
  \item{adtol}{used for autodegree}
  \item{smoothpde}{Use a an averaged version of partial derivatives
    estimates, by default simple average of \code{nweight} estimates.

    Currently disabled by default (FALSE), underlying code still a bit 
    experimental.
  }

  \item{akimaweight}{apply Akima weighting scheme on partial derivatives
    estimations instead of simply averaging}
  \item{nweight}{size of search neighbourhood for weighting scheme,
    default: 25}
}
%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
\value{
  a list with 3 components:
  \item{x,y}{
    If \code{output="grid"}:
    vectors of \eqn{x}- and \eqn{y}-coordinates of output grid, the same
    as the input
    argument \code{xo}, or \code{yo}, if present.  Otherwise, their
    default, a vector 40 points evenly spaced over the range of the
    input \code{x} and \code{y}.

    If \code{output="points"}: vectors of \eqn{x}- and \eqn{y}-coordinates of
    output points as given by \code{xo} and \code{yo}.
    }
  \item{z}{
    If \code{output="grid"}:
    matrix of fitted \eqn{z}-values.  The value \code{z[i,j]} is computed
    at the point \eqn{(xo[i], yo[j])}. \code{z} has
    dimensions \code{length(xo)} times \code{length(yo)}.

    If \code{output="points"}: a vector with the calculated z values for
    the output points as given by \code{xo} and \code{yo}.

    If the input was a \code{SpatialPointsDataFrame} a
    \code{SpatialPixelsDataFrame} is returned for \code{output="grid"}
    and a  \code{SpatialPointsDataFrame}  for \code{output="points"}.
  }
}
\references{
  Moebius, A. F. (1827) Der barymetrische Calcul. Verlag v. Johann
  Ambrosius Barth, Leipzig,
  https://books.google.at/books?id=eFPluv_UqFEC&hl=de&pg=PR1#v=onepage&q&f=false

  Franke, R., (1979). A critical comparison of some methods for interpolation
  of scattered data. Tech. Rep. NPS-53-79-003, Dept. of Mathematics, Naval
  Postgraduate School, Monterey, Calif.


  Akima, H. (1978). A Method of Bivariate Interpolation and
  Smooth Surface Fitting for Irregularly Distributed Data Points.
  ACM Transactions on Mathematical Software \bold{4}, 148-164.

  Akima, H. (1996). Algorithm 761: scattered-data surface fitting that has
  the accuracy of a cubic polynomial.
  ACM Transactions on Mathematical Software \bold{22}, 362--371.

}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\note{
Please note that this function tries to be a replacement for the interp() function 
from the akima package. So it should be call compatible for most applications. 
It also offers additional tuning parameters, usually the default settings will fit.
Please be aware that these additional parameters may change in the future as they are
still under development.
}

\seealso{
  \code{\link{interpp}}
}
\examples{
### Use all datasets from Franke, 1979:
data(franke)
## x-y irregular grid points:
oldseed <- set.seed(42)
ni <- 64
xi <- runif(ni,0,1)
yi <- runif(ni,0,1)
xyi <- cbind(xi,yi)
## linear interpolation
fi <- franke.fn(xi,yi,1)
IL <- interp(xi,yi,fi,nx=80,ny=80,method="linear")
## prepare breaks and colors that match for image and contour:
breaks <- pretty(seq(min(IL$z,na.rm=TRUE),max(IL$z,na.rm=TRUE),length=11))
db <- breaks[2]-breaks[1]
nb <- length(breaks)
breaks <- c(breaks[1]-db,breaks,breaks[nb]+db)
colors <- terrain.colors(length(breaks)-1)
image(IL,breaks=breaks,col=colors,main="Franke function 1",
      sub=paste("linear interpolation, ", ni,"points"))
contour(IL,add=TRUE,levels=breaks)
points(xi,yi)
## spline interpolation
fi <- franke.fn(xi,yi,1)
IS <- interp(xi,yi,fi,method="akima",
             kernel="gaussian",solver="QR")
## prepare breaks and colors that match for image and contour:
breaks <- pretty(seq(min(IS$z,na.rm=TRUE),max(IS$z,na.rm=TRUE),length=11))
db <- breaks[2]-breaks[1]
nb <- length(breaks)
breaks <- c(breaks[1]-db,breaks,breaks[nb]+db)
colors <- terrain.colors(length(breaks)-1)
image(IS,breaks=breaks,col=colors,main="Franke function 1",
      sub=paste("spline interpolation, ", ni,"points"))
contour(IS,add=TRUE,levels=breaks)
        points(xi,yi)
## regular grid:
nx <- 8; ny <- 8
xg<-seq(0,1,length=nx)
yg<-seq(0,1,length=ny)
xx <- t(matrix(rep(xg,ny),nx,ny))
yy <- matrix(rep(yg,nx),ny,nx)
xyg<-expand.grid(xg,yg)
## linear interpolation
fg <- outer(xg,yg,function(x,y)franke.fn(x,y,1))
IL <- interp(xg,yg,fg,input="grid",method="linear")
## prepare breaks and colors that match for image and contour:
breaks <- pretty(seq(min(IL$z,na.rm=TRUE),max(IL$z,na.rm=TRUE),length=11))
db <- breaks[2]-breaks[1]
nb <- length(breaks)
breaks <- c(breaks[1]-db,breaks,breaks[nb]+db)
colors <- terrain.colors(length(breaks)-1)
image(IL,breaks=breaks,col=colors,main="Franke function 1",
      sub=paste("linear interpolation, ", nx,"x",ny,"points"))
contour(IL,add=TRUE,levels=breaks)
points(xx,yy)
## spline interpolation
fg <- outer(xg,yg,function(x,y)franke.fn(x,y,1))
IS <- interp(xg,yg,fg,input="grid",method="akima",
             kernel="gaussian",solver="QR")
## prepare breaks and colors that match for image and contour:
breaks <- pretty(seq(min(IS$z,na.rm=TRUE),max(IS$z,na.rm=TRUE),length=11))
db <- breaks[2]-breaks[1]
nb <- length(breaks)
breaks <- c(breaks[1]-db,breaks,breaks[nb]+db)
colors <- terrain.colors(length(breaks)-1)
image(IS,breaks=breaks,col=colors,main="Franke function 1",
      sub=paste("spline interpolation, ", nx,"x",ny,"points"))
contour(IS,add=TRUE,levels=breaks)
        points(xx,yy)
set.seed(oldseed)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ dplot }
\keyword{ math }

\name{triSht}
\title{A triangulation object}
\alias{triSht}
\description{
  R object that represents the triangulation of a set of 2D points,
  generated by \code{\link{tri.mesh}}.
}
\arguments{
  \item{n}{Number of nodes}
  \item{x}{\eqn{x} coordinates of the triangulation nodes}
  \item{y}{\eqn{y} coordinates of the triangulation nodes}
  \item{nt}{number of triangles}
  \item{trlist}{Matrix of indices which defines the triangulation,
    each row corresponds to a triangle.

    Columns \code{i1}, \code{i2}, \code{i3} of the row \eqn{i} contain
    the node indices defining the \eqn{i}th triangle.

    Columns \code{j1}, \code{j2}, \code{j3} of the row \eqn{i} contain
    the indices of neighbour triangles (or 0 if no neighbour available
    along the convex hull).

    Columns \code{k1}, \code{k2}, \code{k3} of the row \eqn{i} contain
    the indices of the arcs of the \eqn{i}th triangle as returned by the
    \code{\link{arcs}} function.
  }
  \item{cclist}{
    Matrix describing the circumcircles and triangles.

    Columns \code{x} and \code{y} contain coordinates of the
    circumcircle centers, \code{r} is the circumcircle radius.

    \code{area} is the triangle area and \code{ratio} is the ratio of
    the radius of the inscribed circle to the circumcircle radius. It
    takes it maximum value 0.5 for an equilateral triangle.

    The radius of the inscribed circle can be get via
    \eqn{r_i=\frac{r}{ratio}}.
  }
  \item{nchull}{number of points on the convex hull}
  \item{chull}{
    A vector containing the indices of nodes forming the convec hull (in
    counterclockwise ordering).
  }
  \item{narcs}{number of arcs forming the triangulation}
  \item{arcs}{A matrix with node indices describing the arcs, contains
    two columns \code{from} and \code{to}.
  }
  \item{call}{call, which generated this object}
}
\note{
  This object is not backward compatible with \code{tri} objects generated
  from package \code{tripack} but the functions and methods are! So you
  have to regenerate these objects and then you can continue to use the
  same calls as before.

  The only difference is that no constraints to the triangulation are
  possible in package \code{interp}.

  Function \code{triSht2tri} provides an option to convert this object into
  the older form from package \code{tripack}, but it will not generate exact
  copies as if the object would have been created with \code{tripack::tri.mesh}!
  The old data structure consists of three lists describing adjacency lists
  of triangulation nodes in counterclockwise order, the translation function 
  only genrates such a valid (but not unique) description. 
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{tri.mesh}}, \code{\link{print.triSht}},\code{\link{triSht2tri}}, 
  \code{\link{plot.triSht}}, \code{\link{summary.triSht}}
}
\keyword{spatial}

\name{interp2xyz}
\alias{interp2xyz}
\title{From interp() Result, Produce 3-column Matrix}
\description{
  From an \code{\link{interp}()} result, produce a 3-column matrix
  or \code{\link{data.frame}} \code{cbind(x, y, z)}.
}
\usage{
interp2xyz(al, data.frame = FALSE)
}
\arguments{
  \item{al}{a \code{\link{list}} as produced from \code{\link{interp}()}.}
  \item{data.frame}{logical indicating if result should be
    \link{data.frame} or matrix (default).}
}
\value{
  a matrix (or data.frame) with three columns, called
  \code{"x"}, \code{"y"}, \code{"z"}.
}
\author{
  Martin Maechler, Jan.18, 2013
}
\seealso{
  \code{\link{expand.grid}()} is the \dQuote{essential ingredient} of
  \code{interp2xyz()}.

  \code{\link{interp}}.
}
\examples{
data(akima)
ak.spl <- with(akima, interp(x, y, z, method = "akima"))
str(ak.spl)# list (x[i], y[j], z = <matrix>[i,j])

## Now transform to simple  (x,y,z)  matrix / data.frame :
str(am <- interp2xyz(ak.spl))
str(ad <- interp2xyz(ak.spl, data.frame=TRUE))
## and they are the same:
stopifnot( am == ad | (is.na(am) & is.na(ad)) )
}
\keyword{manip}

\name{akima474}
\alias{akima474}
\title{
Sample data from Akima's Bicubic Spline Interpolation code (TOMS 474)
}
\description{
\code{akima474} is a list with vector components \code{x}, \code{y} and a matrix \code{z} which
represents a smooth surface of \code{z} values at the points
of a regular grid spanned by the vectors \code{x} and \code{y}.

}
\references{
Hiroshi Akima, Bivariate Interpolation and
Smooth Surface Fitting Based
on Local Procedures [E2], 
Communications of ACM,
Vol. 17, No. 1, January 1974, pp. 26-30
}
\examples{
\dontrun{
library(rgl)
data(akima474)
# data
rgl.spheres(akima474$x,akima474$z , akima474$y,0.5,color="red")
rgl.bbox()
# bivariate linear interpolation
# interp:
akima474.li <- interp(akima474$x, akima474$y, akima474$z, 
                   xo=seq(min(akima474$x), max(akima474$x), length = 100),
                   yo=seq(min(akima474$y), max(akima474$y), length = 100))
# interp surface:
rgl.surface(akima474.li$x,akima474.li$y,akima474.li$z,color="green",alpha=c(0.5))
# interpp:
akima474.p <- interpp(akima474$x, akima474$y, akima474$z,
                    runif(200,min(akima474$x),max(akima474$x)),
                    runif(200,min(akima474$y),max(akima474$y)))
# interpp points:
rgl.points(akima474.p$x,akima474.p$z , akima474.p$y,size=4,color="yellow")

# bivariate spline interpolation
# data
rgl.spheres(akima474$x,akima474$z , akima474$y,0.5,color="red")
rgl.bbox()
# bivariate cubic spline interpolation
# interp:
akima474.si <- interp(akima474$x, akima474$y, akima474$z, 
                   xo=seq(min(akima474$x), max(akima474$x), length = 100),
                   yo=seq(min(akima474$y), max(akima474$y), length = 100),
                   linear = FALSE, extrap = TRUE)
# interp surface:
rgl.surface(akima474.si$x,akima474.si$y,akima474.si$z,color="green",alpha=c(0.5))
# interpp:
akima474.sp <- interpp(akima474$x, akima474$y, akima474$z,
                    runif(200,min(akima474$x),max(akima474$x)),
                    runif(200,min(akima474$y),max(akima474$y)),
                   linear = FALSE, extrap = TRUE)
# interpp points:
rgl.points(akima474.sp$x,akima474.sp$z , akima474.sp$y,size=4,color="yellow")

}
}
\keyword{datasets}
% Converted by Sd2Rd version 0.2-a3.

\name{bicubic}
\alias{bicubic}
\title{
  Bivariate Interpolation for Data on a Rectangular grid
}
\description{
This is a placeholder function for backward compatibility with packaga akima.

In its current state it simply calls the reimplemented Akima algorithm for
irregular grids applied to the regular gridded data given.

Later a reimplementation of the original algorithm for regular grids may follow.
}
\usage{
bicubic(x, y, z, x0, y0)
}

\arguments{
  \item{x}{
    a vector containing the \code{x} coordinates of the rectangular data grid.
  }
  \item{y}{
    a vector containing the \code{y} coordinates of the rectangular data grid.
  }
  \item{z}{
    a matrix containing the \code{z[i,j]} data values for the grid points (\code{x[i]},\code{y[j]}).
  }
  \item{x0}{
    vector of \code{x} coordinates used to interpolate at.
  }
  \item{y0}{
    vector of \code{y} coordinates used to interpolate at.
  }
}
\details{
  This function is a call wrapper for backward compatibility with package akima.

  Currently it applies Akimas irregular grid splines to regular grids, later 
  a FOSS reimplementation of his regular grid splines may replace this wrapper.
}
\value{
  This function produces a list of interpolated points:
  \item{x}{vector of \code{x} coordinates.}
  \item{y}{vector of \code{y} coordinates.}
  \item{z}{vector of interpolated data \code{z}.}
  If you need an output grid, see \code{\link{bicubic.grid}}.
}
\references{
  Akima, H. (1996) Rectangular-Grid-Data
  Surface Fitting that Has the Accuracy of a
  Bicubic Polynomial,
  J. ACM \bold{22}(3), 357-361
}
\note{
  Use \code{\link{interp}} for the general case of irregular gridded data!
}

\seealso{
  \code{\link{interp}}, \code{\link{bicubic.grid}}
  % maybe later:
  % \code{\link[rgeostat]{bilinear}}
}
\examples{
data(akima474)
# interpolate at the diagonal of the grid [0,8]x[0,10]
akima.bic <- bicubic(akima474$x,akima474$y,akima474$z,
                     seq(0,8,length=50), seq(0,10,length=50))
plot(sqrt(akima.bic$x^2+akima.bic$y^2), akima.bic$z, type="l")

}

\keyword{ dplot }

\name{bilinear}
\alias{bilinear}
\alias{BiLinear}
\title{
  Bilinear Interpolation for Data on a Rectangular grid
}
\description{
  This is an implementation of a bilinear interpolating function.

  For a point (x0,y0) contained in a rectangle (x1,y1),(x2,y1),
  (x2,y2),(x1,y2) and x1<x2, y1<y2, the first step is to get z()
  at locations (x0,y1) and (x0,y2) as convex linear combinations
  z(x0,y*)=a*z(x1,y*)+(1-a)*z(x2,y*) where a=(x2-x1)/(x0-x1) for
  y*=y1,y2. In a second step z(x0,y0) is calculated as convex linear
  combination between z(x0,y1) and z(x0,y2) as
  z(x0,y1)=b*z(x0,y1)+(1-b)*z(x0,y2)  where b=(y2-y1)/(y0-y1).

  Finally, z(x0,y0) is a convex linear combination of the z values at
  the corners of the containing  rectangle with weights according to
  the distance from (x0,y0) to these corners.

  The grid lines can be unevenly spaced.

}
\usage{
bilinear(x, y, z, x0, y0)
BiLinear(x, y, z, x0, y0)
}

\arguments{
  \item{x}{
    a vector containing the \code{x} coordinates of the rectangular data grid.
  }
  \item{y}{
    a vector containing the \code{y} coordinates of the rectangular data grid.
  }
  \item{z}{
    a matrix containing the \code{z[i,j]} data values for the grid points (\code{x[i]},\code{y[j]}).
  }
  \item{x0}{
    vector of \code{x} coordinates used to interpolate at.
  }
  \item{y0}{
    vector of \code{y} coordinates used to interpolate at.
  }
}
\note{
  This Fortran function was part of the akima package but not related to 
  any of Akimas algorithms and under GPL. So it could be transfered
  into the interp package without changes.

  \code{BiLinear} is a C++ reimplementation, maybe it will replace the Fortran 
  implementation later, so
  its name may change in futrure versions.
}
\value{
  This function produces a list of interpolated points:
  \item{x}{vector of \code{x} coordinates.}
  \item{y}{vector of \code{y} coordinates.}
  \item{z}{vector of interpolated data \code{z}.}
  If you need an output grid, see \code{\link{bilinear.grid}}.
}
\references{
  Pascal Getreuer,
  Linear Methods for Image Interpolation,
  Image Processing On Line, 2011,
  http://www.ipol.im/pub/art/2011/g_lmii/article.pdf
}
\note{
  Use \code{\link{interpp}} for the general case of irregular gridded data!
}

\seealso{
  \code{\link{interp}}, \code{\link{bilinear.grid}}%, \code{\link{bicubic.grid}}
}
\examples{
data(akima474)
# interpolate at the diagonal of the grid [0,8]x[0,10]
akima.bil <- bilinear(akima474$x,akima474$y,akima474$z,
                     seq(0,8,length=50), seq(0,10,length=50))
plot(sqrt(akima.bil$x^2+akima.bil$y^2), akima.bil$z, type="l")
}

\keyword{ dplot }

\name{tri.mesh}
\alias{tri.mesh}
\title{
  Delaunay triangulation
}
\description{
  This function generates a Delaunay triangulation of arbitrarily distributed
  points in the plane. The resulting object can be printed or plotted,
  some additional functions can extract details from it like the list of
  triangles, arcs or the convex hull.
}
\usage{
tri.mesh(x, y = NULL, duplicate = "error")
}
\arguments{
  \item{x}{
    vector containing \eqn{x} coordinates of the data. If \code{y} is missing
    \code{x} should be a list or dataframe with two components \code{x}
    and \code{y}.
    }
  \item{y}{
    vector containing \eqn{y} coordinates of the data. Can be omitted if
    \code{x} is a list with two components \code{x} and \code{y}.
  }
  \item{duplicate}{
    flag indicating how to handle duplicate elements.
    Possible values are:
    \itemize{
      \item{
        \code{"error"} -- default,
      }
      \item{
        \code{"strip"} -- remove all duplicate points,
      }
      \item{
        \code{"remove"} -- leave one point of the duplicate points.
      }
    }
  }
}
\details{
  This function creates a Delaunay triangulation of a set of
  arbitrarily distributed points in the plane referred to as
  nodes.

  The Delaunay triangulation is defined as a set of triangles with the
  following five properties:
  \enumerate{
    \item The triangle vertices are nodes.
    \item No triangle contains a node other than its vertices.
    \item The interiors of the triangles are pairwise disjoint.
    \item The union of triangles is the convex hull of the set
    of nodes (the smallest convex set which contains
    the nodes).
    \item The interior of the circumcircle of each triangle
    contains no node.
    }
    The first four properties define a triangulation, and the
    last property results in a triangulation which is as close
    as possible to equiangular in a certain sense and which is
    uniquely defined unless four or more nodes lie on a common
    circle.  This property makes the triangulation well-suited
    for solving closest point problems and for triangle-based
    interpolation.

    This triangulation is based on the s-hull algorithm by David
    Sinclair. It consist of two steps:
    \enumerate{
      \item{
        Create an initial non-overlapping triangulation from the
        radially sorted nodes (w.r.t to an arbitrary first
        node). Starting from a first triangle built from the first node
        and its nearest neigbours this is done by adding triangles from the
        next node (in the sense of distance to the first node) to the hull
        of the actual triangulation visible from this node (sweep hull
        step).
      }
      \item{
        Apply triange flipping to each pair of triangles sharing a
        border until condition 5 holds (Cline-Renka test).
      }
    }
    This algorithm has complexicity \eqn{O(n*log(n))}.
}
\value{
  an object of class \code{"triSht"}, see \code{\link{triSht}}.
}
\references{
  B. Delaunay, Sur la sphere vide. A la memoire de Georges Voronoi,
  Bulletin de l'Academie des Sciences de l'URSS. Classe des sciences
  mathematiques et na, 1934, no. 6, p. 793--800

  D. A. Sinclair, S-Hull: A Fast Radial Sweep-Hull Routine for Delaunay
  Triangulation. https://arxiv.org/pdf/1604.01428.pdf, 2016.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\note{
  This function is meant as a replacement for function
  \code{tri.mesh} from package \code{tripack}.
  Please note that the underlying algorithm changed from Renka's method
  to Sinclair's sweep hull method. Delaunay triangulations are unique if
  no four or more points exist which share the same
  circumcircle. Otherwise several solutions are available and different
  algorithms will give different results. This especially holds for
  regular grids, where in the case of rectangular gridded points each
  grid cell can be triangulated in two different ways.

  The arguments are backward compatible, but the returned object
  is not compatible with package \code{tripack} (it
  provides a \code{tri} object type)! But you
  can apply methods with same names to the object returned in package
  \code{interp} which is of type \code{\link{triSht}}, so you can reuse
  your old code but you cannot reuse your old saved workspace.
}


\seealso{
  \code{\link{triSht}}, \code{\link{print.triSht}}, \code{\link{plot.triSht}},
  \code{\link{summary.triSht}}, \code{\link{triangles}},
  \code{\link{convex.hull}}, \code{\link{arcs}}.
}
\examples{
## use Frankes datasets:
data(franke)
tr1 <- tri.mesh(franke$ds3$x, franke$ds3$y)
tr1
tr2 <- tri.mesh(franke$ds2)
summary(tr2)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ spatial }

\name{print.voronoi}
\title{Print a voronoi object}
\usage{\method{print}{voronoi}(x,...)
}
\alias{print.voronoi}
\arguments{
  \item{x}{object of class \code{"voronoi"}}
  \item{...}{additional paramters for \code{print}}
}
\description{prints a summary of \code{"x"}
}
\value{None
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}

\seealso{
  \code{\link{voronoi}},
  \code{\link{plot.voronoi}},
  \code{\link{summary.voronoi}}
}
\keyword{spatial}

\name{voronoi}
\title{Voronoi object}
\alias{voronoi}
\arguments{
  \item{x,y}{x and y coordinates of nodes of the voronoi mosaic. Each node is a
    circumcircle center of some triangle from the Delaunay triangulation.}
  \item{node}{logical vector, indicating real nodes of the voronoi
    mosaic. These nodes are the centers of circumcircles of triangles with
    positive area of the delaunay triangulation.

    If \code{node[i]}=\code{FALSE}, (\code{c[i]},\code{x[i]}) belongs to a
    triangle with area 0.}
  \item{n1,n2,n3}{indices of neighbour nodes. Negative indices indicate
    dummy points as neighbours.}
  \item{tri}{triangulation object, see \code{\link{triSht}}.}
  \item{area}{area of triangle \eqn{i}.
  }
  \item{ratio}{aspect ratio (inscribed radius/circumradius) of triangle
    \eqn{i}.}
  \item{radius}{circumradius of triangle i.}
  \item{dummy.x,dummy.y}{x and y coordinates of dummy points. They are
    used for plotting of unbounded tiles.}
}
\description{
  A \code{voronoi} object is created with \code{\link{voronoi.mosaic}}
}
\note{
  This version of \code{voronoi} object is generated from the
  \code{\link{tri.mesh}} function from package \code{interp}. That's the only
  difference to \code{voronoi} objects generated with package
  \code{tripack}.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{voronoi.mosaic}},\code{\link{plot.voronoi}}
}
\keyword{spatial}

\name{aspline}
\alias{aspline}
\alias{aSpline}
\title{
  Univariate Akima interpolation
}
\description{
  The function returns a list of points which smoothly
  interpolate given data points, similar to a curve drawn by hand.
}
\usage{
aspline(x, y = NULL, xout, n = 50, ties = mean, method = "improved",
degree = 3)
aSpline(x, y, xout, method = "improved", degree = 3)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x, y}{vectors giving the coordinates of the points to be
    interpolated.  Alternatively a single plotting structure can be
    specified: see \code{\link{xy.coords}}.}
  \item{xout}{an optional set of values specifying where interpolation
    is to take place.}
  \item{n}{If \code{xout} is not specified, interpolation takes place at
    \code{n} equally spaced points spanning the interval [\code{min(x)},
    \code{max(x)}].}
  \item{ties}{Handling of tied \code{x} values.  Either a function
    with a single vector argument returning a single number result or
    the string \code{"ordered"}.}
  \item{method}{either \code{"original"} method after Akima (1970) or
    \code{"improved"} method (default) after Akima (1991)}
  \item{degree}{if improved algorithm is selected: degree of the
    polynomials for the interpolating function}
}
\details{
  The original algorithm is based on a piecewise function composed of a
  set of polynomials, each of degree three, at most, and applicable to
  successive interval of the given points. In this method, the slope of
  the curve is determined at each given point locally by fitting a third
  degree polynomial to four consecutive points. Each polynomial
  representing a portion of the curve between a pair of given
  points is determined by the coordinates of and the slopes at the
  points. The data set is prolonged below and above minimum and maximum
  x values to enable estimation of derivatives at the boundary. 
  The improved algorithm uses polynomials of degree two and one at the
  boundary. Additionally four overlapping  sequences of points are used
  for the estimation via a residual based weighting scheme.

}
\value{
\item{x }{x coordinates of the interpolated data as given by 'xout' or 'n'.}
\item{y }{interpolated y values.}
}
\references{
  Akima, H. (1970) A new method of interpolation
  and smooth curve fitting based on local procedures,
  J. ACM \bold{17}(4), 589-602

  Akima, H. (1991) A Method of Univariate Interpolation that Has
  the Accuracy of a Third-degree Polynomial. ACM Transactions on
  Mathematical Software, \bold{17}(3), 341-366.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Thomas Petzold <thomas.petzoldt@tu-dresden.de>
}
\note{
  'aspline' is a wrapper call for the underlying Rcpp function 'aSpline'
  which could also be called directly with 'x' and 'y' arguments if
  'xout' is given and no 'ties' argument is needed.  

  This is a reimplementation of Akimas algorithms (original and improved 
  version). It is only based on the original articles. It does not involve 
  or resemble the Fortran code associated with those articles. For this 
  reason results may differ slightly because different expressions can
  result in different numerical errors.

  This code is under GPL in contrast to original Fortran code as
  provided in package 'akima'.

  The function arguments are identical to the call in package 'akima',
  only the 'method' argument has its default now set to 'improved'.
}

\seealso{
\code{\link[stats]{spline}}
}
\examples{
## regular spaced data
x <- 1:10
y <- c(rnorm(5), c(1,1,1,1,3))

xnew <- seq(-1, 11, 0.1)
plot(x, y, ylim=c(-3, 3), xlim=range(xnew))
## stats::spline() for comparison
lines(spline(x, y, xmin=min(xnew), xmax=max(xnew), n=200), col="blue")

lines(aspline(x, y, xnew, method="original"), col="red")
lines(aspline(x, y, xnew, method="improved"), col="black", lty="dotted")
lines(aspline(x, y, xnew, method="improved", degree=10), col="green", lty="dashed")

## irregular spaced data
x <- sort(runif(10, max=10))
y <- c(rnorm(5), c(1,1,1,1,3))

xnew <- seq(-1, 11, 0.1)
plot(x, y, ylim=c(-3, 3), xlim=range(xnew))
## stats::spline() for comparison
lines(spline(x, y, xmin=min(xnew), xmax=max(xnew), n=200), col="blue")

lines(aspline(x, y, xnew, method="original"), col="red")
lines(aspline(x, y, xnew, method="improved"), col="black", lty="dotted")
lines(aspline(x, y, xnew, method="improved", degree=10), col="green", lty="dashed")

## an example of Akima, 1991
x <- c(-3, -2, -1, 0,  1,  2, 2.5, 3)
y <- c( 0,  0,  0, 0, -1, -1, 0,   2)

plot(x, y, ylim=c(-3, 3))
## stats::spline() for comparison
lines(spline(x, y, n=200), col="blue")

lines(aspline(x, y, n=200, method="original"), col="red")
lines(aspline(x, y, n=200, method="improved"), col="black", lty="dotted")
lines(aspline(x, y, n=200, method="improved", degree=10), col="green", lty="dashed")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{arith}
\keyword{dplot}

\name{tri.find}
\title{Locate a point in a triangulation}
\usage{
tri.find(tri.obj,x,y)
}
\alias{tri.find}
\arguments{
  \item{tri.obj}{an triangulation object of class \code{triSht}}
    \item{x}{x-coordinate of the point}
    \item{y}{y-coordinate of the point}
}
\description{
  This subroutine locates a point \eqn{P=(x,y)} relative to a
  triangulation  created by \code{tri.mesh}.  If \eqn{P} is
  contained in a triangle, the three vertex indexes are
  returned.  Otherwise, the indexes of the rightmost and
  leftmost visible boundary nodes are returned.
}
\value{
  A list with elements \code{i1},\code{i2},\code{i3} containing nodal
  indexes, in counterclockwise order, of the vertices of a triangle
  containing \eqn{P=(x,y)}. \code{tr} contains the triangle index and 
  \code{bc} contains the barycentric coordinates 
  of \eqn{P} w.r.t. the found triangle.

  If \eqn{P} is not contained in the
  convex hull of the nodes this indices are 0 (\code{bc} is meaningless then).
  % CHECKME (maybe differs from tripack!):
  %, \code{i1} indexes the rightmost visible
  %boundary node, \code{i2} indexes the leftmost visible boundary node,
  %and \code{i3} = 0.  Rightmost and leftmost are defined from the
  %perspective of \eqn{P}, and a pair of points are visible from each other if
  %and only if the line segment joining them intersects no triangulation
  %arc.  If \eqn{P} and all of the nodes lie on a common line, then
  %\code{i1}=\code{i2}=\code{i3} = 0 on output.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}

\seealso{
  \code{\link{triSht}}, \code{\link{print.triSht}}, \code{\link{plot.triSht}},
  \code{\link{summary.triSht}}, \code{\link{triangles}},
  \code{\link{convex.hull}}
}
\examples{
data(franke)
tr<-tri.mesh(franke$ds3$x,franke$ds3$y)
plot(tr)
pnt<-list(x=0.3,y=0.4)
triangle.with.pnt<-tri.find(tr,pnt$x,pnt$y)
attach(triangle.with.pnt)
lines(franke$ds3$x[c(i1,i2,i3,i1)],franke$ds3$y[c(i1,i2,i3,i1)],col="red")
points(pnt$x,pnt$y)
}
\keyword{spatial}

\name{outer.convhull}
\title{Version of outer which operates only in a convex hull}
\usage{outer.convhull(cx,cy,px,py,FUN,duplicate="remove",...)
}
\alias{outer.convhull}
\arguments{
  \item{cx}{x cordinates of grid}
  \item{cy}{y cordinates of grid}
  \item{px}{vector of x coordinates of points}
  \item{py}{vector of y coordinates of points}
  \item{FUN}{function to be evaluated over the grid}
  \item{duplicate}{indicates what to do with duplicate
    \eqn{(px_i,py_i)} points, default \code{"remove"}.}
  \item{...}{additional arguments for \code{FUN}}
}
\description{This version of \code{outer} evaluates \code{FUN}
  only on that part of the grid \eqn{cx} times \eqn{cy} that is enclosed within
  the convex hull of the points \eqn{(px,py)}.
  
  This can be useful for spatial estimation if no extrapolation is wanted. 
}
\value{Matrix with values of \code{FUN} (\code{NA}s if outside the
  convex hull).
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{\code{\link{in.convex.hull}}
}
\examples{
x<-runif(20)
y<-runif(20)
z<-runif(20)
z.lm<-lm(z~x+y)
f.pred<-function(x,y)
  {predict(z.lm,data.frame(x=as.vector(x),y=as.vector(y)))}
xg<-seq(0,1,0.05)
yg<-seq(0,1,0.05)
image(xg,yg,outer.convhull(xg,yg,x,y,f.pred))
points(x,y)
}
\keyword{spatial}

\name{print.summary.triSht}
\title{Print a summary of a triangulation object}
\usage{\method{print}{summary.triSht}(x, ...)}
\alias{print.summary.triSht}
\arguments{
  \item{x}{object of class \code{"summary.triSht"},
    generated by \code{\link{summary.triSht}}.}
  \item{...}{additional paramters for \code{print}}
}
\description{
  Prints some information about \code{tri.obj}
}
\value{None
}
\note{
  This function is meant as replacement for the function of same name in
  package \code{tripack}.

  The only difference is that no constraints are possible with
  \code{triSht} objects of package \code{interp}.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{triSht}},\code{\link{tri.mesh}},
  \code{\link{print.triSht}}, \code{\link{plot.triSht}},
  \code{\link{summary.triSht}}.
}
\keyword{spatial}

\name{akima}
\alias{akima}
\title{
Waveform Distortion Data for Bivariate Interpolation
}
\description{
\code{akima} is a list with components \code{x}, \code{y} and \code{z} which
represents a smooth surface of \code{z} values at selected points
irregularly distributed in the \code{x-y} plane.

The data was taken from a study of waveform distortion in
electronic circuits, described in:
Hiroshi Akima, "A Method of Bivariate Interpolation and
Smooth Surface Fitting Based on Local Procedures", 
CACM,
Vol. 17, No. 1, January 1974, pp. 18-20.
}
\references{
Hiroshi Akima, "A Method of Bivariate Interpolation and
Smooth Surface Fitting for Irregularly Distributed Data
Points", 
ACM Transactions on Mathematical Software,
Vol. 4, No. 2, June 1978, pp. 148-159.
Copyright 1978, Association for Computing Machinery, Inc.,
reprinted by permission.
}
\examples{
\dontrun{
library(rgl)
data(akima)
# data
rgl.spheres(akima$x,akima$z , akima$y,0.5,color="red")
rgl.bbox()
# bivariate linear interpolation
# interp:
akima.li <- interp(akima$x, akima$y, akima$z, 
                   xo=seq(min(akima$x), max(akima$x), length = 100),
                   yo=seq(min(akima$y), max(akima$y), length = 100))
# interp surface:
rgl.surface(akima.li$x,akima.li$y,akima.li$z,color="green",alpha=c(0.5))
# interpp:
akima.p <- interpp(akima$x, akima$y, akima$z,
                    runif(200,min(akima$x),max(akima$x)),
                    runif(200,min(akima$y),max(akima$y)))
# interpp points:
rgl.points(akima.p$x,akima.p$z , akima.p$y,size=4,color="yellow")

# bivariate spline interpolation
# data
rgl.spheres(akima$x,akima$z , akima$y,0.5,color="red")
rgl.bbox()
# bivariate cubic spline interpolation
# interp:
akima.si <- interp(akima$x, akima$y, akima$z, 
                   xo=seq(min(akima$x), max(akima$x), length = 100),
                   yo=seq(min(akima$y), max(akima$y), length = 100),
                   linear = FALSE, extrap = TRUE)
# interp surface:
rgl.surface(akima.si$x,akima.si$y,akima.si$z,color="green",alpha=c(0.5))
# interpp:
akima.sp <- interpp(akima$x, akima$y, akima$z,
                    runif(200,min(akima$x),max(akima$x)),
                    runif(200,min(akima$y),max(akima$y)),
                   linear = FALSE, extrap = TRUE)
# interpp points:
rgl.points(akima.sp$x,akima.sp$z , akima.sp$y,size=4,color="yellow")

}
}
\keyword{datasets}
% Converted by Sd2Rd version 0.2-a3.

\name{on.convex.hull}
\title{Determines if points are on or in the convex hull of a triangulation object}
\usage{
on.convex.hull(tri.obj, x, y, eps=1E-16)
in.convex.hull(tri.obj, x, y, eps=1E-16, strict=TRUE)
}
\alias{on.convex.hull}
\alias{in.convex.hull}
\arguments{
  \item{tri.obj}{object of class \code{\link{triSht}}}
  \item{x}{vector of \eqn{x}-coordinates of points to locate}
  \item{y}{vector of \eqn{y}-coordinates of points to locate}
  \item{eps}{accuracy for checking the condition}
  \item{strict}{logical, default \code{TRUE}. It indicates if the convex
    hull is treated as an open (\code{strict=TRUE}) or closed
    (\code{strict=FALSE}) set. (applies only to \code{in.convex.hull})}
}
\description{
Given a triangulation object \code{tri.obj} of \eqn{n} points in the plane, this
subroutine returns a logical vector indicating if the points
\eqn{(x_i,y_i)}
lay on or in the convex hull of \code{tri.obj}.

}
\value{
Logical vector.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{triSht}}, \code{\link{print.triSht}}, \code{\link{plot.triSht}},
  \code{\link{summary.triSht}}, \code{\link{triangles}},
  \code{\link{convex.hull}}.
}
\examples{
# use a part of the quakes data set:
data(quakes)
quakes.part<-quakes[(quakes[,1]<=-10.78 & quakes[,1]>=-19.4 &
                     quakes[,2]<=182.29 & quakes[,2]>=165.77),]
q.tri<-tri.mesh(quakes.part$lon, quakes.part$lat, duplicate="remove")
on.convex.hull(q.tri,quakes.part$lon[1:20],quakes.part$lat[1:20])
# Check with part of data set:
# Note that points on the hull (see above) get marked FALSE below:
in.convex.hull(q.tri,quakes.part$lon[1:20],quakes.part$lat[1:20])
# If points both on the hull and in the interior of the hull are meant 
# disable strict mode:
in.convex.hull(q.tri,quakes.part$lon[1:20],quakes.part$lat[1:20],strict=FALSE)
# something completely outside:
in.convex.hull(q.tri,c(170,180),c(-20,-10))
}
\keyword{spatial}

\name{interpp}
\alias{interpp}
\title{
  Pointwise interpolate irregular gridded data
}
\description{
  This function implements bivariate interpolation onto a set of points
  for irregularly spaced input data.

  This function is meant for backward compatibility to package
  \code{akima}, please use \code{\link{interp}} with its \code{output}
  argument set to \code{"points"} now. Especially newer options to the underlying
  algorithm are only available there.
}
\usage{
interpp(x, y = NULL, z, xo, yo = NULL, linear = TRUE,
  extrap = FALSE, duplicate = "error", dupfun = NULL,
  deltri = "shull")
}
\arguments{

  \item{x}{
    vector of x-coordinates of data points or a
    \code{SpatialPointsDataFrame} object.
    Missing values are not accepted.
  }
  \item{y}{
    vector of y-coordinates of data points.
    Missing values are not accepted.

    If left as NULL indicates that \code{x} should be a
    \code{SpatialPointsDataFrame} and \code{z} names the variable of
    interest in this dataframe.
  }
  \item{z}{
    vector of z-coordinates of data points or a character variable
    naming the variable of interest in the
    \code{SpatialPointsDataFrame} \code{x}.

    Missing values are not accepted.

    \code{x}, \code{y}, and \code{z} must be the same length
    (execpt if \code{x} is a \code{SpatialPointsDataFrame}) and may
    contain no fewer than four points. The points of \code{x} and \code{y}
    cannot be collinear, i.e, they cannot fall on the same line (two vectors
    \code{x} and \code{y} such that \code{y = ax + b} for some \code{a},
    \code{b} will not be accepted).
  }
  \item{xo}{
    vector of x-coordinates of points at which to evaluate the interpolating
    function. If \code{x} is a \code{SpatialPointsDataFrame} this has
    also to be a \code{SpatialPointsDataFrame}.
  }
  \item{yo}{
    vector of y-coordinates of points at which to evaluate the interpolating
    function.

    If operating on \code{SpatialPointsDataFrame}s this is left as \code{NULL}
  }
  \item{linear}{logical -- indicating wether linear or spline
    interpolation should be used.
  }
  \item{extrap}{
    logical flag: should extrapolation be used outside of the
    convex hull determined by the data points? Not possible for linear
    interpolation.}
  \item{duplicate}{
    indicates how to handle duplicate data points. Possible values are
    \code{"error"} - produces an error message, \code{"strip"} - remove
    duplicate z values, \code{"mean"},\code{"median"},\code{"user"}  -
    calculate  mean , median or user defined function of duplicate z
    values.
  }
  \item{dupfun}{
    this function is applied to duplicate points if \code{duplicate="user"}
  }
  \item{deltri}{
    triangulation method used, this argument will later be moved
    into a control set together with others related to the spline
    interpolation!
  }
}
%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
\value{
  a list with 3 components:
  \item{x,y}{
    If \code{output="grid"}:
    vectors of \eqn{x}- and \eqn{y}-coordinates of output grid, the same
    as the input
    argument \code{xo}, or \code{yo}, if present.  Otherwise, their
    default, a vector 40 points evenly spaced over the range of the
    input \code{x} and \code{y}.

    If \code{output="points"}: vectors of \eqn{x}- and \eqn{y}-coordinates of
    output points as given by \code{xo} and \code{yo}.
    }
  \item{z}{
    If \code{output="grid"}:
    matrix of fitted \eqn{z}-values.  The value \code{z[i,j]} is computed
    at the point \eqn{(xo[i], yo[j])}. \code{z} has
    dimensions \code{length(xo)} times \code{length(yo)}.

    If \code{output="points"}: a vector with the calculated z values for
    the output points as given by \code{xo} and \code{yo}.

    If the input was a \code{SpatialPointsDataFrame} a
    \code{SpatialPixelssDataFrame} is returned for \code{output="grid"}
    and a  \code{SpatialPointsDataFrame}  for \code{output="points"}.
    }
}
\references{
  Moebius, A. F. (1827) Der barymetrische Calcul. Verlag v. Johann
  Ambrosius Barth, Leipzig,
  https://books.google.at/books?id=eFPluv_UqFEC&hl=de&pg=PR1#v=onepage&q&f=false

  Franke, R., (1979). A critical comparison of some methods for interpolation
  of scattered data. Tech. Rep. NPS-53-79-003, Dept. of Mathematics, Naval
  Postgraduate School, Monterey, Calif.


}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\note{
  This is only a call wrapper meant for backward compatibility, see
  \code{\link{interp}} for more details!
}


\seealso{
  \code{\link{interp}}
}
\examples{
### Use all datasets from Franke, 1979:
### calculate z at shifted original locations.
data(franke)
for(i in 1:5)
    for(j in 1:3){
        FR <- franke.data(i,j,franke)
        IL <- with(FR, interpp(x,y,z,x+0.1,y+0.1,linear=TRUE))
        str(IL)
    }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ spatial }

\name{circtest}
\alias{circtest}
\alias{circtest2}
\title{ circtest / sample data }
\description{
  Sample data for the \code{link{circumcircle}} function.

  \code{circtest2} are points sampled from a circle with some jitter
  added, i.e. they represent the most complicated case for the
  \code{link{circumcircle}} function.
  
}

\keyword{datasets}

\name{tritest}
\alias{tritest}
\alias{tritest2}
\title{ tritest / sample data }
\description{
A very simply set set of points to test the tripack functions, taken
from the FORTRAN original. \code{tritest2} is a slight modification by 
adding \code{runif(,-0.1,0.1)} random numbers to the coordinates.
}
\references{
  R. J. Renka (1996). Algorithm 751: TRIPACK: a constrained
  two-dimensional Delaunay triangulation package.
  ACM Transactions on Mathematical Software.
  \bold{22}, 1-8.
}
\keyword{datasets}

\name{cells}
\alias{cells}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ extract info about voronoi cells }
\description{
  This function returns some info about the cells of a voronoi mosaic,
  including the coordinates of the vertices and the cell area.
}
\usage{
cells(voronoi.obj)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{voronoi.obj}{ object of class \code{voronoi}  }
}
\details{
  The function calculates the neighbourhood relations between the
  underlying triangulation and translates it into the neighbourhood
  relations between the voronoi cells.
}
\value{
  retruns a list of lists, one entry for each voronoi cell which contains
  \item{cell }{cell index}
  \item{center }{cell 'center'}
  \item{neighbours }{neighbour cell indices}
  \item{nodes}{2 times \code{nnb} matrix with vertice coordinates}
  \item{area}{cell area}
}

\author{ A. Gebhardt }
\note{ outer cells have \code{area=NA}, currently also \code{nodes=NA}
  which is not really useful -- to be done later }


\seealso{  \code{\link{voronoi.mosaic}},  \code{\link{voronoi.area}} }
\examples{
data(tritest)
tritest.vm <- voronoi.mosaic(tritest$x,tritest$y)
tritest.cells <- cells(tritest.vm)
# higlight cell 12:
plot(tritest.vm)
polygon(t(tritest.cells[[12]]$nodes),col="green")
# put cell area into cell center:
text(tritest.cells[[12]]$center[1],
     tritest.cells[[12]]$center[2],
     tritest.cells[[12]]$area)
}
\keyword{ spatial }% at least one, from doc/KEYWORDS

\name{voronoi.polygons}
\alias{voronoi.polygons}
\title{ extract polygons from a voronoi mosaic }
\description{
  This functions extracts polygons from a \code{voronoi.mosaic} object.
}
\usage{
voronoi.polygons(voronoi.obj)
}
\arguments{
  \item{voronoi.obj}{ object of class \code{voronoi.mosaic} }
}
\value{
  Returns an object of class \code{voronoi.polygons} with unamed list
  elements for each polygon. These list
  elements are matrices with columns \code{x} and \code{y}.
  Unbounded polygons along the border are represented by \code{NULL}
  instead of a matrix.
}
\author{ Denis White }
\seealso{ \code{\link{plot.voronoi.polygons}},\code{\link{voronoi.mosaic}}}

\examples{
data(franke)
fd3 <- franke$ds3
fd3.vm <- voronoi.mosaic(fd3$x,fd3$y)
fd3.vp <- voronoi.polygons(fd3.vm)
fd3.vp
}
\keyword{ spatial }

\name{summary.voronoi}
\title{Return a summary of a voronoi object}
\usage{\method{summary}{voronoi}(object,...)
}
\alias{summary.voronoi}
\arguments{
  \item{object}{object of class \code{"voronoi"}}
  \item{...}{additional parameters for \code{summary}}
}
\description{
  Returns some information about \code{object}
}
\value{Object of class \code{"summary.voronoi"}.

  It contains the number of nodes (\code{nn}) and dummy nodes (\code{nd}).
}
\note{
  This function is meant as replacement for the function of same name in
  package \code{tripack} and should be fully backward compatible.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{voronoi}},\code{\link{voronoi.mosaic}},
  \code{\link{print.voronoi}}, \code{\link{plot.voronoi}},
  \code{\link{print.summary.voronoi}}.
}
\keyword{spatial}

\name{print.summary.voronoi}
\title{Print a summary of a voronoi object}

\usage{\method{print}{summary.voronoi}(x, ...)}
\alias{print.summary.voronoi}
\arguments{
  \item{x}{object of class \code{"summary.voronoi"},
    generated by \code{\link{summary.voronoi}}.}
  \item{...}{additional paramters for \code{print}}
}
\description{
  Prints some information about object \code{x}
}
\value{None
}
\note{
  This function is meant as replacement for the function of same name in
  package \code{tripack} and should be fully backward compatible.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{voronoi}},\code{\link{voronoi.mosaic}},
  \code{\link{print.voronoi}}, \code{\link{plot.voronoi}},
  \code{\link{summary.voronoi}}. 
}
\keyword{spatial}

\name{circles}
\alias{circles}
\title{ plot circles }
\description{
 This function plots circles at given locations with given radii.
}
\usage{
circles(x, y, r, ...)
}
\arguments{
  \item{x}{ vector of x coordinates }
  \item{y}{ vector of y coordinates }
  \item{r}{ vactor of radii }
  \item{\dots}{ additional graphic parameters will be passed through }
}
\note{
  This function needs a previous plot where it adds the circles.
  }
\author{A. Gebhardt}
\seealso{  \code{\link{lines}},
  \code{\link{points}} }
\examples{
x<-rnorm(10)
y<-rnorm(10)
r<-runif(10,0,0.5)
plot(x,y, xlim=c(-3,3), ylim=c(-3,3), pch="+")
circles(x,y,r)
}
\keyword{ aplot }

\name{interp-package}
\alias{interp-package}
\docType{package}
\title{
  Interpolation of data
}
\description{
  Interpolation of \eqn{z} values given regular or irregular gridded
  data sets containing coordinates \eqn{(x_i,y_i)} and function values
  \eqn{z_i} is (will be) available through this package. As this
  interpolation is (for the irregular gridded data case) based on
  trianglation of the data locations also triangulation functions are
  implemented. Moreover the (not yet finished) spline interpolation
  needs estimators for partial derivates, these are also made available
  to the end user for direct use. 
}
\details{
  The interpolation use can be divided by the used method into piecewise
  linear (finished in 1_0.27) and spline  (not yet finished) interpolation and by
  input and output settings into  gridded and pointwise setups.
}
\note{
  This package is a FOSS replacement for the ACM licensed packages
  \code{akima} and \code{tripack}. The function calls are backward
  compatible.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>


  Maintainer: Albrecht Gebhardt <albrecht.gebhardt@aau.at>
}
%\references{
%  This optional section can contain literature or other references for
%  background information.
%}
\keyword{ package }
\seealso{
  \code{\link{interp}}, \code{\link{tri.mesh}},
  \code{\link{voronoi.mosaic}}, \code{\link{locpoly}}
}
%\examples{
%  \dontrun{
%     ## Optional simple examples of the most important functions
%     ## These can be in \dontrun{} and \donttest{} blocks.   
%  }
%}

\name{triSht2tri}
\alias{triSht2tri}
\title{
Converter to tripack objects
}
\description{
This function converts \code{triSht} objects (from this package) to \code{tri} objects (from tripack package).
}
\usage{
triSht2tri(t.triSht)
}
\arguments{
  \item{t.triSht}{
a class \code{triSht} object as returned by \code{tri.mesh} 
}
}
\note{
The converted objects are not fully compatible with \code{tripack} functions. Basic stuff (printing, plotting) works, \code{tripack::triangles} e.g. does not work.
Voronoi functions from package \code{tripack} are working correctly with translated objects.
}
\value{
	A class \code{tri} object, see tripack package.
}
\author{
A. Gebhardt
}
\seealso{
\code{\link{tri.mesh}},
\code{\link{triSht}}
}

\name{bilinear.grid}
\alias{bilinear.grid}
\alias{BiLinear.grid}
\title{
  Bilinear Interpolation for Data on a Rectangular grid
}
\description{
  This is an implementation of a bilinear interpolating function.

  For a point (x0,y0) contained in a rectangle (x1,y1),(x2,y1),
  (x2,y2),(x1,y2) and x1<x2, y1<y2, the first step is to get z()
  at locations (x0,y1) and (x0,y2) as convex linear combinations
  z(x0,y*)=a*z(x1,y*)+(1-a)*z(x2,y*) where a=(x2-x1)/(x0-x1) for
  y*=y1,y2. In a second step z(x0,y0) is calculated as convex linear
  combination between z(x0,y1) and z(x0,y2) as
  z(x0,y1)=b*z(x0,y1)+(1-b)*z(x0,y2)  where b=(y2-y1)/(y0-y1).

  Finally, z(x0,y0) is a convex linear combination of the z values at
  the corners of the containing  rectangle with weights according to
  the distance from (x0,y0) to these corners.

  The grid lines can be unevenly spaced.

}
\usage{
bilinear.grid(x,y,z,xlim=c(min(x),max(x)),ylim=c(min(y),max(y)),
                         nx=40,ny=40,dx=NULL,dy=NULL)
BiLinear.grid(x,y,z,xlim=c(min(x),max(x)),ylim=c(min(y),max(y)),
                         nx=40,ny=40,dx=NULL,dy=NULL)
}

\arguments{
  \item{x}{
    a vector containing the \code{x} coordinates of the rectangular data grid.
  }
  \item{y}{
    a vector containing the \code{y} coordinates of the rectangular data grid.
  }
  \item{z}{
    a matrix containing the \code{z[i,j]} data values for the grid points (\code{x[i]},\code{y[j]}).
  }
  \item{xlim}{
    vector of length 2 giving lower and upper limit for range \code{x}
    coordinates used for  output grid.
  }
  \item{ylim}{
    vector of length 2 giving lower and upper limit for range of \code{y}
    coordinates used for  output grid.
  }
  \item{nx}{
    output grid dimension in \code{x} direction.
    }
  \item{ny}{
    output grid dimension in \code{y} direction.
    }
  \item{dx}{
    output grid spacing in \code{x} direction, not used by default,
  overrides \code{nx} if specified.
    }
  \item{dy}{
    output grid spacing in \code{y} direction, not used by default,
    overrides \code{ny} if specified..
    }
}
\value{
  This function produces a grid of interpolated points, feasible to be
  used directly with \code{\link{image}} and \code{\link{contour}}:
  \item{x}{vector of \code{x} coordinates of the output grid.}
  \item{y}{vector of \code{y} coordinates of the output grid.}
  \item{z}{matrix of interpolated data for the output grid.}
}
\references{
  Pascal Getreuer,
  Linear Methods for Image Interpolation,
  Image Processing On Line, 2011,
  http://www.ipol.im/pub/art/2011/g_lmii/article.pdf
}
\note{
  This Fortran function was part of the akima package but not related to 
  any of Akimas algorithms and under GPL. So it could be transfered
  into the interp package without changes.
  
  \code{BiLinear.grid} is a C++ reimplementation, maybe this will replace the 
  Fortran implementation later. So its name may change in future versions, dont
  rely on it currently.
}


\seealso{
  \code{\link{interp}}%, \code{\link{bicubic}}
  % maybe later:
  % \code{\link[rgeostat]{bilinear}}
}
\examples{
data(akima474)
# interpolate at a grid [0,8]x[0,10]
akima.bil <- bilinear.grid(akima474$x,akima474$y,akima474$z)
zmin <- min(akima.bil$z, na.rm=TRUE)
zmax <- max(akima.bil$z, na.rm=TRUE)
breaks <- pretty(c(zmin,zmax),10)
colors <- heat.colors(length(breaks)-1)
image(akima.bil, breaks=breaks, col=colors)
contour(akima.bil, levels=breaks, add=TRUE)
}
\keyword{ dplot }

\name{identify.triSht}
\title{Identify points in a triangulation plot}
\usage{\method{identify}{triSht}(x,...)
}
\alias{identify.triSht}
\arguments{
  \item{x}{object of class \code{\link{triSht}}}
  \item{...}{additional paramters for \code{identify}}
}
\description{Identify points in a plot of \code{"x"} with its
  coordinates. The plot of \code{"x"} must be generated with \code{plot.tri}.
}
\value{an integer vector containing the indexes of the identified points.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
    \code{\link{triSht}}, \code{\link{print.triSht}}, \code{\link{plot.triSht}}, \code{\link{summary.triSht}}
}
\examples{
\dontrun{
data(franke)
tr <- tri.mesh(franke$ds3$x, franke$ds3$y)
plot(tr)
identify(tr)
}
}
\keyword{spatial}

\name{neighbours}
\title{List of neighbours from a triangulation or voronoi object}
\author{A. Gebhardt}
\usage{neighbours(obj)
}
\alias{neighbours}
\arguments{
  \item{obj}{object of class \code{"triSht"} or \code{"voronoi.mosaic"}}
}
\description{Extract a list of neighbours from a triangulation or
  voronoi object
}
\value{nested list of neighbours per point
}
\seealso{\code{\link{triSht}}, \code{\link{print.triSht}}, \code{\link{plot.triSht}}, \code{\link{summary.triSht}}, \code{\link{triangles}}
}
\examples{
data(tritest)
tritest.tr<-tri.mesh(tritest$x,tritest$y)
tritest.nb<-neighbours(tritest.tr)
}
\keyword{spatial}

\name{summary.triSht}
\title{Return a summary of a triangulation object}
\usage{\method{summary}{triSht}(object,...)
}
\alias{summary.triSht}
\arguments{
  \item{object}{object of class \code{"triSht"}}
  \item{...}{additional paramters for \code{summary}}
}
\description{
  Returns some information (number of nodes, triangles, arcs)
  about \code{object}.
}
\value{An object of class \code{"summary.triSht"}, to be printed by
  \code{\link{print.summary.triSht}}.

  It contains the number of nodes (\code{n}), of arcs (\code{na}), of
  boundary nodes (\code{nb}) and triangles (\code{nt}).
}
\note{
  This function is meant as replacement for the function of same name in
  package \code{tripack}.

  The only difference is that no constraints are possible with
  \code{triSht} objects of package \code{interp}.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{triSht}}, \code{\link{print.triSht}}, \code{\link{plot.triSht}},
  \code{\link{print.summary.triSht}}.
}
\keyword{spatial}

\name{area}
\alias{area}
\title{
  Extract a list of triangle areas from a triangulation object.
}
\description{
  This function returns a list containing the areas of each triangle of
  a  triangulation object created by \code{tri.mesh}.
}
\usage{
area(tri.obj)
}
\arguments{
  \item{tri.obj}{
    object of class \code{\link{triSht}}
  }
}
\details{
  This function acesses the \code{cclist} component of a triangulation
  object returned by \code{\link{tri.mesh}} and extracts the areas
  of the triangles contained in this triangulation.
}
\value{
  A vector containing the area values.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{triSht}}, \code{\link{triangles}}, \code{\link{arcs}}
}
\examples{
data(franke)
tr <- tri.mesh(franke$ds3)
area(tr)
}
\keyword{ spatial }
\keyword{ utilities }

\name{circum}
\Rdversion{1.1}
\alias{circum}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
  Determine the circumcircle (and some other characteristics) of a triangle
}
\description{
This function returns the circumcircle of a triangle and some additonal
values used to determine them.
}
\usage{
circum(x, y)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{Vector of three elements, giving the x coordinatres of the
    triangle nodes.
}
  \item{y}{Vector of three elements, giving the y coordinatres of the
    triangle nodes.
}
}
\details{
  This is an interface to the Fortran function CIRCUM found in TRIPACK.
}
\value{
  \item{ x }{ 'x' coordinate of center}
  \item{ y }{ 'y' coordinate of center}
  \item{ radius }{ circumcircle radius }
  \item{ signed.area }{ signed area of riangle (positive iff nodes are
    numbered counter clock wise) }
  \item{ aspect.ratio }{ ratio "radius of inscribed circle"/"radius of
    circumcircle", varies between 0 and 0.5

    0 means collinear points, 0.5 equilateral trangle.
    }
}
\references{
https://math.fandom.com/wiki/Circumscribed_circle#Coordinates_of_circumcenter, visited march 2022.
}
\author{
  A. Gebhardt
}
\note{
  This function is mainly intended to be used by \code{\link{circumcircle}}.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
  \code{\link{circumcircle}}
}
\examples{
circum(c(0,1,0),c(0,0,1))

tr <- list()
tr$t1 <-list(x=c(0,1,0),y=c(0,0,1))
tr$t2 <-list(x=c(0.5,0.9,0.7),y=c(0.2,0.9,1))
tr$t3 <-list(x=c(0.05,0,0.3),y=c(0.2,0.7,0.1))
plot(0,0,type="n",xlim=c(-0.5,1.5),ylim=c(-0.5,1.5))
for(i in 1:3){
    x <- tr[[i]]$x
    y <- tr[[i]]$y
    points(x,y,pch=c("1","2","3"),xlim=c(-0.5,1.5),ylim=c(-0.5,1.5))
    cc =circum(x,y)
    lines(c(x,x[1]),c(y,y[1]))
    points(cc$x,cc$y)
    if(cc$signed.area<0)
      circles(cc$x,cc$y,cc$radius,col="blue",lty="dotted")
    else
      circles(cc$x,cc$y,cc$radius,col="red",lty="dotted")
}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ spatial }

\name{franke.data}
\alias{franke.data}
\alias{franke.fn}
\alias{franke}
\title{
Test datasets from Franke for interpolation of scattered data
}
\description{
\code{franke.data} generates the test datasets from Franke, 1979, see references.
}
\usage{
franke.data(fn = 1, ds = 1, data)
franke.fn(x, y, fn = 1)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{fn}{
    function number, from 1 to 5.
  }
  \item{x}{'x' value}
  \item{y}{'y' value}
  \item{ds}{
    data set number, from 1 to 3. Dataset 1 consists of 100 points,
    dataset 2 of 33 points and dataset 3 of 25 points scattered in the
    square \eqn{[0,1]\times[0,1]}{[0,1]x[0,1]}. (and partially slightly
    outside).
  }
  \item{data}{
    A list of dataframes with 'x' and 'y' to choose from, dataset
    \code{franke} should be used here.
  }
}
\details{
  These datasets are mentioned in Akima, (1996) as a testbed for the
  irregular scattered data interpolator.

  Franke used the five functions:

  \deqn{0.75e^{-\frac{(9x-2)^2+(9y-2)^2}{4}}+
    0.75e^{-\frac{(9x+1)^2}{49}-\frac{9y+1}{10}}+
    0.5e^{-\frac{(9x-7)^2+(9y-3)^2}{4}}-
      0.2e^{-((9x-4)^2-(9y-7)^2)}
    }{0.75*exp(-((9*x-2)^2+(9*y-2)^2)/4)+
      0.75*exp(-((9*x+1)^2)/49-(9*y+1)/10)+
      0.5*exp(-((9*x-7)^2+(9*y-3)^2)/4)-
      0.2*exp(-(9*x-4)^2-(9*y-7)^2)}


  \deqn{\frac{\mbox{tanh}(9y-9x)+1}{9}}{(tanh(9*y-9*x)+1)/9}

  \deqn{\frac{1.25+\cos(5.4y)}{6(1+(3x-1)^2)}}{(1.25+cos(5.4*y))/(6*(1+(3*x-1)^2))}

  \deqn{e^{-\frac{81((x-0.5)^2+\frac{(y-0.5)^2}{16})}{3}}}{exp(-81*((x-0.5)^2+(y-0.5)^2)/16)/3}

  \deqn{e^{-\frac{81((x-0.5)^2+\frac{(y-0.5)^2}{4})}{3}}}{exp(-81*((x-0.5)^2+(y-0.5)^2)/4)/3}

  \deqn{\frac{\sqrt{64-81((x-0.5)^2+(y-0.5)^2)}}{9}-0.5}{sqrt(64-81*((x-0.5)^2+(y-0.5)^2))/9-0.5}

  and evaluated them on different more or less dense grids over \eqn{[0,1]\times[0,1]}{[0,1]x[0,1]}.
}
\value{
A data frame with components
  \item{x }{'x' coordinate}
  \item{y }{'y' coordinate}
  \item{z }{'z' value}
}
\note{
  The datasets have to be generated via \code{franke.data} before
  use, the dataset \code{franke} only contains a list of 3 dataframes of
  'x' and 'y' coordinates for the above mentioned irregular grids.
  Do not forget to load the \code{franke} dataset first.

  The 'x' and 'y' values have been taken from Akima (1996).
}
\references{
FRANKE, R., (1979). A critical comparison of some methods for interpolation
of scattered data. Tech. Rep. NPS-53-79-003, Dept. of Mathematics, Naval
Postgraduate School, Monterey, Calif.

Akima, H. (1996). Algorithm 761: scattered-data surface fitting that has
the accuracy of a cubic polynomial.
ACM Transactions on Mathematical Software \bold{22}, 362--371.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}

\seealso{
\code{\link{interp}}
}
\examples{
## generate Frankes data set for function 2 and dataset 3:
data(franke)
F23 <- franke.data(2,3,franke)
str(F23)
}
\keyword{ datagen }

\name{convex.hull}
\title{Return the convex hull of a triangulation object}
\usage{convex.hull(tri.obj, plot.it=FALSE, add=FALSE,...)
}
\alias{convex.hull}
\arguments{
  \item{tri.obj}{object of class \code{\link{triSht}}}
  \item{plot.it}{logical, if \code{TRUE} the convex hull of
    \code{tri.obj} will be plotted.}
  \item{add}{logical. if \code{TRUE} (and \code{plot.it=TRUE}), add to
    a current plot.}
  \item{...}{additional plot arguments}
}
\description{
  Given a triangulation \code{tri.obj} of \eqn{n} points in the plane, this
  subroutine returns two vectors containing the coordinates
  of the nodes on the boundary of the convex hull.
}
\value{
  \item{x}{x coordinates of boundary nodes.}
  \item{y}{y coordinates of boundary nodes.}
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{triSht}}, \code{\link{print.triSht}},
  \code{\link{plot.triSht}}, \code{\link{summary.triSht}}, \code{\link{triangles}}.
}
\examples{
## random points:
rand.tr<-tri.mesh(runif(10),runif(10))
plot(rand.tr)
rand.ch<-convex.hull(rand.tr, plot.it=TRUE, add=TRUE, col="red")
## use a part of the quakes data set:
data(quakes)
quakes.part<-quakes[(quakes[,1]<=-17 & quakes[,1]>=-19.0 &
                     quakes[,2]<=182.0 & quakes[,2]>=180.0),]
quakes.tri<-tri.mesh(quakes.part$lon, quakes.part$lat, duplicate="remove")
plot(quakes.tri)
convex.hull(quakes.tri, plot.it=TRUE, add=TRUE, col="red")
}
\keyword{spatial}

\name{voronoi.mosaic}
\alias{voronoi.mosaic}
\title{
  Voronoi mosaic
}
\description{
    This function creates a Voronoi mosaic out of a given set of
    arbitraryly located points in the plane. Each cell of a voronoi
    mosaic is associated with a data point and contains all points
    \eqn{(x,y)} closest to this data point.
}
\usage{
voronoi.mosaic(x, y = NULL, duplicate = "error")
}
\arguments{
  \item{x}{
    vector containing \eqn{x} coordinates of the data. If \code{y} is missing
    \code{x} should be a list or dataframe with two components \code{x}
    and \code{y}.

    \code{x} can also be an object of class \code{\link{triSht}} generated
    by \code{\link{tri.mesh}}. In this case the internal triangulation
    step can be skipped.
  }
  \item{y}{
    vector containing \eqn{y} coordinates of the data. Can be omitted if
    \code{x} is a list with two components \code{x} and \code{y}.
  }
  \item{duplicate}{
    flag indicating how to handle duplicate elements.
    Possible values are:
    \itemize{
      \item{
        \code{"error"} -- default,
      }
      \item{
        \code{"strip"} -- remove all duplicate points,
      }
      \item{
        \code{"remove"} -- leave one point of the duplicate points.
      }
    }
  }
}
\details{
  The function creates first a Delaunay triangulation (if not already
  given), extracts the circumcircle centers of these triangles, and then
  connects these points according to the neighbourhood relations between
  the triangles.
}
\value{
  An object of class \code{\link{voronoi}}.
}
\references{
G. Voronoi, Nouvelles applications des parametres continus a la theorie
    des formes quadratiques. Deuxieme memoire. Recherches sur les
    parallelloedres primitifs, Journal fuer die reine und angewandte
    Mathematik, 1908, vol 134, p. 198-287
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\note{
  This function is meant as a replacement for function
  \code{voronoi.mosaic} from package \code{tripack}.
  Please note that the underlying triangulation uses a
  different algorithm, see \code{\link{tri.mesh}}. Contrary to
  \code{tri.mesh} this should not affect the result for non
  unique triangulations e.g. on regular grids as the voronoi mosaic in
  this case will still be unique.

  The arguments are backward compatible, even the returned object should be
  compatible with functions from package \code{tripack}.
}

\seealso{
  \code{\link{voronoi}},\code{\link{voronoi.mosaic}},
  \code{\link{print.voronoi}}, \code{\link{plot.voronoi}}
}
\examples{
data(franke)
fd <- franke$ds3
vr <- voronoi.mosaic(fd$x, fd$y)
summary(vr)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ spatial }% use one of  RShowDoc("KEYWORDS")

\name{locpoly}
\alias{locpoly}
\title{
  Local polynomial fit.
}
\description{
  This function performs a local polynomial fit of up to order 3 to
  bivariate data. It returns estimated values of the regression function
  as well as estimated partial derivatives up to order 3. This access to the 
  partial derivatives was the main intent for writing this code as there already
  many other local polynomial regression implementations in R.
}
\usage{
locpoly(x, y, z, xo = seq(min(x), max(x), length = nx), yo = seq(min(y),
 max(y), length = ny), nx = 40, ny = 40, input = "points", output = "grid",
 h = 0, kernel = "uniform", solver = "QR", degree = 3, pd = "")
}
\arguments{
  \item{x}{
    vector of \eqn{x}-coordinates of data points.

    Missing values are not accepted.

}
  \item{y}{
    vector of \eqn{y}-coordinates of data points.

    Missing values are not accepted.

}
  \item{z}{
    vector of \eqn{z}-values at data points.

    Missing values are not accepted.

    \code{x}, \code{y}, and \code{z} must be the same length
    
  }
  \item{xo}{
    If \code{output="grid"} (default): sequence of \eqn{x} locations for
    rectangular output grid, defaults to \code{nx} points between
    \code{min(x)} and \code{max(x)}.

    If \code{output="points"}: vector of \eqn{x} locations for output points.
  }
  \item{yo}{
    If \code{output="grid"} (default): sequence of \eqn{y} locations for
    rectangular output grid, defaults to \code{ny} points between
    \code{min(y)} and \code{max(y)}.

    If \code{output="points"}: vector of \eqn{y} locations for output
    points. In this case it has to be same length as \code{xo}.
  }
  \item{input}{
    text, possible values are \code{"grid"} (not yet implemented) and
    \code{"points"} (default).

    This is used to distinguish between regular and irregular gridded data.
  }
  \item{output}{
    text, possible values are \code{"grid"} (=default) and
    \code{"points"}.

    If \code{"grid"} is choosen then \code{xo} and \code{yo} are
    interpreted as vectors spanning a rectangular grid of points
    \eqn{(xo[i],yo[j])}, \eqn{i=1,...,nx}, \eqn{j=1,...,ny}. This
    default behaviour matches how \code{akima::interp} works.

    In the case of \code{"points"}  \code{xo} and \code{yo} have to be
    of same lenght and are taken as possibly irregular spaced output
    points \eqn{(xo[i],yo[i])}, \eqn{i=1,...,no} with
    \code{no=length(xo)}. \code{nx} and \code{ny} are ignored in this
    case. 
  }
  \item{nx}{
    dimension of output grid in x direction
  }
  \item{ny}{
    dimension of output grid in y direction
  }

  \item{h}{
    bandwidth parameter, between 0 and 1.
    If a scalar is given it is interpreted as ratio applied to the dataset size 
    to determine a local search neighbourhood, if set to 0 a minimum useful 
    search neighbourhood is choosen (e.g. 10 points for a cubic trend function 
    to determine all 10 parameters).

    If a vector of length 2 is given both components are interpreted as
    ratio of the \eqn{x}- and \eqn{y}-range and taken as global
    bandwidth. 
  }
  \item{kernel}{
    Text value, implemented kernels are \code{uniform}, \code{triangle},
    \code{epanechnikov}, \code{biweight}, \code{tricube},
    \code{triweight}, \code{cosine}  and \code{gaussian} (default).
}
\item{solver}{
  Text value, determines used solver in fastLM algorithm used by this 
  code 

  Possible values are \code{LLt}, \code{QR} (default), \code{SVD},
  \code{Eigen} and
  \code{CPivQR} (compare \code{\link[RcppEigen]{fastLm}}).
  %% FIXME: translate their integer codes to our string values!
}
  \item{degree}{
    Integer value, degree of polynomial trend, maximum allowed value is 3.
}
  \item{pd}{
    Text value, determines which partial derivative should be returned,
    possible values are  \code{""} (default, the polynomial itself),
    \code{"x"}, \code{"y"}, \code{"xx"}, \code{"xy"}, \code{"yy"}, 
    \code{"xxx"}, \code{"xxy"}, \code{"xyy"}, \code{"yyy"} or \code{"all"}.
  }
}
%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
If \code{pd="all"}:
\item{x }{\eqn{x} coordinates}
\item{y }{\eqn{y} coordinates}
\item{z }{estimates of \eqn{z}}
\item{zx }{estimates of \eqn{dz/dx}}
\item{zy }{estimates of \eqn{dz/dy}}
\item{zxx }{estimates of \eqn{d^2z/dx^2}}
\item{zxy }{estimates of \eqn{d^2z/dxdy}}
\item{zyy }{estimates of \eqn{d^2z/dy^2}}
\item{zxxx }{estimates of \eqn{d^3z/dx^3}}
\item{zxxy }{estimates of \eqn{d^3z/dx^2dy}}
\item{zxyy }{estimates of \eqn{d^3z/dxdy^2}}
\item{zyyy }{estimates of \eqn{d^3z/dy^3}}

If \code{pd!="all"} only the elements \code{x}, \code{y} and the desired
derivative will be returned, e.g. \code{zxy} for \code{pd="xy"}. 
}
\references{
  Douglas Bates, Dirk Eddelbuettel (2013). Fast and Elegant Numerical
  Linear Algebra Using the RcppEigen Package. Journal of Statistical
  Software, 52(5), 1-24. URL http://www.jstatsoft.org/v52/i05/.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\note{
  Function \code{\link[KernSmooth]{locpoly}} of package
  \code{KernSmooth} performs a similar task for univariate data.
}

\seealso{
  \code{\link[KernSmooth]{locpoly}}, \code{\link[RcppEigen]{fastLm}}
}
\examples{

## choose a kernel
knl <- "gaussian"

## choose global and local bandwidth 
bwg <- 0.25 # *100% means: percentage of x- y-range used
bwl <- 0.1  # *100% means: percentage of data set (nearest neighbours) used

## a bivariate polynomial of degree 5:
f <- function(x,y) 0.1+ 0.2*x-0.3*y+0.1*x*y+0.3*x^2*y-0.5*y^2*x+y^3*x^2+0.1*y^5

## degree of model
dg=3 

## part 1:
## regular gridded data:
ng<- 11 # x/y size of a square data grid

## build and fill the grid with the theoretical values:

xg<-seq(0,1,length=ng)
yg<-seq(0,1,length=ng)

# xg and yg as matrix matching fg
nx <- length(xg)
ny <- length(yg)
xx <- t(matrix(rep(xg,ny),nx,ny))
yy <- matrix(rep(yg,nx),ny,nx)

fg   <- outer(xg,yg,f)

## local polynomial estimate
## global bw:
ttg <- system.time(pdg <- locpoly(xg,yg,fg,
  input="grid", pd="all", h=c(bwg,bwg), solver="QR", degree=dg, kernel=knl))
## time used:
ttg

## local bw:
ttl <- system.time(pdl <- locpoly(xg,yg,fg,
  input="grid", pd="all", h=bwl, solver="QR", degree=dg, kernel=knl))
## time used:
ttl

image(pdl$x,pdl$y,pdl$z,main="f and its estimated first partial derivatives",
      sub="colors: f, dotted: df/dx, dashed: df/dy")
contour(pdl$x,pdl$y,pdl$zx,add=TRUE,lty="dotted")
contour(pdl$x,pdl$y,pdl$zy,add=TRUE,lty="dashed")
points(xx,yy,pch=".")


## part 2:
## irregular data,
## results will not be as good as with the regular 21*21=231 points.

nd<- 121 # size of data set

## random irregular data
oldseed <- set.seed(42)
x<-runif(ng)
y<-runif(ng)
set.seed(oldseed)

z <- f(x,y)

## global bw:
ttg <- system.time(pdg <- interp::locpoly(x,y,z, xg,yg, pd="all",
  h=c(bwg,bwg), solver="QR", degree=dg,kernel=knl))

ttg

## local bw:
ttl <- system.time(pdl <- interp::locpoly(x,y,z, xg,yg, pd="all",
  h=bwl, solver="QR", degree=dg,kernel=knl))

ttl

image(pdl$x,pdl$y,pdl$z,main="f and its estimated first partial derivatives",
      sub="colors: f, dotted: df/dx, dashed: df/dy")
contour(pdl$x,pdl$y,pdl$zx,add=TRUE,lty="dotted")
contour(pdl$x,pdl$y,pdl$zy,add=TRUE,lty="dashed")
points(x,y,pch=".")

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ models }% use one of  RShowDoc("KEYWORDS")
\keyword{ regression }% __ONLY ONE__ keyword per line

\name{on}
\alias{on}

\alias{left}

\title{
  Determines if a point is on or left of the vector described by two other points.
}
\description{
  A simple test function to determine the position of one (or more)
  points relative to a vector spanned by two points.
}
\usage{
on(x1, y1, x2, y2, x0, y0, eps = 1e-16)
left(x1, y1, x2, y2, x0, y0, eps = 1e-16)
}
\arguments{
  \item{x1}{
    \code{x} coordinate of first point determinig the vector.
  }
  \item{y1}{
    \code{y} coordinate of first point determinig the vector.
  }
  \item{x2}{
    \code{x} coordinate of second point determinig the vector.
  }
  \item{y2}{
    \code{y} coordinate of second point determinig the vector.
  }
  \item{x0}{
    vector of \code{x} coordinates to locate relative to the vector
    \eqn{(x_2-x_1, y_2-y_1)}.
  }
  \item{y0}{
    vector of \code{x} coordinates to locate relative to the vector
    \eqn{(x_2-x_1, y_2-y_1)}.
  }
  \item{eps}{
    tolerance for checking if \eqn{x_0,y_0} is on or left of \eqn{(x_2-x_1,
      y_2-y_1)}, defaults to \eqn{10^{-16}}.
  }
}
\value{
  logical vector with the results of the test.
}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}

\seealso{
  \code{\link{in.convex.hull}},   \code{\link{on.convex.hull}}.
}
\examples{
y <- x <- c(0,1)
## should be TRUE
on(x[1],y[1],x[2],y[2],0.5,0.5)
## note the default setting of eps leading to
on(x[1],y[1],x[2],y[2],0.5,0.50000000000000001)
## also be TRUE

## should be TRUE
left(x[1],y[1],x[2],y[2],0.5,0.6)
## note the default setting of eps leading to
left(x[1],y[1],x[2],y[2],0.5,0.50000000000000001)
## already resulting to FALSE

}
\keyword{ utilities }

\name{arcs}
\alias{arcs}
\title{
  Extract a list of arcs from a triangulation object.
}
\description{
  This function extracts a list of arcs from a triangulation object
  created by \code{tri.mesh}.
}
\usage{
arcs(tri.obj)
}
\arguments{
  \item{tri.obj}{
    object of class \code{\link{triSht}}
  }
}
\details{
  This function acesses the \code{arcs} component of a triangulation
  object returned by \code{\link{tri.mesh}} and extracts the arcs
  contained in this triangulation. This is e.g. used for plotting.
}
\value{
  A matrix with two columns \code{"from"} and \code{"to"} containing the
  indices of points connected by the arc with the corresponding row index.

}
\author{
  Albrecht Gebhardt <albrecht.gebhardt@aau.at>,
  Roger Bivand <roger.bivand@nhh.no>
}
\seealso{
  \code{\link{triSht}}, \code{\link{triangles}}, \code{\link{area}}
}
\examples{
data(franke)
tr <- tri.mesh(franke$ds3)
arcs(tr)
}
\keyword{ spatial }
\keyword{ dplot }

\name{bicubic.grid}
\alias{bicubic.grid}
\title{
  Bicubic Interpolation for Data on a Rectangular grid
}
\description{
This is a placeholder function for backward compatibility with packaga akima.

In its current state it simply calls the reimplemented Akima algorithm for
irregular grids applied to the regular gridded data given.

Later a reimplementation of the original algorithm for regular grids may follow.
}
\usage{
bicubic.grid(x,y,z,xlim=c(min(x),max(x)),ylim=c(min(y),max(y)),
             nx=40,ny=40,dx=NULL,dy=NULL)
}

\arguments{
  \item{x}{
    a vector containing the \code{x} coordinates of the rectangular data grid.
  }
  \item{y}{
    a vector containing the \code{y} coordinates of the rectangular data grid.
  }
  \item{z}{
    a matrix containing the \code{z[i,j]} data values for the grid points (\code{x[i]},\code{y[j]}).
  }
  \item{xlim}{
    vector of length 2 giving lower and upper limit for range \code{x}
    coordinates used for  output grid.
  }
  \item{ylim}{
    vector of length 2 giving lower and upper limit for range of \code{y}
    coordinates used for  output grid.
  }
  \item{nx}{
    output grid dimension in \code{x} direction.
    }
  \item{ny}{
    output grid dimension in \code{y} direction.
    }
  \item{dx}{
    output grid spacing in \code{x} direction, not used by default,
  overrides \code{nx} if specified.
    }
  \item{dy}{
    output grid spacing in \code{y} direction, not used by default,
    overrides \code{ny} if specified..
    }
}
\details{
  This function is a call wrapper for backward compatibility with package akima.

  Currently it applies Akimas irregular grid splines to regular grids, later 
  a FOSS reimplementation of his regular grid splines may replace this wrapper.
}
\value{
  This function produces a grid of interpolated points, feasible to be
  used directly with \code{\link{image}} and \code{\link{contour}}:
  \item{x}{vector of \code{x} coordinates of the output grid.}
  \item{y}{vector of \code{y} coordinates of the output grid.}
  \item{z}{matrix of interpolated data for the output grid.}
}
\references{
  Akima, H. (1996) Rectangular-Grid-Data
  Surface Fitting that Has the Accuracy of a
  Bicubic Polynomial,
  J. ACM \bold{22}(3), 357-361
}
\note{
  Use \code{\link{interp}} for the general case of irregular gridded data!
}


\seealso{
  \code{\link{interp}}, \code{\link{bicubic}}
  % maybe later:
  % \code{\link[rgeostat]{bilinear}}
}
\examples{
data(akima474)
# interpolate at a grid [0,8]x[0,10]
akima.bic <- bicubic.grid(akima474$x,akima474$y,akima474$z)
zmin <- min(akima.bic$z, na.rm=TRUE)
zmax <- max(akima.bic$z, na.rm=TRUE)
breaks <- pretty(c(zmin,zmax),10)
colors <- heat.colors(length(breaks)-1)
image(akima.bic, breaks=breaks, col=colors)
contour(akima.bic, levels=breaks,  add=TRUE)
}
\keyword{ dplot }
